This is a Lynx -dump of the Kermit Project web page:
http://kermitproject.org/ckupdates.html

   [1]Icon [2]The Kermit Project   |   Now hosted by [3]Panix.com
   New York City USA   •   [4]kermit@kermitproject.org
   ...since 1981

     * [5]Home
     * [6]C-Kermit
     * [7]E-Kermit
     * [8]W-Kermit
     * [9]Kermit 95
     * [10]Scripts
     * [11]Current
     * [12]Scripts
     * [13]Timeline
     * [14]About
     * [15]Archive

   Áëıøù

C-KERMIT UPDATE HISTORY

      Versions 9.0–10.0: 2011-2024

     [16]Frank da Cruz
     [17]The Kermit Project, Bronx NY.
     Email: fdc@columbia.edu
     Last update: Mon Mar 24 14:06:30 2025 New York time

   Current Beta-test version:   10.0
   Current released version:    [18]9.0.302   20 August 2011

   Changes since version 8.0.207 of 1 January 2003 -- In reverse
   chronological order (newest first)

   [19] LATEST ACTIVITY     [20] TABLE OF DEVELOPMENT BUILDS

   [21] DOWNLOAD Latest Beta for Unix and VMS     [22] DOWNLOAD latest
   Beta for Windows and OS/2   [23]CLICK HERE to read about it and
   download it for testing if you wish.

   22 March 2025: 12th Beta test of C-Kermit 10.0 for Windows with SSH and
   SSL/TLS support based on [24]LibSSH and [25]OpenSSL.   [26]CLICK HERE
   to read about it and download it for testing if you wish. [27]CLICK
   HERE to read more-or-less daily progress notes.

   11 August 2024: Kermit 95 for Windows and OS/2 (K95):
   Beta.06 for Microsoft Windows and IBM OS/2.

   If you have a hardware/OS platform where hasn't been built yet, please
   try to build it and then [28]send me the data for an entry in the
   [29]C-Kermit 10.0 builds table.  Thanks!
   Builds needed: Any Linux system not already listed in the Beta.09
   [30]Builds Table (currently 9 different Linux distributions out of
   [31]MORE THAN 600), plus older non-Linux Unix OS's like BSDI, Unix V7,
   SVR3, 4.2BSD, 4.3BSD, IRIX, HPUX before 10.0, [32]Plan 9 from Outer
   Space, QNX, SCO, Ultrix, OSF/1, Tru64, AIX, MINIX, NeXT, SINIX, ...,
   and non-Unix OS's like Stratus VOS, AOS/VS, OS-9...

   Also see:
     * [33]C-Kermit 10.0 command reference (new October 2022)
     * [34]Index to all C-Kermit documentation (new July 2019)
     * [35]C-Kermit Program Logic Manual (guidelines for keeping the code
       portable)
     * [36]Change logs for C-Kermit releases 1985-2011  (plain text)
     * [37]Announcements of older C-Kermit releases  (plain text)

   This Web page, which would be about 245 pages long if printed, was
   originally a plain-text change log in chronological order (newest
   entries at the bottom). In May 2017 it was converted to HTML with a
   [38]text-to-html Kermit script, and as of 27 July 2020 it has been
   rearranged so the latest information is at the top and the oldest at
   the bottom, and the formatting was improved by makeshift scripts and by
   hand. Since July 2020, this page is the only for C-Kermit since the 9.0
   release.

   Instructions for downloading and building C-Kermit 10.0 Beta tests →
   [39]UNIX    [40]VMS    [41]Windows

C-Kermit 10.0 Beta.12

          22 March 2025

   C-Kermit 10.0 for Unix and VMS [42]Beta 12. Mostly "political
          correctness" adjustments, i.e. perfectly legal C language
          constructions that now cause warnings, especially from Clang,
          have been recast in modern form acceptable to Clang.
          08-11 August 2024

   August 11: [43]C-Kermit for Windows Beta.06 built upon C-Kermit 10
          Beta.11) released for testing. August 08:C-Kermit for UNIX and
          VMS Beta.11 packaged and released as an official Beta test. The
          changes are listed in the following sections.

          Known bugs:

    1. On certain OS's (so far only HP-UX) C-Kermit has the wrong idea of
       the maximum length for a filename (in this case 14 instead of 256).
    2. PIPE command is broken.

   Coming soon:
    1. ckvbuildlog.com for (Open)VMS (for submitting build reports)

   About OpenSSL support...
   David Hittner says (Aug 15):

   Wow, I just took a hour or so look at the SSL Help Needed issue.

   It looks like the CKermit SSL is pretty much hard-coded to the legacy
   DES protocol, using OpenSSL low-level API calls and nonstandard
   platform routines where OpenSSL is not available.
   (ed.: Yes, it dates from C-Kermit 6.0 of 2011)

   OpenSSL appears to be deprecating all the low-level APIs in favor of
   the high-level APIs. This will cause a fairly major rework to the code
   base to use the higher level APIs, but still allow the DES protocol (in
   the high-level Legacy package) and still use the nonstandard platform
   routines and the low-level API routines of the older OpenSSL packages.
   Dang!

   OpenSSL has a couple of macros to suppress the deprecated routines and
   set the SSL compliance version number.

   [44]https://docs.openssl.org/3.0/man7/openssl_user_macros/

   OpenSSL also has a section on Migration from the low-level APIs to the
   high-level APIs, but it’s not super helpful other than describe some of
   the issues that you’ll run across.

   [45]https://docs.openssl.org/3.0/man7/migration_guide/

   I may take a swing at this if I get some free time. Fortunately, they
   haven’t removed the deprecated routines yet.

   It may be easier to #ifdef two separate code sections, the high-level
   API version and low-level API version, get them running right, and then
   try to merge them if possible.

C-Kermit 10.0 Beta.11 release candidate

          April and June 2024

   More fixes Steven M. Schweda, documented [46]HERE, some of them
          specific to VMS (a.k.a. OpenVMS), others affecting all
          platforms. Mainly compliance issues, not functional ones.
          24-26 March 2024

   Various long-standing (but minor) problems solved by Steven M. Schweda,
          listed [47]HERE. All warnings in the HP-UX builds have been
          eliminated. But on the downside, it has been verified that
          [48]OpenSSL builds fail with Clang 16; C-Kermit's OpenSSL
          support needs to be modernized by a competent OpenSSL
          programmer.
          21 March 2024

   A few weeks ago Krzyszstof Mitco reported that building the 6 February
          pre-Beta-11 upload on a Macintosh with Clang 15 got a ton of
          Wdeprecated-non-prototype warnings in ckwart.c: "function
          definition without a prototype is deprecated". But all (or at
          least most) of those functions *did* have prototypes. Long story
          short, the problem was not the prototypes, but the function
          declarations themselves, 26 of them in ckwart.c and one in
          ckcpro.w. These all needed to be converted to the #ifdef
          CK_ANSIC .. #else .. #endif format used for declaring functions
          in the other modules. It might have been helpful if Clang had
          issued a less misleading warning message, like maybe "ANSI
          protototype for Non-ANSI function declaration". Especially since
          older Clang versions and (as far as I know) all gcc versions
          give no warnings at all. The updated code is in the Pretest
          builds area (on top):

[49]https://kermitproject.org/ftp/kermit/pretest/

          6 February 2024

   Minor changes to REMOTE STATUS code in new ckcfns.c routine nxthlp() to
          squelch some warnings in OpenBSD, and rearrangement of some
          statements that were out of order in a way that was noticed only
          by HP-UX.
          5 February 2024

   C-Kermit 10.0 Beta 10 and pre-Beta 11 appear to be quite solid; there
          have been 10,391 downloads of the tarballs since 3 July 2023
          without a single bug report. Now, after a long hiatus, a Beta 11
          candidate upload dated 2024-02-05 is available in the usual
          place:

     [50]/ftp/kermit/pretest/index.html

          Changes since last time:

          + Prototypes for system functions malloc(), getenv(),
            locate_srv_dns(), etc, were removed from Kermit header files,
            which caused build failure in Ubuntu Linux. Anyway there was
            no reason for them to be there since the prototypes should be
            picked up from the system header files.
          + For conformity with [51]DECSYSTEM-20 Kermit, recently revived
            by Tom DeBellis, the C-Kermit server now responds to two new
            REMOTE commands from the client: REMOTE CDUP (tells the server
            to change directory one level up) and REMOTE STATUS (asks
            server for a status report). The status report looks like
            this:

SERVER: C-Kermit 10.0 pre-Beta.11, 03 Feb 2024, NetBSD 10.0_RC3
OPEN SOURCE
C-Kermit full version number: 10.0.408
Hostname: panix1.panix.com (166.84.1.1)
Server hardware: amd64 (64 bits)
Server operating system family: UNIX
Current directory on server: /net/u/1/f/fdc/beta11/
Last file sent by server:
 /net/u/1/f/fdc/beta11/ascii.html 8440 20240202 20:23:34
Last file received by server:
 /net/u/1/f/fdc/beta11/utf8.txt 343 20240204 08:26:43
Filename length limit: 511
Pathname length limit: 1024

          + Wart lives again!  Each of these required changes to the
            protocol, so I had to reinstate the ckcpro.w and ckwart.c
            modules to the source package and put targets for them back in
            the makefile because it turned out to be next to impossible to
            edit ckcpro.c directly.

          Files affected in this edit: makefile, ckcker.h, ckcpro.w,
          ckwart.c, ckcmai.c, ckcfns.c, ckuusr.c, ckuus2.c, ckuus4.c,
          ckuus7.c. Tested so far only on Unix; should work on VMS and
          Windows but not tested there yet.

          Also a new "generic server commands" sections was added to the
          [52]Kermit file-transfer packet reference page, that includes
          the two new commands.

          OpenSSL help needed

   C-Kermit 10.0 has gone through a long testing phase with many Alphas
          and Betas. It's nearly ready for promotion to Release Candidate
          except for one thing: when built with OpenSSL 3 it gets warnings
          about deprecated functions. I know nothing about OpenSSL and
          neither does anybody else working on this release, but these
          warnings need to be fixed because in a year or two they will
          turn into fatal errors. And of course they should be fixed in a
          way that still works on platforms that have older OpenSSL
          versions installed. The "deprecated" functions are:

DECLARE_PEM_rw_attr()
DH_free()
DH_new()
DH_set0_pqg
RSA_free()
RSA_generate_key_ex()
RSA_new()
SSL_CTX_set_tmp_dh_callback
des_ecb3_encrypt()
des_ecb_encrypt()
des_fixup_key_parity()
des_key_sched()
des_key_sched()
des_new_random_key()
des_random_key()
des_random_seed()
des_set_odd_parity()
des_set_odd_parity()
des_set_random_generator_seed()
fb64_session()
fb64_start()

          and the complaints come from ck_crp.c and ck_ssl.c.
          24 September 2023

   A new preBeta.11 upload dated 2023-09-24 in the usual place:

     [53]/ftp/kermit/pretest/index.html

          The SunOS 4.1.1 version didn't agree with [54]ckbuildlog. Long
          story short, in SunOS C-Kermit didn't allocate large-enough text
          buffers for ckubuildlog; this is fixed and Solaris should be OK
          too but I have no way to test it there myself. Also a bit of
          finagling was needed to find out what the SunOS compiler was,
          since "cc -v" doesn't exist there, so now ckubuildlog fills it
          in.
          20 September 2023

   Fixes from Piotr Kolasiński for some confusion yesterday (mine) +
          [55]new builds by Piotr for macOS (now warning-free) and OpenBSD
          7.3, plus one by me for SunOS 4.1.1 running on a real Sun3,
          compiled with a non-ANSII compiler (Sun cc 1.22). New tarball
          dated 2023-09-20 uploaded to the [56]C-Kermit 10.0 PreBeta
          archive.
          19 September 2023

   From Peter Eichhorn in Germany:

          + A fix for preprocessor directive (#ifdef, #endif, etc) that
            did not start on the left margin in ck_ssl.c and ckcnet.c
            (this is fatal in HP-UX 10 with the bundled compiler and also
            with other old C compilers).

          From Piotr Kolasiński in Poland:

          + For mac OS: -Wdeprecated-non-prototype warnings for ftime()
            and utimes() have been eliminated.
          + A C-Kermit bug regarding "copy /append" has been fixed. The
            bug prevented the ckubuildlog script from working right on the
            Mac.

          A new tarball dated 2023-09-19 has been uploaded to the
          [57]C-Kermit 10.0 Beta Prestest builds archive.
          17 September 2023

   When doing an SSL build with Clang on Ubuntu, the following warning
          appeared: "ckuus7.c:14572:1: a function definition without a
          prototype is deprecated in all versions of C and is not
          supported in C2x [-Wdeprecated-non-prototype] sho_auth(cx) int
          cx; {". Turns out sho_auth() did have a prototype but did not
          have the required dual ANSI/pre-ANSI declaration. Fixed in
          ckuus7.c (not uploaded yet).
          16 September 2023

   C-Kermit 10.0's Beta.11 development cycle begins with 388 code
          adjustments by David Goodwin (C-Kermit for Windows) in 25
          modules to eliminate compiler warnings when building the Windows
          version with the OpenWatcom 1.9 compiler. The warnings
          (including one error), number of occurrences, and brief
          description of each were:

  1. W202:     283   Symbol defined but not referenced
  2. W131:      79   No prototype found for function
  3. W118:       9   Label defined but not referenced
  4. I2002:      3   Note! (functionname) defined in (path)
  5. I2004:      3   Note! target conversion type is 'unsigned long *'
  6. I2003:      3   Note! target conversion type is 'long *'
  7. E1181:      3   Parameter 3 sign specifier mismatch
  8. W201:       2   Unreachable code
  9. W300:       1   Nested comment found

          Here are the affected modules with the number of changes in
          each:

  1. ckcnet.c:  47
  2. ckuus6.c:  36
  3. ckuus3.c:  34
  4. ckuus7.c:  33
  5. ckuusr.c:  30
  6. ckcftp.c:  28
  7. ckuus4.c:  28
  8. ckctel.c:  23
  9. ckuus5.c:  22
 10. ckucmd.c:  21
 11. ckuath.c:  16
 12. ckuusx.c:  13
 13. ckudia.c:  11
 14. ckuusy.c:   8
 15. ckcmai.c:   8
 16. ckcsig.h:   5
 17. ckcfns.c:   5
 18. ckuscr.c:   5
 19. ckcpro.c:   4
 20. ckuus2.c:   3
 21. ckclib.c:   3
 22. ckcdeb.h:   2
 23. ckcfn3.c:   1
 24. ckcfn2.c:   1
 25. ckcxxx.h:   1

          These were merged with some minor changes by me in ckcmai.c,
          ckcfns.c, and ckfn2.c. The result can be downloaded from the
          usual place:

     [58]/ftp/kermit/pretest/index.html

          David and I have already built it successfully on about 30
          different platforms
          10 September 2023

   Since the July announcement of C-Kermit 10.0 Beta.10, I have had just
          about zero feedback and an equal number of [59]build reports
          except the 25 Windows and OS/2 builds by David Goodwin, the VMS
          ones from SMS, and one macOS, plus the 90 I did myself on
          various Linuxes I have access to. I still have a list of runtime
          bugs to try to fix, but the top priority is to make sure that
          Beta.10 still builds on all the platforms where the earlier
          Betas built, because of the massive code changes in Beta.10
          required by Clang. So please, send in build results for Mac OS /
          macOS, Raspberry Pi, Android, MINIX... SunOS, Solaris, SCO, AIX,
          IRIX, and whatever else you might have access to, that's not
          already on Beta.10 build list. And remember, on UNIX-based OS's,
          you should now be able to generate build reports automatically
          at the end of your compilation, as explained [60]here.
          Thanks! --Frank
          4 July 2023

   [61]24 Windows builds (plus one OS/2) added to the [62]builds table.
          The [63]C-Kermit for Windows page totally overhauled for CKW
          Beta 5.

C-Kermit 10.0 Beta.10, 3 July 2023     [64] DOWNLOAD

          3 July 2023

   A last-minute correction to "make freebsd" in the makefile, and off we
          go!

          C-Kermit 10.0 Beta.10 is mainly focussed on "Buzzword 2.0
          compliance", not new features or even very many bug fixes. Each
          change is noted below, down to the [65]Beta.09 section. It also
          comes with a new utility, [66]ckubuildlog, a script that (when
          you invoke it) automatically creates a [67]a builds table entry,
          so when you build C-Kermit it's easy to to report the results.

          2 July 2023

   From David Goodwin: Fixed date in top line of ckctel.c (2003→2023), and
          in ckuus5.c for Windows and OS/2 only: #include "ckoath.h" for
          ck_crypt_ll_version() prototype to prevent crash on 64-bit
          Windows.

          Also from David: ckcnet.c... for some reason the Windows NT 3.50
          SDK #defines 'try' as '__try'.

          VMS issue with Unicode unresolved: If I understand correctly
          OpenVMS 7.2 and later have some kind of support for Unicode on
          ODS-5 volumes, but only in its UCS-2 form, not UTF-8. I thought
          I would check this by sending a UTF-8 file from Linux to OpenVMS
          8.4-2L3 with "set transfer character-set ucs2". I was surprised
          to see it was sent with utf8 as the transfer character set and
          thought this was a C-Kermit bug, but it's not. A comment at
          about line 7419 in ckuxla.c (function setxlatype()) says "If any
          of our charsets is Unicode we use Unicode functions even if TCS
          and FCS are the same because of BOM and byte swapping" (because
          UCS-2 files can have different markers and byte order depending
          on the platform), so when the source file is UTF-8, the transfer
          encoding is forced to UTF-8 also, no matter what transfer
          character-set has been set. Anyway, I don't even know if or how
          Unicode is supported on VMS. If I try to type the UTF-8 file on
          VMS, the non-ASCII characters are gibberish. If I convert it to
          UCS-2, the result is a different gibberish. But maybe that was
          because the disk was not an ODS-5 volume. If anybody cares
          and/or knows anything about this issue, feel free to contact me
          ([68]email address at top).

          1 July 2023

   'make xxx -DV7MIN' or 'make linuxmin' warned about "implicit
          declaration of function 'urlparse'; fixed by adding the
          appropriate #ifdefs to ckcfnp.h and ckcdeb.h.

          Minor changes from David Goodwin to ckcmai.c and ckcdeb.h for
          the forthcoming [69]Beta.05 test release of [70]C-Kermit for
          Windows.

          28 June 2023

   "make freebsd" makefile entry changed to eliminate the "<sys/timeb.h>
          deprecated" warning by adding KFLAG -DNOSYSTIMEBH in the cases
          where (a) <sys/timeb.h> does not exist, and (b) it exists but
          contains the word "deprecated".
          27 June 2023

   I fixed ckcfnp.h to not sprew out warnings about the prototype for
          locate_srv_dns() when building a no-TCP/IP or
          no-networking-at-all C-Kermit version. Plus... ckubuildlog to
          work (in case a VMS version of ckubuildlog is ever written):

                ckcdeb.h

        Added new C macros, GETEXEDIR and HAVE_VN_EXEDIR, defined on
                systems where the getexedir() function is used, and the
                builtin variable "exedir" exists, respectively. (I chose
                functional names rather than things like OS2ORUNIXORVMS.)
                ckcmai.c

        Changed to call getexedir() on VMS as well as UNIX (according to
                GETEXEDIR).
                ckuus4.c

        Changed to enable builtin variable "exedir" according to
                HAVE_VN_EXEDIR instead of OS2ORUNIX.
                ckvfio.c

        Added getexedir() for VMS.
                Changed to use revised NAM[L] macros from ckvrms.h.
                ckvrms.h

        Minor update to NAM[L] macros for simpler code and better
                consistency with non-Kermit code.

          25 June 2023

   [71]ckubuildlog updated to work with HP-UX and to make greater efforts
          to find the compiler and version that was used to build the
          C-Kermit binary it's looking at. Thanks to Peter Eichhorn for
          working this out.
          24 June 2023

   From [72]David Goodwin (who is in charge of the [73]Windows and OS/2
          versions of C-Kermit 10.0), in preparation for a (hopefully)
          joint release of C-Kermit 10.0 Beta.10 for Unix, VMS, and
          Windows (and maybe OS/2). The changes are:

        ck_des.c:
                Support statically linking des/cast rather than putting it
                in k95crypt.dll
                ckcdeb.h:

        Add WIN32ORUNIX define. On OS/2 or Windows, if CK_KERBEROS and
                NO_KERBEROS are undefined on the command line then enable
                all KRB stuff - this allows the windows build scripts to
                turn on kerberos features selectively based on the headers
                that could be found.
                ckcfnp.h:

        Don't define a prototype "int hash(char*)" on OS2 and Windows as
                it conflicts with SRP support
                ckcmai.c:

        Bump windows beta number to match unix
                ckuat2.h:

        Fix for building crypt dll when kerberos is enabled
                ckuus2.c:

        Built-in SSH only provides SSH v2
                ckuus5.c:

        Add Pathworks and SuperLAT to show features output as these
                features are not present in all builds (SuperLAT was
                presumably only available on x86, Pathworks was only on
                x86 and Alpha) Also add PTY support to the list of missing
                features when its not present

          23 June 2023

          + When you download a C-Kermit 10.0 source code package (zip or
            tar) dated 23 June 2023 or later, it now includes the
            [74]ckubuildlog script so it will be super-easy to get the
            build data and submit it for the [75]C-Kermit 10.0 build log.
            Instructions: after unpacking the source-code tarball or zip
            file (target is the makefile target name, e.g. linux, freebsd,
            macos+ssl, etc):
              1. make target 2>log
              2. ./ckubuildlog
              3. send me the resulting target.txt file
              4. Done!
            Let's hope there will also be a ckvbuildlog.com some day for
            VMS!
          + Thanks to help from "Zero King" (Lin Dongyu), Jake Thompson,
            Jeff Altman, and Steven M. Schweda, every last one of the
            Clang 15 -Wdeprecated-non-prototype warnings has been
            eliminated, so C-Kermit is saved from extinction. The only
            remaining Clang warning is "*s++; -Wunused-value", which I
            [76]refuse to "fix".
          + From Tony Nicholson: Fixed building C-Kermit 10.0 Beta.09 on
            Alpha with SSL3 (and the VSI OpenVMS patch kit for SSL3 on
            Alpha) due to an issue with Multinet TCP/IP headers and the
            select() function: ckcmai.c, ckcnet.c.
          + ckuus4.c:14296, sprintf(vvbuf,"%d",crc16); changed to "%ld".
          + COPYING.TXT and README.TXT were omitted from Beta.09 archives,
            restored as of this edit.
          + From Jeff Johnson: "Over in ckuus5.c around line 12445,
            mestring is using startup, which won't work after the
            executable is installed; "\\v(exedir)\\v(name), size:
            \\fsize(\\v(exedir)\\v(name))"; - (that is, using exedir
            instead of startup) seems like what was intended." (correct,
            fixed now). Also in ckcmai.c, the "Portions Copyright" ...
            that text should be separated from the preceding license text
            by a newline (done).
          + Also from Jeff Johnson (Beta.09):

     A quick bug to report, affecting IKSD, where restricting connections
     via negotiations is not actually working.

     To replicate, on the IKSD server side, you do both "SET TELOPT
     COM-PORT-CONTROL REQUIRED" and "SET TELOPT START-TLS REQUIRED"
     together.
     You'll see that an incoming connection without supporting those will
     not actually be disconnected - the connection continues on after the
     "terminating connection" message, where it should have stopped after
     the "Start-TLS refused" message.
    $ telnet 127.0.0.1 1649
    Trying 127.0.0.1...
    Connected to 127.0.0.1.
    Escape character is '^]'.

    Telnet Start-TLS refused.

    Internet Kermit Service ready at Mon May 15 06:25:55 2023
    C-Kermit 10.0 Beta.09, 09 May 2023
    localhost

     Peer refuses TELNET DO COM-PORT-CONTROL negotiations - terminating
     connection Username: But the connection isn't terminated, and the
     login can continue, which isn't right. Tested on C-Kermit 10.0
     Beta.09.
     The "Start-TLS refused" message is issued in tn_xdoopt(),
     ckctel.c(). case TELOPT_START_TLS: (two occurrences) in both cases,
     it closes the connection and returns -3 (= "connection closed by
     us") to its caller, which is tn_doop().
            Jeff's patch was applied.
          + And another from Jeff J:

     In short, if you have, in iksd.conf a long valid line and then a
     shorter invalid line, the syntax error message conflates them,
     example:

     Here is the configuration: SET AUTHENTICATION TLS RSA-KEY-FILE
     /etc/iks/key.pem DEBUG LOG /tmp/iksd.log

     And the buggy output:
     ?Not a command or macro name: "DEBUG"
     ?iksd.conf[7]: "DEBUG LOG /tmp/iksd.log SA-KEY-FILE /etc/iks/k...":
     Syntax error

     This was introduced by the addition of 9case to ckuus5.c around line
     3408 in the sources. I'm also not exactly sure what the best fix
     would be here, but the simpliest solution I can think is just to
     ensure the whole buffer is NUL'd - I did this by adding the memset
     call at line 2550:
          + With peter eichhorn, fixed the "types incompatible in
            conditional expression" warning in ckuus3.c:4071, in a way
            that works in all hp-ux versions from 6.5 to 11.
          + Noted in passing... -DNOANSII builds no longer work on any
            modern platform. It used to be possible to #ifdef‑away all
            ANSI/POSIX features to simulate a pre-ANSI build on a newer
            platform, but newer compilers don't tolerate old C. I think it
            would be better to "be conservative in what you send ("demand"
            in this case), be liberal in what you accept from others"
            ([77]Robustness principal, [78]Jon Postel, "god of the
            Internet").

          If anybody sent me any other corrections that are not addressed
          above, please let me knw.
          13-14 May 2023

   Corrected some problems in Minix builds reported by Liam Stitt:

          + In ckocon.c (the old pre-Internet CONNECT command module), the
            chkaes() function has only one argument, but the prototype
            specifies two because the copy of the same routine in the new
            CONNECT module, ckucns.c, had a second argument added at some
            point so C-Kermit, when in CONNECT mode, could handle certain
            ANSI escape sequences.
          + #include "ckuusr.h" was added to ckcfnp.h for Minix builds so
            the struct mtab[] typedef would be picked up.

C-Kermit 10.0 Beta.09, 9 May 2023

   C-Kermit 10.0 Beta.09 was released 9 May 2023; the changes since
   Beta.08 are listed below. The majority of the work was not adding new
   features or even fixing bugs; it was "complying" with changes in the C
   language and its Unix programming environment, in particular making
   sure that all functions are declared in both ANSI format and K&R format
   (so C-Kermit can built on both new and old computers), and that every
   function has a prototype; this is an edict from the Clang people. The
   changes were massive but the only result is that C-Kermit should
   continue to compile successfully with forthcoming Clang releases on
   Clang-dominated platforms like macOS, FreeBSD, and OpenBSD even after
   the [79]"C2x" cutover, and yet remain buildable on all the platforms
   where where it compiled and ran before: [80]most or all Unixes
   (including decades-old ones like SunOS 4 and HP-UX 10.20), plus VMS
   back to at least version 5.4, and all releases of Microsoft Windows and
   NT and hopefully also IBM OS/2.

   Special thanks to (alphabetically) Nelson Beebe, Peter Eichhorn, David
   Goodwin, and Steven M Schweda for their contributions in recent weeks.

   One problem still must be resolved before C-Kermit 10.0 can be
   released:
     * Clang 15 and possibly later versions issue the following warning
       for [81]function calls made via function pointers:
       warning: passing arguments to a function without a prototype is
       deprecated in all versions of C and is not supported in C2x
       [-Wdeprecated-non-prototype]
       so if this problem can't be fixed before C2x-ageddon, then C-Kermit
       won't be buildable by Clang. But the warning is bogus: how could
       Clang expect to find a prototype for a function whose name won't be
       known until runtime? Anyway, as of Beta.09 Clang *knows* that all
       C-Kermit's functions have prototypes, so there's no reason to make
       a fuss. Meanwhile it is apparently possible to squelch these
       warnings by accident somehow because "make linux+ssl" doesn't get
       them. I haven't yet been able to figure out why.

   Various other warnings that are not potentially lethal should be looked
   at, for example:
     * Clang also complains about perfectly legal compound IF statements
       and/or complex IF conditions, and wants to have parens and/or
       brackets galore added for clarity. These statements were written by
       programmers who understood the rules of precedence of arithmetic
       and logical operators, and the code has been working correctly for
       decades. Editing hundreds of lines of complicated code to please
       bureaucrats is very likely to do more harm than good. The classic
       rule of software development and maintenance applies: "Don't fix
       what ain't broke"... To that should be added "Don't deliberately
       break things!")
     * Some OpenSSL 3 builds get six "implicit declaration" warnings;
       others get 25 "deprecated declarations". The SSL code needs work by
       someone who knows SSL APIs. Worse, builds with OpenSSL 3.02 and
       later can fail because they depend on some other package
       (libpam06-dev) that might not be installed.
     * Platform-specific warnings or failures need to be fixed by people
       who have those platforms, without breaking compilation on any other
       platform. I'm not inclined to make fixes that I can't test myself.

          6 May 2023

   A -DNOSPL ("no script programming language") build failed with implicit
          declarations of functions and undeclared variables. Turns out
          some of the code I added a few months ago to the TYPE and GREP
          commands that used script-language features like arrays was not
          guarded by #ifndef NOSPL..#endif. Fixed in ckuus3.c and
          ckuus6.c.

          The C-Kermit macro name lookup functions mlook(), mxlook(), and
          mxxlook() all have a parameter of type sruct mtab[], which
          doesn't exist if NOSPL is defined; fixed by putting #ifdefs
          around their prototypes in ckcfnp.h.

          Also in the same builds: "implicit declaration of function
          'initproto'" in ckuus3.c. Of course initproto() *is* prototyped
          in ckcfnp.h and ckcfnp.h *has* been included by ckuus3.c. The
          reason for the complaint eludes me but I fixed it by putting an
          "extern VOID initproto(...)" in ckuus3.c:setproto().

          For HP-UX 10 I added an explicit cast to this statement in
          ckuus3.c:
          if ((CKFLOAT)result != fpresult) fpflag++;
          I don't know why the complaint ("Types incompatible in
          conditional expression") comes only now after all these years. I
          have no way to test it; will find out tomorrow morning from
          Mr.HPUX in Germany, which is 7 hours later than the Bronx (the
          problem was resolved after the Beta.09 release, see notes above
          for May 13-14).

          Finally (for today)... Unlike previous Beta09 previews, today's
          version once again supports customized builds with certain
          features deselected. See the "[82]newbuilds table". Also it now
          identifies itself as Beta.09RC (Release Candidate for Beta.09).

          Today's code as of 19:49 Bronx time is in the [83]USUAL PLACE.

          5 May 2023

   ckuusx.c line 6195, fixed a semicolon-comma mixup in move() declaration
          (noticed by SMS while compiling on an old VAX with VMS 5.2).
          Ditto for ck_curpos at ckuusx.c:6386.

          From David Goodwin (for the Windows version):

          + Move MAINTYPE/MAINNAME futher down in ckcdeb.h to where
            OS2ORWINDOWS is defined.
          + ckcuni.h: don't define a prototype for ck_isunicode() on NT.
          + ckuus7.c: fix semicolon-comma mixup in declaration of
            owwait().

          To squelch warnings about non-declaration of wait() in OpenBSD,
          I added a test for the existence of <sys/wait.h> to the openbsd:
          and freebsd: makefile targets, with accompanying code around
          #include <sys/wait.h> in ckufio.c.

          Finally, I built today's code successfully on a Sun 3 with SunOS
          4.1 from 1990 -- that's 33 years ago. No changes were needed and
          there were just a few harmless warnings. A fully functional
          executable was produced:

$ uname -a
SunOS three 4.1.1 1 sun3
$ ./wermit
C-Kermit 10.0 Pre-Beta.09, 05 May 2023, for SunOS 4.1
 Copyright (C) 1985, 2023,
  Trustees of Columbia University in the City of New York.
  Open Source 3-clause BSD license since 2011.
Type ? or HELP for help.
(~/kermit/) C-Kermit>quit
$

          Today's sources as of 21:04 New York time can be downloaded
          [84]HERE. This should be regarded as Beta.09 release candidate
          so please give it a spin, or even a workout, and let me know of
          any problems. As you can see [85]HERE, it's been built on a wide
          variety of platforms both old and new, but reports are needed
          for many more.
          4 May 2023

   From SMS:

          + ckuath.c binaryEqual() args a and b needed to be const for
            macOS.
          + Fixed a typo in a comment in ckvker.com.

          I fixed a typo in ckcmai.c:2019: "ikslogin" in the ikslogin()
          non-ANSI declaration was misspelled as iksolgin, which broke
          pre-ANSIC builds (thanks to Peter Eichhorn for catching this).

          I fixed the "make linux+ssl" and "linux+krb5" makefile targets
          to honor CC= and/or CC2= selectors on the make command line
          (previously they were hardwired for gcc).

          And I removed the superfluous "extern char * pncvt();" at line
          11053 of ckuus4.c in fneval(), case FN_PNCVT, that conflicted
          with the new prototype in ckcfnp.h. There are a also lot of
          other extern declarations for functions that also now have
          prototypes but that don't generate Clang warnings, so DFWAB.

          1-3 May 2023

   Reworked the "main() mess" in ckcmai.c, in which a pile of #ifdefs
          accounted for platforms where main() might return a different
          data type, or even have a different name, e.g. "Main()" in
          Windows. The declaration (which previously was SIXTY lines long)
          is now simply:

MAINTYPE
#ifdef CK_ANSIC
MAINNAME( int argc, char ** argv )
#else
MAINNAME( argc, argv ) int argc; char **argv;
#endif /* CK_ANSIC */
{

          where MAINTYPE and MAINNAME are declared in ckcdeb.h, where they
          can be easily edited in case any new "standards" appear. Thanks
          to SMS for help with this one, who also debugged the VMS builds
          and pointed out a couple duplications in the new prototypes
          header, ckcfnp.h, that caused trouble with some compilers.

          Meanwhile Peter Eichhorn in München has an old HP-UX system
          where he can do K&R (i.e. Pre-ANSI-C) builds and found several
          errors, which have been corrected, mostly in punctuation
          (e.g. comma vs semicolon in prototypes), in ckutio.c, ckuus4.c,
          ckucmd.c, and ckclib.c, plus a typo (by me course) in the
          freebsd makefile entry where HAVE_HAVEWAITH should have been
          HAVE_WAITH.

          These changes are in the "pretest" archive with a
          date/time-stamp of 2023-05-03 19:32:12 or later, [86]CLICK HERE
          to download a tar or zip archive (the latest version is at the
          top, as always).

          29 April 2023

   The 27 April OpenBSD 7.2 build needed a special make command to
          circumvent the disappearance of sys/timeb.h; today's code
          detects its presence or absence automatically, so "make openbsd"
          is sufficient to build it on both older and newer OpenBSD
          systems. Also in OpenBSD, assorted warnings about implicit
          declaration of several curses functions are now cleared and it
          builds with no warnings.

          Also "make freebsd" had 3 "implicit declaration of wait()"
          warnings, now cleared. It still warns that sys/timeb.h is
          deprecated; if anybody cares, see the makefile comments above
          the "freebsd" target.

          The Clang 15 prototype problem with function pointers remains
          and I'm totally baffled (see yeterday's entry). It needs to be
          fixed (hopefully in Clang itself!).

          Tne [87]new builds table has been updated, and today's sources
          (dated 29 April) have been uploaded to the [88]Beta pretest
          builds archive, dated 20230429.

          28 April 2023

   I did 32 successful builds of the 27 April code base on a variety of
          BSD and Linux systems, as shown in [89]THIS TABLE. For each
          platform's default build, e.g. "make linux", compiled with Clang
          15, I still get the 17 -Wdeprecated-non-prototype warnings for
          functions invoked via function pointers. The new development,
          however, is that if I do "make linux+ssl" on the same computer
          with the same compiler, I don't get those warnings! So far I
          can't figure out why, but these need to be fixed before the
          final release, otherwise the code will error out in the
          later-model Clang compilers.
          27 April 2023

   David Goodwin, who is in charge of the [90]MS Windows and IBM OS/2
          versions of C-Kermit 10, merged my sources of 18 April with his
          and made the following changes to my modules. As you can see
          see, he's in the middle of converting C-Kermit for Windows into
          a 64-bit application for platforms that support it ([91]CLICK
          HERE to see David's progress log).

                ck_des.c

        Include ckucmd.h as ckcfnp requires xxstrp
                ck_ssl.c

        Itanium porting: Fixes for ANSI-C compiler (Visual C++ 2010 for
                Itanium isn't C99)

        Feature: Support TLS SNI indication for https and telnets
                ckcdeb.h

        NT 3.1 porting: __int64 isn't available in Visual C++ 1.0 32-bit
                edition

        Windows is only 64bit when _WIN64 is defined (fixes NT on the DEC
                Alpha being picked up as 64bit)

        Win64 porting: Fix missing prototype for zgperm (compiler assumes
                all parameters and return types are 32bit int if there is
                no prototype to say otherwise)

        NT 3.1 porting: GetShortPathName doesn't exist there so we must
                supply our own

        Win64 porting: Define intptr_t as an int for 32bit platforms that
                don't define it in their headers. Similar for DWORD_PTR.

        Win64 porting: CK_TTYFD_T is intptr_t if available, else just an
                int
                ckcfnp.h

        Fix missing semi-colon on NT (KUI)
        shokeycode takes two parameters on OS/2 and NT
                ckcftp.c

        Win64 porting: Fix missing function prototypes to prevent pointer
                truncation
                ckcnet.c

        Win64 porting: ttyfd is now of type CK_TTYFD_T: On windows,
                handles to sockets/files/serial ports/etc are pointer size
                so ttyfd must be an __int64 on 64bit windows.

        Win64 porting: saddrlen is just an int (socklen_t isn't avialable
                on Windows)

        NT 3.1 porting: Comment about a bug so the affected code can be
                easily found in the future

        Win64 porting: Fix missing prototype for GetLocalUser to avoid
                pointer truncation.
                ckcnet.h

        Win64 porting: socklen_t isn't available on windows
                ckcsig.h

        Win64 porting: ttyfd is now of type CK_TTYFD_T
                ckuus3.c

        Win64 porting: Fix missing prototypes to avoid pointer truncation
        NT 3.1 porting: tidy up defines
        Win64 porting: Some parameters on KuiSetProperty have changed to
                intptr_t so they can accept pointers on 64bit windows

        Win64 porting: ttyfd is now of type CK_TTYFD_T
                ckuus4.c

        Win64 porting: Fix missing prototypes to avoid pointer truncation
        Win64 porting: use _atoi64 on 64bit windows (HWND is a 64bit type
                there)

        NT 3.1 porting: Call ckGetShortPathName instead of
                GetShortPathName
                ckuus5.c

        NT 3.1 porting: Call ckGetShortPathName instead of
                GetShortPathName

        Fix "show terminal" not showing the "ask" auto-download option
        Win64 porting: Add _WIN64 to the "show features" command - this is
                defined when building for 64bit windows (x86-64, Itanium,
                ARM64 and the unreleased 64bit Alpha port)

        NT 3.1 porting: Add CKT_NT35 to the "show features" command - this
                flag is Set when targeting NT 3.50 (if both CKT_NT31 and
                CKT_NT35 are defined then runtime checks are used to
                handle API differences)

        Itanium porting: Add "for Itanium CPUs" on Itanium
        ARM porting: Add "for ARM CPUs" on 32bit ARM, and "for 64bit ARM
                CPUs" for 64bit ARM

        Win64 porting: Add "for x86-64/AMD64 CPUs." for 64bit x86 systems
                ckuus7.c

        Win64 porting: KuiSetProperty now takes intptr_t parameters to
                avoid pointer truncation
                ckuusr.c

        NT 3.1 porting: Call ckGetShortPathName instead of
                GetShortPathName
                ckuusx.c

        Win64 porting: KuiSetProperty now takes intptr_t parameters to
                avoid pointer truncation

          Meanwhile I was able to "make linux+ssl" on Ubuntu with Clang 15
          with only the warnings regarding functions invoked via function
          pointers, explained in the previous entry. This required a
          one-line addition to ckcfnp.h. You can download today's
          source-code package [92]HERE.

          18 April 2023

   I spent the past few days addressing Clang's hundreds of
          prototype-related complaints about nonstatic functions
          (I already took care of the static ones a while back):

          ckcfns.c 23
          ckcfn2.c 13
          ckcfn3.c 25
          ckcftp.c 92
          ckcnet.c 16
          ckcpro.c 2
          ckctel.c 6
          ckucmd.c 58
          ckudia.c 15
          ckupty.c 11
          ckuscr.c 1
          ckufio.c 68
          ckutio.c 47
          ckuusr.c 22
          ckuus2.c 8
          ckuus3.c 19
          ckuus4.c 46
          ckuus5.c 50
          ckuus6.c 39
          ckuus7.c 38
          ckuusx.c 26
          ckuusy.c 10
          ckuxla.c 11

          Summary: 646 warnings cleared in 23 modules. This is for
          "make linux" on Ubuntu 20.04.1 with Clang 15. The result also
          still builds with gcc on various Linux and BSD platforms. Still
          to be done: OpenSSL and Kerberos builds and other "custom"
          builds.

          Each clearance involved creating a prototype where none existed
          before AND the function itself to have *both* K&R and ANSI
          definitions governed by #ifdef CK_ANSIC..#else..#endif, because
          C-Kermit does not -- as a matter of principle -- force users to
          "upgrade" their computer, OS, or compiler every time a new
          Kermit version comes out. So C-Kermit 10.0 *should* still be
          buildable on (e.g.) Unix V7, SVR3, 4.2BSD, SCO Xenix, and
          [93]all the others where it has been built in the past. Any
          cases where it isn't should be fixed, that's what these beta
          tests are for.

          Warnings not cleared: ckucmd.c (12), ckcftp.c (5). All of these
          warnings are like this:

ckucmd.c:1460:10: warning: passing arguments to a function without a
prototype is deprecated in all versions of C and is not supported in C2x
[-Wdeprecated-non-prototype]
        if ((*f)(zp,&zq,&atxn) < 0)     /* Convert */
                ^

          Clang is complaining that there is no prototype for the "*f"
          function. Of course there isn't; 'f' is a variable containing
          the name of the function being called at runtime and "*f" is a
          function pointer. The Clang people can't be serious about this.
          If they don't take this warning away before the C2x cutover,
          every C program on the planet that uses function pointers will
          die in Clang shops. If anybody reading this has some insight on
          this issue, please send me email (address at the [94]top of this
          page).

          The code dated 16 April 2023 built successfully on Ubuntu
          20.04.1 with clang 15.0.5 and 10.0.1; FreeBSD 13.1 with clang
          13.0.0; SUSE 15.4 with clang 13.0.1; NetBSD 9.3 with gcc 7.5.0;
          Centos 9 with gcc 11.3.1; Debian 11 with gcc 10.2.1; Fedora 37
          with gcc 12.2.1; and Oracle 9.1 with gcc 11.3.1. In most cases
          there were no warnings except the clang 15 ones noted above. The
          April 16th code base is available in the [95]C-Kermit 10.0 Beta
          Pretest builds archive as of Tue Apr 18 20:15:51 2023 (NY time).

          14 April 2023

   I really do not see what Clang's problem is with the prototype and
          declaration of cl_int(), but as noted previously this warning
          will turn into a fatal error in Clang C2x, so the code had to be
          removed. Its only use was to catch interruption by Ctrl-C while
          executing command-line arguments and before entering the
          interactive command parser. Until a better solution presents
          itself, this can be re-enabled by building with a non-Clang
          compiler and adding KFLAGS=-DUSE_CL_INT to the make command
          line.
          12 April 2023

           Module  Warnings cleared
          ckuusr.c 22
          ckuus2.c 8
          ckuus3.c 19
          ckuus6.c 39
          ckuusx.c 26
          ckuusy.c 10

          124 "-Wdeprecated-non-prototype" warnings cleared in about four
          hours, so maybe it won't take months after all. A problem
          cropped up in ckuusy.c: a -Wdeprecated-non-prototype warning for
          cl_int() in ckuusy.c, even though it has a prototype and an ANSI
          declaration. The return type of this function is SIGTYP, which
          is typedef'd in the header files; I have yet to track this down
          but if not fixed, it will be fatal when [96]Clang C2x comes out.
          Meanwhile, 473 "function without prototype" warnings to go, down
          from the original 692.
          10 April 2023

   Nothing to do with C-Kermit, but over the past week a major new release
          of Kermit-20 for the late lamented [97]DECSYSTEM-20 was rolled
          out. Kermit-20 was the very first Kermit program. The first
          Kermit protocol transfer took place 29 April 1981 between two
          instances of Kermit-20 connected by null-modem cable between two
          DEC-20 serial ports; read about it [98]HERE and read about the
          new release [99]HERE.

          Now that that's done (and some other things), today I purified
          another C-Kermit module, by hand of course: ckucmd.c, squelching
          58 -Wdeprecated-non-prototype warnings from Clang 15 with 597
          remaining. At this rate the job will be done after 321 more
          hours of work, so if I worked 8 hours a day on nothing else (fat
          chance!), that would be forty days.

          Today's work revealed a new problem, the second one below:

          + Clang issues -Wdeprecated-non-prototype warnings for functions
            that don't have prototypes.
          + Clang issues -Wdeprecated-non-prototype warnings for functions
            that have prototypes but that have only a K&R-format
            declaration.

          30 March 2023

   Fixed the straggling function declarations in ckcmai.c and ckclib.c.
          The declaration of main() in ckcmai.c, in particular, is rather
          complicated since its return type varies by OS and version. I
          have no way of testing on non-Unix platforms. Aside from the
          bogus "*s++;" warning in ckclib.c, both modules built clean in
          Clang 15.
          26 March 2023

   I spent the day trying to change all the K&R-format function
          declarations in ckcmai.c and ckclib.c to the [100]format shown
          in yesterday's entry, and making sure they match with the
          prototypes in the new ckcfnp.h header file (and in the process
          added 43 more prototypes to it). There is no way to automate
          this; too much variation in how the original functions were
          declared: comments, #ifdef'd symbols, line breaks, the order in
          which the arguments are listed, etc. An example of the latter
          will illustrate:

int
b8tob64(s,n,out,len) char * s,* out; int n, len; {

          See how the data types are listed in a different order than the
          arguments? Who knew 30-some years ago the trouble this would
          cause?

          After the changes I did the following builds on Ubuntu:

          + Made "linux" with gcc 9.4.0, no warnings or errors.
          + Made "linux-pedantic" with gcc 9.4.0, no warnings or errors.
          + Made "linux-clang" with Clang 10.0, no warnings except the
            bogus one about "*s++;"

          And then with Clang 15:

          Warnings before recent changes:   728
          Total "no prototype" warnings:    692
          Prototype warnings in ckcmai.c:   7
          Prototype warnings in ckclib.c:   31

          Warnings after changes:           698
          Prototype warnings after changes: 662
          Prototype warnings in ckcmai.c:   3
          Prototype warnings in ckclib.c:   7

          Difference:                       30

          So a full day's work on two modules out of a total of 43 for the
          Unix version of C-Kermit resulted in 30 fewer prototype warnings
          out of 682 and I still have to go back and find out about the
          other 10 that weren't squelched. For all 43 modules, this
          process will probably take a month.

          25 March 2023

   It turns out that the Clang warnings in yesterday's item indicated a
          problem after all, but not the one announced; in the majority of
          cases, the complained-about function *did* have an ANSI
          prototype, but its declaration was in K&R format. Thanks to
          Nelson Beebe for identifying the problem.

          So the next step is to convert every single C-Kermit function
          declaration to be like this one:

static char *
#ifdef CK_ANSIC
xxlast(char *s, char c)
#else
xxlast(s,c) char *s; char c;
#endif /* CK_ANSIC */
/* xxlast */ {

          I can't simply change them all to ANSI format because C-Kermit
          still has to build on old platforms and/or pre-ANSI compilers.
          Quite a few functions are already declared this way, but quite
          another few are not. It'll be a big job. How big? According to
          "gdb info functions" the "make linux" version has [101]1472
          functions.

          The irony is, Clang versions up to 14 understood both kinds of
          declarations perfectly -- prototypes or no prototypes -- all the
          needed information is in each kind of function declaration. So
          the Clang people are deliberately breaking [mbtq]illions of
          existing programs.

          24 March 2023

   I added 435 non-static function prototypes for C-Kermit, which should
          have made a significant dent in the 692 "without a prototype"
          warnings issued by Clang 15 before I did this. The prototypes
          are in a new header file, ckcfnp.h, which is #included by all
          ckc*.c, cku*.c, and ckv*.c modules, and eventually also the
          Windows and OS/2 modules if needed there, well over 50 modules
          altogether between the three major OS families. This was a long
          and arduous process, complicated by the fact that many of the
          prototyped functions have typedef'd return types, such that for
          any given module, ckcfnp.h couldn't be #included until the other
          headers that did the typedefs had been digested. The work was
          done initially on NetBSD 9.3 with gcc 7.5.0. Once it seemed to
          be fully operational I moved it to Ubuntu 20.04.1 and gcc 9.40,
          worked out some glitches and then ran it through Clang 10.0.0-4,
          which uncovered a few more glitches that I fixed. In all cases,
          the prototypes were read and used by the compiler, evident from
          the fact that numerous #include statements had to be added or
          repositioned in many modules along the way.

          Then I tried it with Clang 15.0.5 and got 692 "function without
          a prototype" warnings, only 35 fewer than before I did all this
          work. And yes, I was compiling the new modules; anyway it can be
          seen that Clang *did* read the ckcfnp.h file because sometimes
          it would find a conflict and complain as follows (note reference
          to ckcfnp.h):

ckuusr.c:8554:23: warning: a function declaration without a prototype is
deprecated in all versions of C and is treated as a zero-parameter prototype
in C2x, conflicting with a previous declaration [-Wdeprecated-non-prototype]
            char * result, * dosexp();
./ckcfnp.h:41:8: note: conflicting prototype is here
char * dosexp( char * );
       ^

          Today's code is [102]HERE.

          19 March 2023

          + The GREP /ARRAY command didn't work at all because the
            supporting code was never written; now it is written and works
            as expected. dogrep(): ckuus6.c.
          + GREP /NAMEONLY was broken in Beta.08, now fixed. dogrep():
            ckuus6.c.
          + Minor updates to the HELP GREP text: ckuus2.c.

          The March 19 version is available for download [103]HERE.

          10 March 2023

   Debug logs can be ridiculously long, largely because of all the debug
          statements in in ckstrlen() in ckclib.c. This routine can be
          considered debugged and correct after all these years so I
          commented out all its debug() calls. This makes debug logs about
          four times shorter, at least in the case I tested.
          10 March 2023

   Prior to this date I had direct access to only three platforms where I
          could build and test C-Kermit: Red Hat RHEL 6.10, NetBSD 9.3,
          and Ubuntu 20.4.1. Now I also can build and test on nine more:
          Centos 9, Debian 11, Fedora 37, Oracle Linux Server 9.1, Rocky
          9.1, OpenSUSE Leap 15.4, FreeBSD 13.1, OpenBSD 7.2, and NetBSD
          10.0 Beta. As of 20 March there are 205 successful builds in the
          [104]builds table.
          16 February 2023

   Added client end of REMOTE STATUS, with which the client asks the
          server for information about the most recent file transfer (this
          was a feature of DECSYSTEM-20 Kermit that never made it into
          C-Kermit). The server end has yet to be written.

C-Kermit 10.0 Beta.08 , 15 December 2022

          15 December 2022

   Nobody has ever reported a problem with "make linux+krb5-new" so I
          renamed the previous linux+krb5 target to linux+krb5-old and
          linux+krb5-new to linux+krb5 so Kerberos builds on Linux should
          be smoother from now on.

          Kenji Rikitake noticed some funny business during builds from
          the Beta.07 tarball: I had written a new script to make the
          tarball and install it, but forgot to remove ckwart.c and
          ckcpro.w from the script's file list. This can cause some crazy
          compilation errors in some cases, messages from something called
          "ctangle", apparently part of TeX. I fixed the new script, which
          is in itself sufficient reason for the new Beta.

          But a much better reason is that David Goodwin has a new Beta
          for Windows ready, so I'm making today's code a new Beta too:
          Beta.08 for VMS and Unix; Beta.04 for Windows, both dated 15
          December 2022 and built from the same common code base.
          Beta.08's full version number is 10.0.402. [105]CLICK HERE to
          see about the new Windows beta.

          12 December 2022

          + COPY /INTERPRET and TYPE /INTERPRET added in September 2022
            disappeared from C-Kermit at some point after that; an #else
            in ckcdeb.h had gone AWOL.
          + Added GREP /DISPLAY:n, that displays only the first n matching
            lines rather than all of them.
          + Added GREP /VERBATIM, which suppresses the normal
            intepretation of \-variables and functions in the search
            string and greps for the actual literal string given,
            something is is almost impossible to do with Unix or GNU grep,
            with all the overloading of shell and regular-expression
            syntax that comes into play when the search string contains
            any of []().*^$-\'. The closest you can come with GNU grep is
            grep -F 'searchstring' (note: single quotes), but even that
            doesn't work if the search string itself includes single
            quotes; see [106]this page for the gory details.
          + Added GREP /MACRO:name (alias GREP /DEFINE:name) to assign the
            grep results (single line or multiple lines) to the macro
            whose name is given. As with DEFINE, any existing macro of the
            same name is overwritten by the GREP result, but in this case
            only if there is at least one match.
          + The [107]C-Kermit 10.0 command reference was updated with the
            new GREP options.
          + Added some compiler symbols to the SHOW FEATURES command:
            TYPEINTERPRET, COPYINTERPRET, TMX_TIME_T, TMPBUFSIZ,
            LINBUFSIZ.

          Modules affected: ckuus5.c, ckuus6.c, ckuus2.c. Today's code
          builds normally with "make linux", etc, as well as with "make
          linux -DNOSPL" (which eliminates GREP /MACRO because NOSPL (No
          Script Programming Language) builds don't have macros). Today's
          code uploaded to [108]HERE 2022-12-12-19:54:00.

          11 December 2022

   From Steven M Schweda:

          + Revived "make aixg", at least for IBM AIX 6.1: "The
            IBM-supplied <sys/ioctl.h> (/usr/include/sys/ioctl.h) needs a
            little help to avoid errors on 'struct winsize': took a new
            SMS makefile that has improved aix and aixg targets." And...
            "Problems with 'localtime()'... New work-around requires user
            to define (new) C macro: TMX_TIME_T. See replacement ckufio.c.
            A smarter scheme might be to use 'time_t' everyplace, and
            expect the user to typdef/#define it if his (obsolete?)
            environment fails to do so."
            The new AIX build is recorded in the [109]Beta-07 builds
            table.

          Plus...

          + An extraneous '*/' removed from "/* #endif /* NETPTY */" in
            ckcdeb.h line 685, ignored in most builds but fatal in at
            least one.
          + SHOW FEATURES now includes (on the second line) the full
            pathname of the C-Kermit program and its size in bytes:
            ckuus5.c.
          + I added an internal varsval() function that, given the name of
            a \v(variable), returns its value as a string. I was going to
            use it in the SHOW FEATURES addition but another method turned
            out to be simpler.

          Today's code builds ok on Ubuntu, RHEL, and NetBSD. I uploaded
          it to the semi-daily [110]C-Kermit 10.0 Beta Pretest builds site
          just now (2022-12-11 16:23 EST).

C-Kermit 10.0 Beta.07 , 07 December 2022

   I've always had a rule that every change to C-Kermit must be backwards
   compatible so scripts and procedures written for an old version of
   C-Kermit will continue to function in the new one. But C-Kermit has a
   feature that has caused great consternation over the years, especially
   in its Windows version (formerly [111]K95, now [112]CKW), namely that
   "backslash-%" scalar variables -- \%1..\%9, \%a..\%z, and array
   references: \&a[]..\&z[] -- are evaluated recursively. This happened
   because C-Kermit's variable syntax and semantics were designed to be
   compatible with those of MS-DOS Kermit (which preceded it by several
   years) and an early MS-DOS Kermit contributor implemented its variables
   this way.

   Problems occur mainly in DOS, Windows, and OS/2 because their pathnames
   contain backslashes, which is also Kermit's "escape" character that
   introduces variable names, and this causes no end of trouble. The
   problem is discussed and illustrated at length [113]here. but manifests
   itself only when the value of a \%x or \&x[] variable includes one or
   more backslashes.

   The irony is, I have NO IDEA if anybody actually uses the recursive
   evaluation feature. I suspect not! So changing the default behavior
   should have no effect, but Murphy's Law suggests otherwise. So I've
   made this change in Beta.07 and we'll see if anybody notices. Without
   it we might have timebombs going off for the rest of eternity.

   If anyone is adversely affected, all they have to do is SET
   VARIABLE-EVALUATION RECURSIVE at the head of their scripts or, for that
   matter, just once in their [114]C-Kermit initialization files. Also
   \frecurse(variablename) can be used on any kind of variable -- not just
   \%x and \&x but also \m(x) ones -- to extract its value recursively.
   Similarly, \fcontents(variablename) can be used to extract the value of
   any kind of variable without recursion.

   The SET VARIABLE-EVALUATION command was added to C-Kermit in version
   9.0, released in 2011.

Other changes...

          06 December 2022

   From Steven M Schweda:

          + ckcdeb.h, the section starting at line 1340: For (Open)VMS:
            simplification and future-proofing of the #ifdefs that decide
            whether the underlying architecture is 32 bits or 64 bits.
            Rather than assume 32 bits and then test for various 64-bit
            architectures (IA64, Itanium, etc), now it defaults to 64 bits
            for all architectures except VAX.
          + ckcnet.c line 14085:  if ( saddr.sin_addr.s_addr == (unsigned
            long) -1 ): a fix for the increasingly common warning:
   if ( saddr.sin_addr.s_addr == (unsigned long) -1
            ~~~~~~~~~~~~~~~~~~~~~ ^  ~~~~~~~~~~~~~~~~~~
warning: "result of comparison of constant 18446744073709551615 with
expression of type 'in_addr_t' (aka 'unsigned int') is always false".

            And the same thing again about 140 lines further down. This
            fixes (e.g.) the Wtautological-constant-out-of-range-compare
            warnings in macOS builds.
            Today's code uploaded to [115]HERE, 17:44 New York time.

          04 December 2022

   Undid the inadvertant undoing of a bit in ckuath.c at the end of
          ck_krb4_is_installed_as_server(): "2022-12-01 SMS. Added return
          in case where ifndef KRB4."
          03 December 2022

          + Yesterday's changes broke non-ANSI C compilation of ckuus2.c,
            ckuus4.c, ckuusx.c, discovered by Peter Eichhorn on HPUX, who
            also noticed that there was Yet Another redundant declaration
            of devname in ckutio.c. Fixes in today's upload.
          + Kerberos 5 builds were failing with vast amounts of warnings
            and errors. Turns out that back in September when I changed
            the BETATEST definition from being local to ckcmai.c, to
            global for all modules, I didn't realize that many years ago
            someone had put some experimental code into ckuath.c within
            #ifdef BETATEST..#endif, and suddenly now it awoke from its
            slumber and went rampaging. I changed the #ifdefs to something
            less collision-prone (KRB5_BETATEST) and the situation with
            Kerberos has settled down:

   Platform Make command Compiler Result Description
   Red Hat RHEL 6.1 make linux+krb5 gcc 4.4.7 Failed /usr/bin/ld: cannot
   find -lgssapi
   Red Hat RHEL 6.1 make linux+krb5-new gcc 4.4.7 OK No errors, no
   warnings
   Ubuntu 20.04.1 make linux+krb5 gcc 9.4.0 Failed "undefined reference to
   symbol 'krb5_c_encrypt@@k5crypto_3_MIT'"
   Ubuntu 20.04.1 make linux+krb5-new gcc 9.4.0 OK Warnings: 12 implicit
   declaration, 2 incompatible-pointer
   NetBSD 9.3 make netbsd+krb5 gcc 7.5.0 Failed Because it's Heimdal
   Kerberos, not MIT
            The xxxxxx-krb5-new targets are intended to do a better job of
            finding header files and libraries, and they seem to be doing
            that.
            When building with Clang, of course there are a LOT more
            warnings; for example "make linux+krb5" with Clang 10.0.0
            yields 57 "Wdangling-else", 42 "Wparentheses", 42 "Wequality
            comparison", 17 "Wimplicit-function-declaration", 5
            "Wpointer-sign", 3 "Wtautological-constant", and 1 "non-void
            function does not return a value in all control paths", of
            which only the final three would be of any real consequence.
            Clang 15 adds another 774 "Wdeprecated-non-prototype"
            warnings.
            I don't know enough (understatement) about Kerberos to fix
            substantive errors like "undefined reference to symbol
            'krb5_c_encrypt@@k5crypto_3_MIT'", nor to finish the Heimdal
            code, but I'll do what I can about the warnings, especially
            the non-prototype ones, but only after Beta.07 is released
            becuase it's too big a last-minute change.
          + Another bit of fallout from the BETATEST definition was a
            piece of the SHOW TAPI command (ckuus5.c: showtapi()) was
            enclosed in #ifdef BETATEST..#endif, but this was just some
            additional verbosity in the response. Nobody would have
            noticed this unless they were actually using CKW to make phone
            calls. I changed this to TAPI_BETATEST.

          Today's code uploaded to [116]HERE, 20:16 New York time.

          02 December 2022

   Bits and pieces... Today's build (20221202) is [117]HERE.

          + From SMS: new macos+ssl and macos+ssl-zlib targets plus an
            experimental macos+krb5+ssl target with some accompanying code
            changes. Kerberos builds on new macOS versions seem hopeless;
            Apple changed everything. Unfortunately the new Kerberos code
            changes broke all the other Kerberos builds so I rolled them
            back, but all three new makefile targets are still there.
          + "make netbsd-krb5" and "make netbsd-krb5-new" builds were
            failing immediately with a nonsensical error: "unknown type
            name 'jmp_buf' in 'typedef jmp_buf ckjmpbuf;'" because of an
            unwise choice of header-file directory search order; these
            builds still fail but for actual good reasons having to do
            with the Kerberos 5 code itself. This is on a Heimdal Keberos
            system, for which C-Kermit support was never completed; the
            same targets might build OK on NetBSD with MIT Kerberos.
          + Makefile: eliminated spaces after \ in continued lines and
            fixed target lines that started with spaces instead of tab;
            some 'make' programs are pretty unforgiving about these
            invisible errors.
          + Fixed duplicate declaration of devname in ckufio.c, noticeable
            only in FreeBSD, discovered by Nelson Beebe.
          + Some HELP message for C-Kermit for Windows (CKW) were improved
            by David Goodwin, plus some CKW-specific changes to ckcdeb.h.
          + Fixed two prototypes that were added to ckucmd.c without
            protection by #ifdef CK_ANSIC..#endif, noticed by Peter
            Eichhorn.

          01 December 2022

   Clang 15 warns of exactly 666 implicitly declared functions, i.e.
          functions lacking prototypes. The announced intention was to
          turn this warning into a [118]fatal error in Clang 16 and maybe
          this is the case or maybe not, I can't seem to find a straight
          answer and don't have access to Clang 16. In any case it seems
          that it's better for C-Kermit's long-term health for every
          function to have a prototype. But of course this must be done in
          a way that does not break compilation with pre-ANSI K&R C
          compilers. So I obtained a list of all the non-prototyped
          functions from Clang 15, and then installed prototypes protected
          by #ifdef CK_ANSIC..#endif for (hopefully) all C-Kermit's static
          functions as a relatively easy first step. Compilation with
          clang 15 reduced the number of "non-prototype" warnings from 666
          to 490. Modules changed: ckcnet.c, ckctel.c, ckucmd.c, ckudia.c,
          ckufio.c, ckutio.c, ckuus2.c, ckuus3.c, ckuus4.c, ckuus5.c,
          ckuus6.c, ckuusr.c, ckuusx.c, ckuusy.c, ckuxla.c.

          Also (from David Goodwin in New Zealand, who is working on the
          Windows C-Kermit version), the "TLSv1_server_method deprecated"
          warnings have finally been eliminated in the xxx+ssl targets:
          "When building with OpenSSL 1.1.0 or newer, TLS_server_method()
          will be used instead of SSLv23_server_method(). For OpenSSL
          1.0.2 and older it will function as before using
          SSLv23_server_method and maybe falling back to
          TLSv1_server_method. Seems to build fine with OpenSSL 1.1.1 --
          not really sure how to test it though, but given
          SSLv23_server_method was just #defined as TLS_server_method if
          it worked before it should still work now."

          Today's build (20221201) is [119]HERE.

          29 November 2022

          + The Unix C-Kermit man page, ckuker.nr, was thoroughly revised
            for C-Kermit 10.0.
          + Thanks to Nelson Beebe I was able to install clang 15.0.5 on
            my Ubuntu box and try some builds, which are now listed in the
            [120]builds table. "make linux-clang" gets 667 warnings; one
            "[121]*s++;" and 666 "function definition without a
            prototype", warnings which will (or did) turn into a fatal
            error in clang 16 (it's not clear to me; see [122]below).
            "make linux-clang-gnu89", on the other hand, gets only the one
            warning: "*s++;" which is bogus. The real question is... when
            clang switches "non-prototype" from warning to fatal error,
            will -std=gnu89 still let "non-compliant" programs build? In
            any case I intend to install the needed prototypes but it's
            not a straightforward task and is a HUGE amount of work.

          27 November 2022

   In ckucon.c (used only for Minix and a few other stragglers)
          "include ckcdeb.h" was fixed to be "#include ckcdeb.h"; somehow
          the '#' was lost in yesterday's edit. Also, added a
          minix3+select target to see if it can be built with the
          preferred ckucns.c select()-based CONNECT module.
          26 November 2022

   MINIX builds by Nelson Beebe and the University of Utah, using Clang
          masquerading as gcc 4.4.6 as the compiler, so it gets all the
          usual bogus warnings about "*s++;" and IF conditions that
          include both && and ||. Also: added -DNOIKSD to minix3 targets
          to avoid "undefined reference to crypt".

          + "make minix3"... the first build attempt since January for
            MINIX 3, which uses the old fork()-based ckucon.c CONNECT
            command module (which I had forgotten about), rather than the
            newer select()-based ckucns.c, revealed that it did not get
            its CR (carriage return) symbol references renamed to CK_CR,
            which was necessary because CR showed up in a Windows header
            file. This was done today. Meanwhile it might be worth
            checking whether MINIX 3 can use ckucns.c; if it has TCP/IP it
            must have select(), right?
          + Supplied a missing prototype for initfloat() in ckcmai.c.
          + "make minix3 -i -k" gets errors for undefined rlogin-related
            identifiers including rlog_inband, rlog_mode, rlog_oob,
            rlog_naws but I don't know how to fix this because I don't
            know -i -k means. So I added -DNORLOGIN to the minix3 target.
          + "make minix315" failed with all the same errors, so should be
            fixed next time around.
          + The "make minix340" build said:
./ckuver.h:526:9: warning: 'HERALD' macro redefined
#define HERALD " Minix 3.4.0"
        ^
./ckuver.h:245:9: note: previous definition is here
#define HERALD " 4.4BSD"

            I can't see how this could happen but I worked around it like
            this:
#ifdef MINIX340
#ifdef HERALD
#undef HERALD
#endif  /* HERALD */
#define HERALD " Minix 3.4.0"
#ifndef MINIX3
#define MINIX3
#endif /* MINIX3 */
#endif /* MINIX340 */

            But there were other more serious errors that I don't know how
            to work around: implicit definition of ioctl() with related
            identifiers undeclared: TIOCFLUSH, TIOCGWINSZ; implicit
            definition of openpty(); <sys/timeb.h> not found. These can
            only be fixed by somebody who knows MINIX. Today's code
            uploaded to [123]HERE, 20:12 New York time.

          24 November 2022

   A shortcoming of the linux+krb5-new target from two days ago was that
          there was no way to force it to link to an installed gssapi
          library that was not known to the linker; for example on my
          Ubuntu box, where it happens to be in
          /usr/lib//x86_64-linux-gnu/. Today's edition handles this
          sitution by looking in the /usr/lib/ tree for libgssapi_krb5 (or
          failing that, libgassapi) and then adding the directory where it
          was found to LD_LIBRARY_PATH. This involved some hairy
          shell-script-inside-of-makefile syntax which is a bit beyond me
          so decades-long Kermit friend Peter Eichhorn in Germany supplied
          the necessary notation. NEEDS TESTING! But even if it works
          perfectly for everybody, it introduces another problem: it's
          over 100 lines long... and it has to be ported to fifteen other
          xxx+krb5 targets, including the linux+krb5+ssl target. Also:

          + Restored missing linuxnd target (noticed by PeterE)
          + Fixed the garbled qnx16 target(ditto)

          Today's version is available [124]HERE, marked 2022-11-24.

          23 November 2022

   Added HAVE_GSSAPI, KRB4, and KRB5 to SHOW FEATURES display.
          22 November 2022

   "make linux+krb5" (to build C-Kermit with Kerberos 5 support) has been
          a big pain for-almost-ever. I spent most of today fixing this,
          at least on the two Linuxes I have direct access to: Ubuntu
          20.04.1 and Red Hat Enterprise Linux 6.10. Previously it failed
          hard on Ubuntu. There is a whole new and radically different
          makefile target for this, "make linux+krb5-new". It'll become
          the default Linux Krb5 build after I've had more feedback. The
          old target was full of hardwired pathnames for both header files
          and libraries. The new one still (unavoidably, I think) has some
          for header files, but libraries are now found by the linker
          (ln).

          The hardest part was dealing with gssapi, it could be almost
          anywhere. If ln finds it with "-lgssapi_krb5" or "-lgssapi",
          all's well, and the symbol HAVE_GSSAPI is made available to the
          C and header files. Otherwise you don't get gssapi in the build.
          For example on my Ubuntu box, it happens to be in
          /usr/lib/x86_64-linux-gnu/libgssapi_krb5.so but the linker
          doesn't know about it, so C-Kermit builds with Kerberos 5
          support that does not include gssapi. By the way, the reason it
          built OK on RHEL 6.10 is that it doesn't have gssapi.

          Once the new target is more widely tested and any needed patches
          are applied, I can convert the other Kerberos 5 builds that are
          scattered throught the makefile.

          Besides the makefile, ckcftp.c had to be changed to have
          #ifdef HAVE_GSSAPI...#endif around any gssapi-specific code.
          Also both ckuath.c and the makefile had to account for several
          possible locations for com_err.h. Nothing has been done yet
          about Heimdal Kerberos; I'm not qualified. Volunteers welcome!

          Meanwhile, please do "make linux+krb5-new" builds on all
          different linuxes that have Kerberos 5 installed and send the me
          results for the [125]builds table, along with any problem
          reports and/or patches. Thanks! Today's code is [126]HERE,
          marked 2022-11-22.

          21 November 2022

   From David Cantrell, a patch to the makefile targets linux+krb5 and
          linux+krb5+ssl to so the linker can find the lib64
          subdirectories and libcom_err.so. Current code uploaded to
          [127]HERE 21 November 2022.
          18 November 2022

   Verified that "set host /server * 3000" / "set host xxx 3000"
          client-server connections still work between every combination
          of NetBSD, Ubuntu, and Windows. Read about this kind of
          connection [128]HERE. No code changes were needed.

   And from SMS:

          + New VMS build files ckvker.com and ckvker.mms with wart and
            ckcpro.w removed.
          + New Unix makefile with some straggling ckcpro.c references
            removed.
          + An updated hpux1000o+ssl target: "added some flexibility
            options in the main HP-UX + SSL rule to cope with a wandering
            zlib object library, whose location seems to be the user's
            choice (I saw no evidence of HP[E] supplying one.)"

          16 November 2022

          + Got a functional SSL build on NetBSD 9.3 with OpenSSL 3.0.7.
            No errors, but "deprecated" warnings for these functions:
            TLSv1_server_method, DH_free, DH_new, DH_set0_pqg,
            PEM_read_bio_DHparams, RSA_free, RSA_generate_key_ex, RSA_new,
            and SSL_CTX_set_tmp_dh_callback.
          + For completeness, here are the functions that are flagged by
            SSL 1.1.1 as "implicitly declared" in ck_crp.c:
            des_set_random_generator_seed, des_new_random_key,
            des_ecb_encrypt, des_set_odd_parity, des_key_sched,
            des_ecb3_encrypt.
          + Added: <tab>*3.[0-9].[0-9]*) OPENSSLOPTION="-DOPENSSL_300" ;;
            to all makefile file targets that have corresponding clauses
            for earlier OpenSSL versions: freebsd, netbsd, solaris9g,
            hpux10/11, and linux. So far it's not used for anything but
            now  "#if(n)def OPENSSL_300" is available to anyone who might
            want to take care of the "deprecated" warnings in OpenSSL3.
            For TLSv1_server_method see:
            [129]https://www.openssl.org/docs/manmaster/man3/TLSv1_server_
            method.html and for the others see:
            [130]https://www.openssl.org/docs/man3.0/man7/migration_guide.
            html.

          15 November 2022

   (From SMS) In ck_ssl.h... Added #ifndef..#endif clauses around #define
          OPENSSL_098 and #define OPENSSL_100, and added a clause for
          OPENSSL_300. Numerous makefile changes for HPUX11 with OpenSSL.
          Today's code base uploaded to [131]HERE.
          13 November 2022

   Increased size of errmsg buffer in ckudial.c about line 6602: ckdial(),
          and changed the "sprintf()" that constructs the error message to
          "ckmakmsg()". sprintf() and snprintf() are both either dangerous
          or likely elicit warnings; ckmakmsg() and ckmakxmsg() (defined
          in ckclib.c) are safe and portable replacements. Especially
          since there is no good way to test for the availability of
          snprintf() without using [132]nonportable preprocessor
          constructions such as "#if _XOPEN_SOURCE >= 500". There are
          seven more snprintf()s in C-Kermit code that could be converted
          but for now fall into the "don't fix what ain't broke" category.
          12 November 2022

          + Added "check" target to makefile (at the end), from Nelson
            Beebe. Now you can do "make linux check" and get a success or
            failure indication at the end, and if the build succeeded, an
            ls -l listing of the result.
          + Fixed the dangling else in ckuu5.c line 6800.
          + HELP strings for HELP FUNCTION STRCPY, FILEINFO, DAYNAME, and
            MONTHNAME were longer than "the length '509' ISO C90 compilers
            are required to support"; I converted these into hmsga()
            arrays. ckuus2.c.

          6 November 2022

          + Wart is no more!  Ever since C-Kermit was first written in
            1985, the file-transfer protocol was was controlled by a state
            machine in a [133]Lex-like module called ckcpro.w; 'w' for
            "Wart" which was a pun on a play on words. The "compiler" for
            ckcpro.w was ckwart.c, which produced ckcpro.c. Well, we
            haven't had to change the state machine much in recent years
            so there's really no need for all the confusion and side
            effects, e.g. like when you use gmake instead of make, or a
            build fails because there's still a ckcpro.o file (or worse. a
            wart executable) hanging around from a previous build on a
            different platform. So from now on, ckcpro.c is a SOURCE file,
            just like all the other ck*.c files, and can (and should) be
            edited directly. The makefile was modifed to skip all
            invocations and discussions of wart, and ckcpro.c was edited
            to not refer to preprocessor step.
          + OpenSSL 3.0.7... Tried building C-Kermit 10.0 pre-Beta.07
            against penSSL 3.0.7 on Netbsd 9.3. Compilation succeeded but
            with 26 "deprecated" warnings. The link step failed with 224
            references to 50 distinct undefined objects ([134]see list) in
            the following modules: ckutio.c, ckuus3.c, ckuus7.c, ckcnet.c,
            ckcftp.c, ck_ssl.c. The undefined references are functions new
            to OpenSSL 3, so the fault seems to be in the testbed setup;
            David Goodwin says he can build with SSL 3.0.7 and does not
            get the undefined reference errors.
            Note: I got this build working [135]November 16th.
          + Fixed a missing blank line in HELP SET TELNET text by
            supplying a missing comma in ckuus2.c.

          5 November 2022

   "make openbsd" on LibertyBSD 6.1 failed because an
          #include <sys/timeb.h> was encountered but there was no
          <sys/timeb.h>. Most instances of #include <sys/timeb.h> were
          protected by #ifndef NOSYSTIMEBH..#endif; I added the protection
          where it was missing: one spot in ckcdeb.h, two in ckufio.c.
          4 November 2022: Clang considered harmful

   From [136]Clang 16.0.0git (In-Progress) Release Notes, Section
          [137]Potentially Breaking Changes: "The
          -Wimplicit-function-declaration and -Wimplicit-int warnings now
          default to an error in C99, C11, and C17. As of C2x, support for
          implicit function declarations and implicit int has been
          removed, and the warning options will have no effect. Specifying
          -Wimplicit-int in C89 mode will now issue warnings instead of
          being a noop. NOTE: We recommend that projects using configure
          scripts verify that the results do not change before/after
          setting -Werror=implicit-function-declarations or -Wimplicit-int
          to avoid incompatibility with Clang 16".

          This is a potentially earth-destroying change, and that's not
          hyperbole. You can't just decide to make previously correct
          programs uncompilable. The world depends on software to keep
          working. You can't expect every software developer to drop
          everything and change thousands or millions or billions of lines
          of CORRECT code to satisfy some arbitrary and capricious whim of
          some random organization ([138]LLVM), that happens to have
          strong ties to Masters-Of-The-Universe companies like Apple, to
          invalidate the work of programmers who have been following the
          rules codified by legitimate standards authorities like ISO,
          POSIX, and ANSI for decades. Although existing software will
          continute to run, eventually it will need to be recompiled for
          replacement hardware that is increasingly likely to have Clang
          as its default or only C compiler; Clang will kill the
          compilation and the new hardware won't be able function. A
          medical device? A drawbridge? A traffic-light network? A nuclear
          power reactor? A mission-critical application on a corporate or
          government computer? That perhaps was developed by a contractor
          that no longer exists?

          According to my rough count, C-Kermit has over 4000 function
          definitions. Of these about 2500 have no prototypes because
          their arguments are integers or they have no arguments. Imagine
          the risks inherent in "correcting" 2500 function declarations by
          hand, then weigh them against the benefits. The Clang folks
          should remember the Robustness Principle. It's fine to warn
          about things to enourage "good behavior" but far that's enough.

          (Later it was suggested that Clang edict was not as draconian as
          it seemed because it could be overridden by including -std=c89
          in the Clang invocation; I tried that and the compilation bombed
          instantly with "/ckcsig.h:52:9: typedef sigjmp_buf ckjmpbuf;
          error: unknown type name 'sigjmp_buf'"... so best to let
          sleeping dogs lie, no?)

          3 November 2022:

          + ck_ssl.c: Changed four occurrences of "printf(ssl_err);" to
            printf("%s",ssl_err);, and one occurrence of "printf(prefix);"
            to printf("%s",prefix). There remains one warning:
            "TLSv1_server_method is deprecated" that needs fixing by an
            OpenSSL programmer.
          + Trying to build C-Kermit on Unix V7 from 1979 is hopeless,
            it's just too big. I kept adding -DNOxxx to deselect
            individual features but it was never enough. Finally tried to
            build a command-line-only version (no interactive commands):
            KFLAGS=-DNOICP (no interactive command parser). This hasn't
            been done for at least a decade, maybe two; to make it work I
            had to make changes (#ifdefs and #ifndefs) to ckcmai.c,
            ckuus[456xy].c, ckcdeb.h, ckcfns.c, ckcpro.w, ckucns.c,
            ckuscr.c, ckucmd.c, and the makefile.
          + -DNOICP was still not enough for V7. I added a new category to
            ckcdeb.h: V7MIN which not only has no interactive command
            commands but also no making network connections (-DNONET), no
            character-set conversion (-DNOCSETS), no spawning and
            interacticing with external processes (-DNOPTY), no debug or
            other logging, and only a minimum set of dialout modems
            (-DMINIDIAL) rather than the normal 72. -DV7MIN can be used
            not only with Unix V7 but also with any other target, e.g.
            Linux. Here are the results for Ubuntu x86_64:

             Make command  KFLAGS   Size              Description
            make linux             2851200 Normal build
            make linux+ssl         3079056 Normal + OpenSSL
            make linux     -DNOSPL 2321544 No script programming language
            make linux     -DOICP  702264  No interactive command parser
            make linux     -DV7MIN 402984  Minimum (about ⅐ of normal build)
          + "make netbsd+ssl" got a ton of warnings about "implicit
            declaration of des_xxx" for various xxx's. I know beans about
            OpenSSL but I made a new makefile target netbsd+ssl-des ("plus
            SSL and minus DES") which left out the DES part and it built
            ok, except for a warning "TLSv1_server_method' is deprecated".
            The resulting binary was able to make a secure connection to
            https://kermitproject.org and execute various HTTP commands.
            Today's source code is [139]HERE.

          30 October 2022:

   Wtmp and Syslog logging are no longer included by default because they
          are "deprecated" in macOS with other modern Unix varieties no
          doubt soon to follow; thus C-Kermit 10.0 builds would start
          failing at some point if I left this code active. So now if you
          want your copy of C-Kermit to include Wtmp logging (which is
          used only when C-Kermit is running as an Internet Kermit Service
          Daemon, IKSD) you have to include KFLAGS=‑DDOWTMP in your 'make'
          command; to include Syslog include KFLAGS=‑DDOWTMP; to include
          both: KFLAGS="‑DDOWTMP ‑DSYSLOG". Syslog logging is a
          little-known, little-used C-Kermit feature for logging
          authentication events, client/server events, and custom
          debugging.
          30 October 2022:

   Fixed -DNOSPL builds, so C-Kermit can once again be built without a
          script programming language. On Ubuntu x86-64, the default "make
          linux" build is 2860016 bytes. With -DNOSPL it's 1189808, 41.6%
          of the normal size. Space savings like this are necessary when
          building on ancient platforms where builds of big programs tend
          to fail. Changes:

          + ckcdeb.h: At line 62, changed #ifndef NOSPL to #ifdef NOSPL
            and #defined NOIKSD and NOLEARN if NOSPL was defined.
          + ckuusr.c: Put #ifndef NOSPL..#endif around the
            isinternalmacro() routine
          + ckuus3.c: in doprm() put case SCMD_VAR: in #ifndef NOSPL (2
            occurrences)
          + ckuus6.c: Put "grep /array" code in #ifndef NOSPL; in
            dotake(), took extern char lasttakeline[]; out of #ifndef
            NOSPL.

          The result still has TCP/IP networking and the (external) SSH
          client.

          29 October 2022:

   Changed makefile target v7 (Bell Labs Seventh Edition Unix, a.k.a. Unix
          V7) to include -DNOSYSLOG.

   Changed ckcdeb.h in the #ifdef V7..#endif section at line 1132 to
          declare extern int errno for Unix V7 (1979) and V8 (1985).
          28 October 2022:

   I changed the default VARIABLE-EVALUATION setting from RECURSIVE (1) to
          SIMPLE (0) for C-Kermit 10.0 Beta.07: ckuusr.c, ckuus3.c.
          26 October 2022:

   ckutio.c at about line 15935, enclosed #includes of <stdarg.h> and
          <varargs.h> in #indef NOIKSD..#endif; otherwise KFLAGS=‑DNOIKSD
          builds fail.

          ckcftp.c line 797:  #define CHECKCONN()
          if(!connected){printf(nocx);return(-9);}
          changed to: #define CHECKCONN()
          if(!connected){printf("%s\n",nocx);return(-9);}

          24 October 2022:

   New documents:
              [140]C-Kermit 10.0 Tutorial
              [141]C-Kermit 10.0 Command Reference (about 7000 lines / 130
          pages if printed)

          This is the first time since the publication of "Using C-Kermit"
          2nd Edition in 1997 that every single C-Kermit command and
          option is documented in one place.
          21 October 2022:

   Added CONVERT as a more-appropriate synonym for TRANSLATE (for
          converting the character encoding of a text file). Of course
          TRANSLATE still works.
          20 October 2022:

   Improved or fixed various HELP commands.

   [142]Comments welcome.

C-Kermit 10.0   (14 October 2022)   [143]DOWNLOAD

   18 October 2022: the Beta.06 download includes some extraneous files:
   ckcnet‑BEFORE‑NONET‑FIX.c, ckuus7‑beta02.c, ckuus7‑save.c,
   ckuus5‑sms.c, ckutiox.c, ckcdebu.h. They do harm but shouldn't be
   there; this will be corrected in the next beta.

   About FTP and OpenSSL...
          Apparently rumors of FTP's death have been exaggerated and --
          more to the point -- that of [144]Secure FTP (FTPS). It is still
          required, for example, by EDI providers such as [145]BOLD VAN,
          so C-Kermit's OpenSSL support is a priority after all*. At this
          point, builds work on most platforms where it has been tried
          (Ubuntu, Debian, Red Hat, Fedora, Hurd, NetBSD, FreeBSD, and
          OpenVMS). In one case on Ubuntu, however, it failed with
          "openssl/comp.h: No such file or directory - #include
          <openssl/comp.h>". According to a report I found in Google, this
          is fixable by "sudo apt-get install libssl-dev". See [146]this
          OpenSSL.org page about SSL and TLS, which explains that
          currently, SSL is really TLS (in OpenSSL, "After SSLv3, SSL was
          renamed to TLS"; also see [147]RFC 7568). Note: FTPS is not to
          be confused with SFTP, which is SSH. [148]A number of FTPS
          servers are available, both commericial and free. For example,
          the free FTPS server for Ubuntu is is called [149]vsftpd and can
          be installed with "sudo apt install vsftpd". An example of a
          commercial FTPS server is [150]Cerberus FTP Server 12.

   * EDI = Electronic Data Interchange; VAN = Value Added Network; SSL =
   Secure Sockets Layer; TLS = Transport Layer Security.

   Changes since Beta.05 (newest first)...

          14 October 2022:

   A change to "make install" in the makefile to allow the target
          directory for the Kermit binary to be specified on the 'make'
          command line, e.g. "env PREFIX=/usr/pkg make install" (Peter
          Eichhorn, Greg Troxel).

          Listing the speeds in numeric order rather than "alphabetic"
          when '?' was typed (Oct 10) was the easy part. Making a numeric
          keyword table behave the same as an alphabetic one during
          interactive command entry -- notably keyword completion when Esc
          or Tab was typed -- was a major production. ckucmd.c now has a
          new routine, nlookup(), parallel to lookup(), plus a lot of new
          code in cmkey() to account for the differences between the two
          formats. A side benefit is that if more numeric tables are ever
          needed, adding adding them will be straightforward.

          11 October 2022:

   A fix to yesterday's item from SMS for Compaq C V6.4-005 on OpenVMS VAX
          V7.3, which doesn't tolerate array declarations with
          non-constant dimensions (these are a new feature of [151]C99
          from 2000.)
          10 October 2022:

   With the addition of so many new serial speeds, the result of
          "set speed ?" was a random pile of numbers:

C-Kermit>set speed ? Serial-port speed (bits per second), one of the following:
 1000000  134.5    1800     230400   300      4000000  57600    921600
 110      14400    19200    2400     3000000  460800   600      9600
 115200   150      200      2500000  3500000  4800     75
 1200     1500000  2000000  28800    38400    50       76800

          Now it makes more sense:

C-Kermit>set speed ? Serial-port speed (bits per second), one of the following:
 50       150      1200     9600     38400    230400   1500000  3500000
 75       200      1800     14400    57600    460800   2000000  4000000
 110      300      2400     19200    76800    921600   2500000
 134.5    600      4800     28800    115200   1000000  3000000

          The new code is in ckuus5.c, lines 1241-1278. If it causes
          trouble, it can be deselected at 'make' time with
          KFLAGS=‑DNOSORTSPEEDS.

          6 October 2022:

   ckutio.c changes from Pali Rohár to get at the higher serial speeds
          supported by newer UARTs.

          + ckutio.c ttsspd() was missing the new high-speed baud rates
            (thus they could be recognized by the command parser but not
            actually used). The new speeds are 500000, 576000, 614400,
            921600, 1000000, 1152000, 1500000, 2000000, 2500000, 3000000,
            and 4000000.
          + Supplied a missing "return(1);" statement in the USETCSETSPEED
            case in ttsspd().

          Why? Pali said "I need to transfer files over UART with highest
          possible speed. I'm developing software which is running on
          embedded devices and for transferring software I can use only
          UART (bootstrapping and debugging). My hardware supports
          baudrates up to 6000000 baud and also I have USB ↔ UART cables
          which support such high speeds. Modern hardware now supports
          UART at really high baudrates, so why not to use it for
          decreasing final transfer time? Bootloader U-Boot has support
          for kermit protocol and can receive files over UART at arbitrary
          baudrate supported by HW. So the only thing which I need is
          software on my computer which can configure UART tty device to
          higher speed and then send over it files via kermit protocol."

          He also removed an extraneous semicolon from ckutio.c line 501:
          #define LOCK_DIR "/var/spool/locks";

          5 October 2022:

          + The ability of C-Kermit's DIRECTORY command to handle multiple
            file specifications, e.g.:

dir makefile README ck[cuvw_]*.[cwh]

            has been broken since C-Kermit 9.0 from 2011. Fixed now.
          + C-Kermit's TOUCH command (which has many options) has been
            totally nonfunctional since the same date. Also fixed now.

          3 October 2022:

   Patch from SMS for OpenSLL (ck_ssl.c):

***************
*** 49,60 ****
  /* Different major/minor version or development version of OpenSSL
   * means ABI may break compatibility.
   * Modified by Adam Friedlander for OpenSSL >= 1.0.0
   */
! #define COMPAT_VERSION_MASK 0xffff000f
  #else
  /* Different major/minor/fix/development (not patch) version of OpenSSL
   * means ABI may break compatibility. */
! #define COMPAT_VERSION_MASK 0xfffff00f  /* MNNFF00S,
major+minor+fix+status */
  #endif        /* OPENSSL_100 */

  #ifdef OPENSSL_098
--- 49,61 ----
  /* Different major/minor version or development version of OpenSSL
   * means ABI may break compatibility.
   * Modified by Adam Friedlander for OpenSSL >= 1.0.0
+  * (See opensslv.h> for OpenSSL version encoding details.)
   */
! #define COMPAT_VERSION_MASK 0xfff0000f  /* MNNffppS, major+minor+status */
  #else
  /* Different major/minor/fix/development (not patch) version of OpenSSL
   * means ABI may break compatibility. */
! #define COMPAT_VERSION_MASK 0xfffff00f  /* MNNFFppS, major+minor+fix+status */
  #endif        /* OPENSSL_100 */

          29 September 2022:

   Patches from Greg Troxel (most of these were for packagers, not me):

          + ckuath.c at about line 5530:

             if ((r = krb5_mk_rep(k5_context,
+#ifdef HEIMDAL
+                                  &auth_context,
+#else /* HEIMDAL */
                                   auth_context,
+#endif /* HEIMDAL */
                                   &outbuf))) {

          + ckupty.c at about line 91:

     Always use termios, never sgtty.h.
     \todo Explain this more clearly.

     This patch appears to be regularizing the use of TERMIO, following
     the package's inclusion of mk/termcap.buildlink3.mk. This is
     contrary to upstream's approach which uses each systems's native
     libs. Therefore, this patch should not be submitted to upstream.
            and then a lot of "#define USE_TERMIO" directives removed.
            Since I don't understand this patch, instead of removing the
            directives I put them within "#ifndef TERMIO_PATCH..#endif,
            which is not defined, but can be if needed.
          + ckuusx.c at about line 100: "This patch needs an explanation,
            and perhaps trying to build without it." Pending an
            explanation, I made it conditional on
            "#ifndef NO_INCLUDE_BSD44_ERRNO..#endif, which is not defined,
            but can be if needed.
          + A *big*, complicated patch for the makefile:
               o Don't override DESTDIR
               o Don't override prefix
               o Don't install the mysterious kermit-sshsub
               o Don't install kermit.ini in bindir, because it doesn't
                 belong there and because (yay!) it is empty, and people
                 don't need empty templates
               o Use DESTDIR harder when installing
               o Get K5LIB, K5INC, SSLLIB and SSLINC from pkgsrc.
            And some other assorted patches:
               o s/-lgssapi/-lgssapi_krb5/ on netbsd+krb5*
               o Add $(LIBS) to link command on
                 solaris2xg+openssl+zlib+pam+shadow
               o s@$(K5INC)/krb5@$(K5INC)/kerberosv5/ on
                 solaris9g+krb5+ssl
               o On linux get HAVE_LIBCURSES and HAVE_CURSES from pkgsrc
                 (with the curses include and library pathes coming from
                 BUILDLINK_*FLAGS).
            This one is one is still in the in-basket.

          Greg's patches can be seen here: [152]/ckpatches/filelist.html
          28 September 2022:

   A fatal compilation error, evident (so far) only on HP-UX 10: in
          ckuusr.c at line 12345, see this code:

#ifdef TYPEINTERPRET
        type_intrp = 0;                 /* Always start with this off */
#endif  /* TYPEINTERPRET */

     Move it down about 13 lines, below "#endif /* UNICODE */".

          This assignment statement is in the middle of a variable
          declaration list in the docmd() function. This should be an
          error everywhere but this code compiled cleanly on 25 different
          builds on other platforms, some of them with the strictest
          modern C compilers including clang and gcc -Wpedantic.

C-Kermit 10.0 Beta.05 (27 September 2022)

          27 September 2022:

    1. Moved BETATEST symbol definition from ckcmai.c to ckcdeb.h so it
       can be referenced in all C-Kermit modules, and moved
       #include ckcdeb.h higher up in in ckcmai.c, above the first
       #ifdef BETATEST reference.
    2. ckcdeb.h: Added NOSYSLOG to NODEPRECATED list (syslog is
       "deprecated" too).
    3. Updated the NEWS command.
    4. Changed version designation from Pre-Beta to Beta and version date
       to 27 September 2022.
    5. ckuus3.c 12328, printf %s missing an argument.
    6. ckuus5.c 8037, corrected printf %d to be %s.
    7. ckuus7.c 13110, corrected printf %ld to be %d.

   26 September 2022:

    1. ckcdeb.h: Removed the arrow-key feature from all platforms except
       Windows. Support for the API that detected arrow-key strokes is
       disappearing from one libc after another, so I might as well do it
       now for everybody. It's a small change near the top of ckcdeb.h,
       which (despite its name) is C-Kermit's primary header file. I
       removed -DNOARROWKEYS from all the makefile targets (and
       android.mk) that included it because now it happens automatically.
       If your platform (e.g. NetBSD or VMS) supports the API and you want
       the feature back, build C-Kermit with KFLAGS=‑DDOARROWKEYS.
    2. ckcmai.c: Straightened out some confusion with the program herald.
       There are two routines: makever() in ckcmai.c, and herald() in
       ckuus5.c. makever() creates PART of the version string but doesn't
       print anything. herald() creates another part of the version string
       and then prints both parts and some other stuff, and it also
       defines the builtin \v(herald) variable. For a hard-to-explain
       reason, we needed to have the herald text and \v(herald) defined
       BEFORE the initialization file was executed, but then not printed
       until AFTER the command-line arguments were processed so
       "kermit -H" (skip printing the herald) still worked. This required
       moving chunks of code from herald() to makever(). Modules changed:
       ckcmai.c, ckuus5.c, and ckuusy.c.
    3. ckcnet.c: "make xxx -DNORLOGIN" generated tons of errors. All the
       rlogin-related functions needed to be protected by
       #ifndef NORLOGIN..#endif. Lines 7180-7567: rlog_ini(), rlog_ctrl(),
       rlog_oob(), rlogoobh().
    4. ckuusx.c line 96: added prototypes for ck_tn_encrypting() and
       ck_tn_decrypting().
    5. ck_ssl.c ck_ssh_is_installed(): Added "return(0);" outside the
       #ifdefs to squelch "non-void function does not return a value"
       Clang warning.
    6. ckcnet.c: in http_security(), cipher =
       SSL_get_current_cipher(tls_http_con); needed to be:
       cipher = (SSL_CIPHER *)SSL_get_current_cipher(tls_http_con);
    7. ckuath.c: Added prototypes for encrypt_is_decrypting(),
       encrypt_request_end(), and get_crypt_table().
    8. ck_crp.c: about line 3876: removed "extern int
       encrypt_debug_mode;". It is not extern and it was already declared
       above.

   With changes 4-8 listed above, SSL builds generate no errors or
   warnings in OpenSSL 1.1.1d-fips 11 Feb 2013 (Red Hat 6.1) nor in
   OpenSSL 1.1.1f 11 Feb 2020 (Ubuntu 20.4.1). A few warnings are
   generated in OpenSSL 1.1.f 31 Mar 2020 on NetBSD 9.2. In all three
   cases compilation and linking succeed and a C-Kermit executable is
   produced.
   25 September 2022:

     * ckufio.c line 2486 "} else if errno {" should have been
       "} else if ( errno ) {" (fatal in AIX 15).
     * ckufio.c line 2474 "debug(F110,"zchki stat errmsg",ck_errstr(),"");
       final argument should have been 0.
     * ckctel.c lines 4679, 4681, 6014, 6221: fixes to address Clang
       10.0.1 complaints about signed vs unsigned char in Telnet code (but
       why does it complain at all if it was given the "-funsigned-char"
       directive?). This was also a problem in VMS.
     * ckuusr.c: changed 'if (s == "")' to 'if (s == (char *)0)' to
       silence Clang warnings.
     * ckuus3.c SHOW DIAL: suppressed "dangling else" warnings from Clang.
     * ckuus4.c in SHOW X25, SHOW PAD, SHOW TCP, SHOW TELNET, SHOW
       NETBIOS, SHOW NETWORK, etc etc: suppressed 155 "dangling else"
       warnings from Clang.
     * ckuus5.c at line 6915 is "} else {" and Clang insists this is a
       dangling else. I just don't see it. This was the only Clang warning
       in ckuus5.c.
     * ckuus6.c, "fixed" 8 dangling else's (in quotes because "dangling
       else" was not a crime when C-Kermit was first written. The
       structure and symantics of the IF statement were clearly spelled
       out by Kernighan and Ritchie. What good is a programming language
       that changes out from under its installed software base?)  With all
       this C-Kermit compiles with gcc -Wpedantic with no errors or
       wanings and with Clang 10.0.1 without errors and almost without
       warnings (there is still [153]this one but really, so what?).

   24 September 2022:

     * Merged David Goodwin's Windows changes from the past several months
       into my code, a large change involving 26 files: ckcasc.h,
       ckcdeb.h, ckcfn2.c, ckcfns.c, ckcftp.c, ckcker.h, ckcmai.c,
       ckcnet.c, ckcpro.w, ckctel.c, ckcuni.h, ckuath.c, ckucmd.c,
       ckudia.c, ckuscr.c, ckuus2.c, ckuus3.c, ckuus4.c, ckuus5.c,
       ckuus6.c, ckuus7.c, ckuusr.c, ckuusr.h, ckuusx.c, ckuusy.c,
       ckuver.h. The changes are listed on David's change log, which is
       here:
       [154]http://www.ext.zx.net.nz/software/notes/kermit95/#updates.
     * [155]Arrow-key support... The C-Kermit command parser has a
       scrollback buffer, and at the C-Kermit prompt you could always (and
       still can) use Ctrl-P to scroll up (to recall previous commands)
       and Ctrl-N to scroll back down. In C-Kermit 8.0 (2004) I added the
       ability to do this also with with the Up-arrow and Down-arrow keys,
       as people might expect. This relied on a somewhat obscure API. A
       few years ago this API was "deprecated", at least in Glibc. Now it
       seems to have been totally removed in some Linux distributions, and
       as a consequence C-Kermit builds fail. So I have to remove this
       feature. Honestly, I have no idea how widespread the problem is,
       but I do know it's present in Linux (on some, but not all,
       distributions; for example I see no problems on Ubuntu 20.04.1) and
       in Android. So to start I'm removing it in Linux and Android:
          + Before removing it, builds OK on Ubuntu 20.04.3 and arrow keys
            work
          + make linux KFLAGS=‑DNOARROWKEYS builds OK and arrow keys don't
            work
          + ckcdeb.h has arrow-key ifdefs
          + but so does ckucmd.h, why?
               o Removed these from ckucmd.h
               o Built normally ok, arrow keys work ok.
               o Built again with NOARROWKEYS, ok, and arrow keys don't
                 work.
               o So that clause did not need to be in ckucmd.h, so I
                 removed it.
          + Added -DNOARROWKEYS for Linux.
          + If you want to build for Linux *with* arrow-key support, do
            "make linux KFLAGS=‑DOARROWKEYS".
          + Added -DNOARROWKEYS to android.mk.
     * ALPINE LINUX HELP NEEDED: A user of [156]Alpine Linux (with
       [157]musl libc) reports that this C-Kermit version, although it
       builds normally ("make linux") and without complaint, does not work
       right: command keystrokes are not echoed until the Enter key is
       pressed. But without -DNOARROWKEYS, it doesn't build at all because
       the "obscure API" isn't there. Can anybody with Alpine Linux lend a
       hand?
     * Added comments to ckucmd.[ch] about its misnomer (it's really for
       all platforms, not just Unix).
     * Added askmore() (more-prompting) to COPY /TOSCREEN.
     * SHOW FILE command: if download directory not defined, say "(your
       current directory)" instead of "(none)" (ckuusr.c).
     * Checked what happens if I give CK a SET SEND PACKET 10 command and
       then send a file: it works perfectly - S and F packets are not
       truncated but data packets are the requested length.
     * HELP FUNC EVALUATE... improved help text (ckuus4.c)
     * \v(herald) was wrong, I fixed it, ckuus5.c: herald() routine.
     * ckcfn2.c: logpkt() - added a comment explaining the packet-log
       format.
     * New builtin variable \v(fullversion) = "10.0.400 Beta.05"
     * Added discriptive comment heading to ckuus5.c: cmcvtdate()
     * Adjusted \fcvtdate() to report date only if format arg is negative.
     * Adjusted HELP FUNC CVTDATE accordingly.
     * Corrected a glitch in HELP DATE text: ckuus2.c.
     * Cleaned up NEWS command a bit but needs work: ckuus2.c.

   19 September 2022:

     * Added new options to the COPY command: /TOSCREEN and /INTERPRET.
       Used together they do what TYPE /INTERPRET does everywhere except
       Windows: it displays a file on the screen with all its Kermit
       backslash-escapes replaced by their values, and it works in
       Windows. The code is mainly in ckuus6.c docopy().
     * I also fixed TYPE /INTERPRET so it clears the intepret bit after it
       finishes. Previously every subsequent TYPE command would act like
       it included an /INTERPRET switch.
     * Not C-Kermit specifically but I wrote a new document that updates
       the old and scattered information about Kermit packets: types,
       formats, encodings, block checks, short vs long, etc, everything in
       one place: [158]/kpackets.html.

   17 September 2022:

   ckcfns.c sdata():
    1. Even after the previous change, C-Kermit could send a long-format
       packet that was one byte too long; fixed in the obvious way.
    2. In tracking down this problem I also noticed that if I gave a SET
       RECEIVE PACKET-LENGTH or SET SEND PACKET-LENGTH command, this too
       could result in overlong packets in some cases. Fixed now.

   14 September 2022:

   ckcfns.c sdata():
    1. Reduced maximum send-packet data size (spsiz) for short packets
       from 94 to 90 to avoid edge cases which could cause the encoded
       packet length to be out of range, i.e. not a printable 7-bit
       US-ASCII character.

   ckcfn2.c spack():
    1. Added code to check whether Long Packet capability had been
       negotiated before deciding to build a long packet.
    2. Corrected an off-by-two error in calculating whether the packet
       would be have to be in long format.

   Before the previous two changes, file transfers from C-Kermit 10.0 (and
   some of the earlier 9.0.305 developement versions) to E-Kermit could
   fail. With the changes, they succeed. Also:

   ckcdeb.h:
    1. Disabled TYPE /INTERPRET on Windows until we can figure out how to
       make it work.

   ckcmai.c:
    1. Changed the numeric version number from 1000000 to 1000400, where
       the last three digits reflect the monotonically increasing edit
       number.

   23 August 2022:
     * I added a new option to the TYPE command: /INTERPRET. "type
       /interpret somefile.txt" displays the lines of the file with all
       Kermit backslash-escapes (variable references, etc) interpreted,
       i.e. replaced by their value. So for example, if you have a file
       hello.txt:
Welcome to \v(herald):
  \fpathname(\%0)
This message is coming to you from your C-Kermit initialization file:
  \fpathname(~/.kermrc)

       You can tell C-Kermit to "type /interpret hello.txt" and the result
       will be something like:
Welcome to C-Kermit 10.0 OPEN SOURCE: Beta.05, 23 Aug 2022:
  /net/u/1/f/fdc/beta05/wermit
This message is coming to you from your C-Kermit initialization file:
  /net/u/1/f/fdc/.kermrc

     * For the benefit of packagers who depended on the old version-number
       format, I reinstated C-Kermit's edit number, but not for public
       view. The new C-Kermit still announces itself as C-Kermit 10.0. To
       see the edit number use the new built-in variable: \v(fullversion):
(~/beta05/) C-Kermit>show variable fullversion
 \v(fullversion) = 10.0.400 Beta.05
(~/beta05/) C-Kermit>echo \v(fullversion)
 \v(fullversion) = 10.0.400 Beta.05
(~/beta05/) C-Kermit>

       Furthermore, the filenames of the tar and zip archives will be
       cku400.*, not cku10.0.* as they have been since 10.0 Beta.01, for
       conformity with all previous releases when they were cku300,
       cku301, cku302, etc; see [159]this page). Of course "400" could be
       "401" or any higher number as development progresses. Also the tar
       and zip archive filenames will include the edit number, [160]as
       they did before the first C-Kermit 10.0 Beta test.
     * A bug that prevented C-Kermit for Windows (CKW) from including the
       Beta-test in the program herald (\v(herald)) was corrected.

   19 August 2022: I removed all the code that supported special version
   numbers for (in chronological order) Mac Kermit (circa 1985), Kermit/2
   (for OS/2), and Kermit 95 (for MS Windows). From now all C-Kermits will
   identify themselves in the same way, for example:

     C-Kermit 10.0 OPEN SOURCE: Beta.05, 19 Aug 2022, for NetBSD 9.2
     (64-bit)

   17 August 2022: The [161]second Beta test of C-Kermit for Windows
   (formerly known as Kermit 95) was released. This work was done by
   [162]David Goodwin in New Zealand, and any changes he had to make to
   the non-Windows-specific modules will be incorporated into Beta.05.

   Meanwhile more Beta.04 builds on platforms where it was tested
   previously would be most welcome: macOS (including old versions),
   HP-UX, MINIX, Solaris versions before 11, etc, not to mention platforms
   where it has not yet been tested at all: FreeBSD, OpenBSD, AIX, plus
   any discontinued OS's that are still running somewhere: IRIX,
   Tru64/Digital Unix, 4.xBSD, NeXTSTEP, System V, DG/UX, SCO, QNX, SINIX,
   SunOS, Xenix, [163]etc etc).

  C-Kermit 10.0 Beta.04  (3 June 2022)

   In the (now) time-honored tradition of releasing a second Beta just
   hours after the first, here is Beta.04 (the curse of the odd-numbered
   Betas?).

   In Beta.03, two compilation errors that I fixed repeatedly -- at least
   one of them fatal -- somehow kept coming back. Senior confusion, no
   doubt... editing or uploading the wrong copy of the file. You can see
   why I'm anxious to get out of this business! The corrections for
   Beta.04 are:
    1. ckctel.c:
tn_ssbopt(TELOPT_NEWENVIRON,TELQUAL_SEND,(CHAR *)request,
           strlen((CHAR *)request)); /* 2022-01-27 */

       should be:
tn_ssbopt(TELOPT_NEWENVIRON,TELQUAL_SEND,request,
           strlen((char *)request)); /* SMS 2022-06-03 */

       Note EVERY makefile target should include the equivalent of
       gcc/clang -funsigned-char if available. Has anybody ever actually
       used *signed* chars??? (I haven't changed the makefile targets
       myself yet, but readers are welcome to do this for their platforms
       and report the results so I can incorporate the change where it
       works.)
    2. ckuusx.c:
ck_curpos(int row, col) {

       should be:
ck_curpos(int row, int col) {

       At least one of these (#2) prevented successful compilation on at
       least one platform (Raspberry pi OS).
       Incidentally, I find myself confused about pre-ANSI function
       argument list syntax. I see several forms in ckuusx.c:

    1.  int ck_curpos(row, col) int row, col; {...}
    2.  int ck_curpos(row, col) int row, int col; {...}
    3.  int ck_curpos(row, col) int row; int col; {...}

   Only the first one seems to be causing trouble in C-Kermit, even though
   it was allowed in K&R C (see pp. 23, 24, 54, and 58 of the original
   1978 C book). I see examples of (3) in the same book (e.g. pp. 60, 67,
   78), but I don't see examples of (2) in the book, and yet when when (1)
   caused problems and was changed to (2) the problem went away. For
   Beta.04 I'm going to err on the side of not making too many changes.

    About *s++;

   I also have a report that constructions like "*s++;" generates "Result
   unused" warnings in Clang, e.g. in ckclib.c about line 3190, but I
   don't believe that these are a problem. See the "C Bible", Kernighan
   and Ritchie, [164]The C Programming Language, Second Edition, Prentice
   Hall (1988), p.105. As one of the authors, Brian Kernighan, [165]said
   in 1974, "The '*s' returns a character; the '++' increments the pointer
   so we'll get the next character next time around. As you can see, as we
   make things more efficient, we also make them less clear. But '*s++' is
   an idiom so common that you have to know it." In this case, were
   toodling through a string character by character in a loop. So the
   result is unused only once. There are countless instances of this usage
   in the code and I doubt that the risk of changing them is worth any
   perceived benefit.

  C-Kermit 10.0 Beta.03

   C-Kermit is loaded with TCP/IP support code: Telnet, Rlogin, and FTP
   clients, Internet security methods including Kerberos and SSL, and on
   and on. This code serves little purpose in 2022 because there remain
   virtually no Telnet, Rlogin, or FTP servers to connect to, secure or
   otherwise. Thus it would seem desirable to be able to build a version
   of C-Kermit that includes no support at all for TCP/IP and its
   protocols and security methods and yet still can make SSH connections
   via the external ssh application. I spent the past three days on this;
   it required a massive reworking of the #if[n]def structure in ckcnet.c,
   ckctel.c, ckucmd.c, ckupty.c, ckutio.c, ckuus3.c, ckuus5.c, ckuus7.c,
   ckuusr.c, ckuusy.c, ck_ssl.c, as well as the ckcdeb.h header file (new
   -DNOTCPIP selector and improved -DNONET), and the makefile has
   corresponding new targets: "make linux-notcp" and "make netbsd-notcp".

   The "-notcp" builds still include support for other networking methods
   like X.25, DECnet, etc, which are also pretty hard to find in 2022, so
   I also added "-nonet" builds for Linux and NetBSD to exclude built-in
   support for all forms of networking. All of the new targets compile
   successfully and produce runnable binaries in these configurations that
   can still make ssh connections:

   CAPTION: C-Kermit 10.0 Beta.03, 02 June 2022: default, nonet, and notcp
   builds on Linux and NetBSD.

   OS and version Architecture Build Size Compiler Status Details
   Linux Red Hat 6.10 x86_64 make linux 2401216 gcc 4.4.7 OK No errors or
   warnings
   Linux Red Hat 6.10 x86_64 make linux-notcp 1949394 gcc 4.4.7 OK No
   errors or warnings
   Linux Red Hat 6.10 x86_64 make linux-nonet 1918181 gcc 4.4.7 OK No
   errors or warnings
   NetBSD 9.2 x86_64 make netbsd 2488936 gcc 7.5.0 OK No errors or
   warnings
   NetBSD 9.2 x86_64 make netbsd-notcp 2030944 gcc 7.5.0 OK No errors or
   warnings
   NetBSD 9.2 x86_64 make netbsd-nonet 2001544 gcc 7.5.0 OK No errors or
   warnings

   Also, many of the compilation warnings in Beta.01-02 have been fixed in
   Beta.03:
     * ckuus2.c: improved "help function cvtdate" text; fixed an unquoted
       backslash in "help date" text. 21 May 2022.
     * ckuus2.c: clarified "help function stripx" text, 20 May 2022.
     * makefile: Added -DNOWTMP to macos target to suppress "deprecated"
       warnings, 19 May 2022.
     * makefile: Added "linux-pedanditic" and "netbsd-pedantic" targets to
       check for warnings I normally wouldn't see. 18 May 2022.
     * ckctel.c, about line 4669: case TELOPT_NEWENVIRON: type casts
       straightened out (again), 17 May 2022.
     * ckuusx.c, stanza starting at line 4168 slightly rearranged to
       squelch another warning, 17 May 2022.
     * ckuusx.c, declaration of ck_curpos() and accompanying comment were
       malformed, causing compilation failure, fixed 5 May 2022.

   But some warnings remain. I wanted to get this Beta out today because
   I'll be pretty much "away from my desk" for the next couple weeks.
   Meanwhile the "install" and "uninstall" makefile targets will be
   improved to handle multilevel directories without depending on
   "mkdir -p" -- which isn't portable -- but not until after Beta.03.

   Finally Beta.03 includes a new CKVKER.COM build procedure for VMS that
   Adds support for the [166]VSI SSL3 product (from SMS).

C-Kermit 10.0 Beta.01 16 May 2022 and Beta.02 17 May 2022

   [[167]Changes since Alpha.07]   [[168]What's new in C-Kermit 10.0]

   Beta.02 corrects two fatal syntax errors in non-ANSI-C builds affecting
   only HP-UX. The rest of this section applies to both Beta.01 and
   Beta.02.

   The forthcoming new release of C-Kermit, expected "pretty soon" will be
   called 10.0 rather than 9.0.305, not so much because it's radically
   different from 9.0, but because (a) it's been over 10 years since the
   previous release and (b) it'll be my final release. Afterwards it can
   be further developed (or not) by the public via Github or whatever
   other collaborative Open-Source development methods supplant it.
   Meanwhile the previous test release, 9.0.305 Alpha.07, has proven to be
   [169]quite stable. The new release should function normally on most
   modern Unix variations (and hopefully older ones as well), and also on
   VMS versions 5.4 through 8.4. I realize there are some as-yet
   unresolved issues on Solaris but there's nothing I can do about them
   without access.

   WHY NOW?:
          I have an infinitely long To-Do list for C-Kermit but I think
          it's a good idea to release this version ASAP, simply because
          the last formal release (9.0.302) fails to build on so many
          platforms where it was [170]perfectly OK eleven years ago, due
          to changes in the underlying APIs, shuffling around of header
          files on different platforms and OS distributions, and changes
          in the C language and/or compilers. In fact, previous releases
          WILL NOT BUILD on most modern Linuxes due to a
          backwards-incompatible change in glibc. And even when they do
          produce an executable, it is only after issuing reams of
          warnings about constructions that used to be perfectly legal.
          Unix and C badly need a "stability layer" to keep programs
          working over the long term.

   ABOUT TEST BUILDS:
          During (and for decades prior to) the C-Kermit 9.0 development
          cycle in 2010-2011, I had direct access to over [171]200
          different Unix and VMS platforms for development and test
          builds, not to mention the other OS families. Now I have access
          to exactly three: NetBSD, Red Hat Linux, and Ubuntu Linux.
          Before a proper new C-Kermit release can be made, I'll need help
          from users of the other Linux distributions, and of Mac OS X,
          FreeBSD, OpenBSD, Minix, Android, and whatever other Unix
          varieties are still viable in the 2020s, plus (Open)VMS, as well
          OpenSSL and Kerberos (especially Heimdal) programmers if those
          security methods are to be carried forward.

   THE C-KERMIT MAKEFILE:
          The makefile has evolved from a single target (4.2BSD) in 1985
          into a nearly 9000-line monster with (at this writing) over 750
          targets. I haven't made any effort to "clean it up". The world
          is a big place, and who can say that there aren't still people
          out there running ancient versions of UNIX who might need a
          newer release of C-Kermit. Anyway it's like a Unix history
          museum. As is C-Kermit itself, with code to support all those
          ancient OS's: Bell Labs Unix V7, AT&T SVR3, 2.9BSD (16-bit!),
          Cray X/MP, DG/UX, DEC Ultrix, OSF/1, Venix, IX/370, NeXTstep,
          QNX, Xenix, DYNIX, SINIX, IRIX...

   ABOUT KERMIT 95:
          Almost all the changes noted in this document were made after
          the still-current release of [172]Kermit 95 for Windows, 2.1.3
          of 1 January 2011, which is based on C-Kermit; in fact it is the
          Windows version of C-Kermit, similar the Unix version and VMS
          version. Thus all the fixes and improvements described here are
          missing from K95 2.1.3 of 1 January 2011, but will magically
          appear in [173]any new release based upon the current C-Kermit
          source code.

    C-Kermit 10.0 Beta.01-02 changes since Alpha.07 [174]DOWNLOAD

   Aside from the new version number, the changes since Alpha.07 are
   modest.

    ▶ New features

     * Serial-port speed selections for 1000000, 2000000, 2500000,
       3000000, 3500000, and 4000000 bps, suggested by Pali Rohár. The new
       high speeds have not been tested because I no longer have a
       computer with serial port.
     * New VDIRECTORY command with 1-letter synonym V, a convenient alias
       for the DIRECTORY command (and a familiar one to old [175]DEC-20
       hands) (the very first Kermit program was written on the DEC-20 in
       1981).
     * New HELP COMPACT-SUBSTRING command to show the syntax for the
       compact substring notation that was added in C-Kermit 9.0.300.
     * HELP text improved for GREP, TRANSLATE, TOUCH /MODTIME, FREAD
       /TRIM, FUNCTION DIRECTORIES, FUNCTION FILEINFO.
     * New -DNODEPRECATED parameter for makefile KFLAGS to disinclude FTP,
       Telnet, and RLOGIN clients plus WTMP logging, all "deprecated" now.
       This saves only about 200K in the executable size.
     * New Makefile targets: New "list" target to list all targets and
       "count" target to show how many targets there are.

    ▶ Bugs fixed

     * (Beta.02 only) ckuusx.c, ckufio.c: correction of syntax errors
       affecting only non-ANSIC-C builds.
     * ckufio.c: Bug fixed affecting -DNOUUCP builds (such as Mac OS) when
       receiving a file in which C-Kermit created a bogus empty backup
       file (e.g. bug.txt.~1~). Reported and diagnosed by MacPorts port
       maintainer Lin Dongyu.
     * ckcfns.c, ckcfn2.c, ckcfn3.c, ckcpro.w: SET SEND PACKET-LENGTH
       applied to all packets when it should have applied only to Data
       packets, now it does [176]details here.
     * ckuus3.c: Bug fixed in S-Expression parser; "if (xx = 0)" should
       have been "if (xx == 0)" (did you know that C-Kermit had a
       [177]mini-LISP iterpreter built in?...  [178]What day is Easter in
       2033?)
     * ckcfns.c: The 'debug(F110,"sipkt rp","",rp);' statement in sipkt()
       had a bad argument list all these years.
     * Extraneous line in "help function tablelook" removed.
     * SET HOST command switch /TIMEOUT: was removed because the
       supporting code was never written.
     * Top-level DEBUG command that was added in C-Kermit 9.0 was removed
       because it never did anything and there was no help text for it.

    ▶ Compiler warnings hushed

   ... most of them issued only by the very picky Mac OS Clang compiler:
     * ckcftp.c: changed a long if-else-if.. (dangling else) sequence to a
       switch
     * ckctel.c: changed:
tn_ssbopt(TELOPT_NEWENVIRON,TELQUAL_SEND,request,
        strlen(request));

           to:
tn_ssbopt(TELOPT_NEWENVIRON,TELQUAL_SEND,(CHAR *)request,
        strlen((CHAR *)request)); /* 2022-01-27 */

       in hopes of silencing some "Pointers are not assignment-compatible"
       and "Argument #1 is not the correct type" warnings on a platform I
       don't have access to (HP-UX).

     * ckcpro.w: fixed 1 dangling else
     * ckuusr.c: fixed 7 dangling elses
     * ckuus2.c: fixed 1 dangling else
     * ckuus3.c: fixed 10 dangling elses
     * ckuus4.c: fixed 67 dangling elses
     * ckuus5.c: fixed 1 dangling else
     * ckuus6.c: fixed 1 dangling else
     * ckuus7.c: fixed 1 dangling else
     * ckuusx.c: Fixed several dummy ck_curpos() declarations to suppress
       warnings.
     * ckuusx.c: fixed 2 extraneous parentheses and 1 dangling else
     * ckcfn2.c: fixed 1 dangling else
     * ckutio.c: fixed 1 dangling else
     * makefile: added -Wdeprecated-declarations to macos target (for
       logwtmp)

   "Dangling else" is (or was) perfectly legal when used correctly; the C
   language was originally designed for use by people who knew what they
   were doing and was thoroughly documented by its authors, Kernighan and
   Ritchie, in a book (two really: original C and ANSI C). It makes no
   sense to keep changing this or any other programming language out from
   under all the millions of programs that have already been written in
   it.

  C-Kermit 10.0: Brief summary of new features since 9.0.302

     * An [179]essential adaptation to a change in Glibc 2.28 that broke
       C-Kermit and caused several major Linux distributions to drop it.
     * SET SPEED 1000000, 1500000, 2000000, 2500000, 3000000, 3500000, and
       4000000 for high serial-port speeds on platforms that support them.
     * Numerous updates for VMS/OpenVMS operating systems from 5.4 to 8.4,
       so it is not orphaned.
     * Adaptation to Android ([180]note) ([181]build)
     * [182]Unix only: New ability to run Kermit scripts in a pipeline,
       and to otherwise behave as a typical stdin/stdout/stderr program
       (example: the [183]html script).
     * New [184]CHANGE command for changing strings in external files.
       Like when you have a website with hundreds of pages in a whole
       directory tree that link to another website whose URL changed.
     * Unix makefile: new target make linux-nodeprecated to build C-Kermit
       without "deprecated" features such as FTP, Telnet, Rlogin, Wtmp
       logging, and ([185]explained below) arrow-key support.
     * And... the [186]guts of the command processor were almost totally
       rewritten to allow IF-command and function arguments to be entered
       in a natural way. Sounds scary but I tested the result by using it
       heavily over 17 months.

   Other changes:
     * TOUCH /MODTIME:xxx, like the Unix 'touch' command, sets a file's
       date. Works on single files, multiple files, and directory trees;
       many selection criteria are available.
     * Locale support for date formats, day and month names, system error
       messages, currency notaion, sorting and collation behavior, etc,
       plus the new functions \fdayname() and \fmonthname() that return
       the full name of the given day or month in the locale's language:
       [187]locale.html, [188]remind.html.
     * New variables: \v(year) = current year, \v(month) = current month
       (three letters), and \v(nmonth) = current month (numeric) to
       complete the set that already included \v(date), \v(day), and
       \v(nday), with \v(date), \v(day), and \v(month) rendered according
       to locale.
     * New IF conditions: NEQ, LLE, LGE, BINARY, TEXT.
     * Parsing of some REMOTE commands were broken, now fixed.
     * New (ECHO xxx) command for use within [189]LISP S-expressions.
     * New \ffileinfo() function to get all the information available
       about a given file, used by the [190]Photogallery script.
     * DIRECTORY /BRIEF /EXCEPT:xxx fixed (required for
       [191]Photogallery), e.g. "dir /brief /except:*-[tr].jpg
       /output:IMAGES *.jpg"
     * New \ffilecompare() function (tells whether two files are identical
       or differ, used in the [192]renamejpgs script).
     * Some new date formats for \fcvtdate(): [193]photogallery.html,
       [194]remind.html.
     * In response to Unix full path names getting longer and longer all
       the time: Improved fullscreen file-transfer display to show user's
       login directory as ~/ and to truncate too-long lines from the left
       rather than the right.
     * The current directory shown in C-Kermit's default prompt now also
       uses ~/ notation to save space.
     * Numerous code changes to integrate with [195]Kermit 95 source, a
       project that was active in 2013 but never completed. If you would
       like to have C-Kermit for Windows (previously known as Kermit 95 =
       K95) and you are a Windows programmer please ([196]CLICK HERE) to
       see how you can help.
     * Numerous adaptations to newer OpenSSL versions, but more work is
       needed if anyone is actually going to make SSL connections with
       C-Kermit.
     * Countless fixes and adaptations to newer Unix platforms, libraries,
       and C compilers. Described below from [197]HERE to [198]HERE...
       about 2000 lines of text. And also in the [199]abbreviated edit
       history found in the no-longer-appropriately named [200]C-Kermit
       Daily Source Archive page. This type of pointless busy work will
       never end.

   Reminder: details of each built-in function are shown by C-Kermit's
   HELP FUNCTION name command, e.g. "help function cvtdate" (or more
   briefly, "h fun cvtd").

    Current and pending issues

   Version number
          The new version number, 10.0, is a change in format. Previous
          version numbers had three parts, e.g. 9.0.304
          (major.minor.edit), the new one follows the modern two-part
          convention.

          However, "10.0" also pushes the number of digits in the built-in
          \v(version) variable from six (90304) to seven (1000000)
          (built-in \v() variables go back to about C-Kermit 5A(178),
          1992, 30 years ago at this writing). Scripts that use the
          \v(version) variable in comparisons, e.g.

if < \v(version) 900300 exit 1 "FATAL - C-Kermit 9.0.300 or later required."

          should be sure to use the numeric comparison operators (=, <,
          <=, >, >=, !=) and not the lexical ones (LLT, LLE, LGT, LGE),
          which worked for version number comparisons until now because
          they were all six digits.

          Future minor versions of C-Kermit should be 10.01, 10.02, etc
          (in case there might be more than ten of them), and the next
          major version should be 11.0. Note to future developers:
          C-Kermit's version numbers and dates are set near the top of
          ckcmai.c.

   Glibc conflicts
          C-Kermit has to multiplex simultaneous keyboard and
          communications i/o. The code for this has evolved over nearly 40
          years at this writing and it's rather complex. A big goal from
          the beginning was efficiency because in the early days Kermit
          might have been running on a very slow computer. Thus C-Kermit
          uses the buffered fopen()/getc() interface for less context
          switching than the bare metal open()/read() interface for each
          character. Kermit's approach was fine until I added support for
          [201]arrow keys in version 8.0 in 2003. Arrow keys are different
          from regular keys in that they generate multiple bytes instead
          of a single byte. So when there is a keyboard event Kermit has
          to peek ahead in the keyboard buffer to tell the difference, and
          if it's an arrow key, then Kermit "does something" rather than
          just transmitting the byte sequence, e.g. recalls the previous
          command. So far so good. But the API for peeking ahead is
          apparently offensive to the glibc people, and they are intent on
          removing it. The first step took place with (I think) glibc 2.28
          in 2018 and the result became manifest in 2021 as various Linux
          packagers like Debian and Ubuntu found that the then-current
          source C-Kermit code failed to compile. A workaround was found
          that fixed the problem, but the Gnu people don't approve of it
          and are determined to remove all possible ways of "poking around
          in stdio internals on *any* platform". They say that they will
          "consider" adding "musl-compatible __freadahead", whatever that
          is, maybe before they pull the plug on the current setup, maybe
          not. So the day will come when C-Kermit breaks again and then
          there will be four possibilities:

         1. Give up on arrow keys and rebuild C-Kermit with -DNOARROWKEYS
            (this has always been possible) or by adding -DNOARROWKEYS to
            the CFLAGS of any makefile target where glibc is used (e.g.
            [202]Linux, Hurd, and perhaps FreeBSD and NetBSD).
         2. Change thousands of lines of code to do single-byte instead of
            buffered reads as the Gnu people suggest, which will kill
            performance on old and slow platforms;
         3. Take advantage of the new __readahead thing (if it's
            appropriate) but only on platforms that have it, keeping the
            original readahead method for those that don't, via #ifdefs;
         4. The Linux application packagers will drop C-Kermit again.

          In the great scheme of things maybe arrow keys aren't so
          important, but who really knows? And then what happens when they
          change something else? The Gnu folks have a very narrow view.
          C-Kermit is not just a Linux program; in fact it predates Linux
          by six years. C-Kermit is portable among at least [203]nine
          different operating system families and at least [204]190
          different Unix varieties, the vast majority of which do not have
          Glibc. How can a total rewrite of C-Kermit's terminal i/o be
          tested on all those platforms? C-Kermit's code has been
          painfully, scrupulously designed to be portable among all those
          platforms. Most of them might be "legacy" now but that does not
          mean that they don't still exist and that people and companies
          and schools and government agencies don't depend on them for
          vital functions.

          In my view it is a CRIME to change an API when unknown numbers
          of programs rely on it and unknown numbers of people could
          depend on those programs. The entire world increasingly depends
          on software written in C for Unix, and particularly Linux. The
          absolute TOP priority for any new release of Linux or C or its
          libraries must be to preserve backwards compatibility so
          existing programs continue to compile, link, and work. This was
          a priority back in the days when software (including compilers)
          was mainly written by paid professionals who were responsible to
          -- and in touch with! -- their users. Today's Wild West software
          culture is not an improvement. Meanwhile I added a new target to
          the makefile:

make linux-nodeprecated

          do eliminate everything that has been deprecated (directly or
          indirectly) up to now: FTP, Telnet, Rlogin, Wtmp logging, and
          arrow-key support. I'm sure I must have missed a few; they can
          be added at the top of the ckcdeb.h file.

   Security methods
          For the major surviving Unix-based operating systems such as
          Linux, *BSD, and Mac OS, the main default makefile targets (e.g.
          "make linux") do NOT include any security features such as SSL
          or Kerberos and never have. Separate targets are provided for
          the desired kind of security code, e.g. "make linux+ssl", "make
          linux+krb5", "make linux+krb5+ssl". But C-Kermit's interfaces to
          OpenSSL, Kerberos, etc, are not necessarily up to date or even
          functional. SSL and Kerberos programmers are welcome to make
          fixes and I will incorporate them into subsequent 10.0 Betas. As
          of 10.0 Beta.01 these builds work on certain platforms but not
          on others, depending mainly on which SSL and Kerberos versions
          are installed on the host. Summary:

          + Kerberos IV and V support in Kermit should be up to date and
            solid, but many sites have switched from MIT Kerberos to
            Heimdal, which Kermit doesn't support, in which case builds
            such as "make linux+krb5" fail (some Heimdal code is present
            but evidently not enough).
          + Some adaptations to newer OpenSSL versions have been made but
            the target is moving too fast to keep up, and most builds such
            as "make linux+ssl" either fail or get tons of warnings.
          + Telnet and FTP servers secured by OpenSSL or Kerberos have
            vanished, and these were the whole reason that C-Kermit
            included these security methods.
          + The SSL and Kerberos code is still included in the source code
            if anybody cares to bring them up to date, presumably and
            preferably in a backwards-compatible way, so C-Kermit could be
            built with (e.g.) any version of OpenSSL, not just the latest
            one.

   WTMP log
          Apparently WTMP logging was "deprecated" in Macintosh OS at some
          point after C-Kermit 9.0 was released, resulting in "deprecated"
          warnings in ckufio.c. WTMP logging is (was) done when C-Kermit
          is running as a [205]Kermit Internet Service Daemon (IKSD,
          similar to an FTP server but better) to log the sessions it
          hosted. Presumably WTMP will disappear some day and then
          C-Kermit builds will get fatal errors and compile time or link
          time. Kermit can be built without IKSD (and WTMP) by including
          -DNOIKSD in the KFLAGS. It can be built with IKSD but without
          WTMP via -DNOWTMP.

   Internet Kermit Service Daemon
          IKSD was secured by Kerberos or OpenSSL or any of C-Kermit's
          other built-in security methods, but since all of those are now
          in limbo, at least in terms of C-Kermit's interface to them,
          IKSD is no longer very useful. Still, it was a good idea and an
          even better one now in light of the retirement of FTP service.
          It could be revived using the external ssh client on the end
          that makes the connection (e.g. "ssh somehost.org 1649"), and an
          ssh server on TCP port 1649 that starts C-Kermit with the
          [206]appropriate command-line options and with its stdin/out/err
          redirected to the ssh connection.

   Terminal emulation
          C-Kermit does not do terminal emulation. It simply writes
          incoming meterial to the screen, and passes your keystrokes
          along to the other computer. Terminal emulation is provided by
          the window in which C-Kermit is running. Normally this is not an
          issue, but one very handy feature that other terminal emulators
          (such as Kermit 95) have but C-Kermit lacks is key mapping ,
          where you can assign any key or key combination (e.g. Alt-h,
          Ctrl-Alt-Shift-q, F1, Insert, etc) to send (or do) whatever you
          want. C-Kermit can't do that because it doesn't know what keys
          you actually pressed because either (a) your keyboard is
          connected to a different computer than the one where C-Kermit is
          running, or (b) there is no reliable and portable Unix API for
          obtaining key events and scan codes. C-Kermit does, however,
          have a SET KEY command, but it works only with [207]ASCII keys
          (printable and control-characters).

          Unlike all the other C-Kermit versions (Unix, VMS, etc) C-Kermit
          for Windows -- previously known as Kermit 95 or simply K95 -- does
          do terminal emulation because it is running on the same computer
          your keyboard and screen are connected to, so it can capture
          keycodes and write to video. Let's hope C-Kermit for Windows
          (CKW) can be released some day soon; if you're a Windows C
          programmer and would like to help out, [208]CLICK HERE.

   Error messages
          C-Kermit's runtime error messages, especially those emanating
          from scripts, are particularly uninformative, as is the
          \v(lastcommand) variable. It's because some commands are
          executed by internally-defined macros composed of multiple
          commands, calling each other recursively. Also, a large chunk of
          code surrounded by { ... } in a script looks like a single
          command to the parser.

   Text blocks
          There has never been an intuitive way of assigning a multiline
          text block as the value of a macro. For example:

define sometext {
This is some text.
This is the second line.

The line above is empty.
  This line is indented.
This line is not.
}

          "echo \m(sometext)" shows leading and interline spaces
          eliminated, and the lines themselves are gathered into a single
          comma-separated-list. A whole new data structure would be
          required to accommodate multiline text blocks.

   Variable evaluation
          For historical reasons all \%x variables and \&x[] arrays are
          evaluated recursively. This is almost never desired and can
          wreak havoc when a value is a DOS or Windows pathname in which
          the directory separator is backslash. A "[209]set
          variable-evaluation" command was added in C-Kermit 9.0, with
          choices "recursive" (default) and "simple". The default can
          never be changed to "simple" because that could break countless
          scripts that actually take advantage of the original evaluation
          method. But if you are writing a script with no intention of
          recursing and want to avoid having your \%x and \&x[] variable
          values garbled, put:

     if >= \v(version) 900000 set variable-evaluation simple

          at the beginning of the script. That way if your script is
          processing external data that happens to contain any
          backslashes, nothing bad will happen. But if someone executes
          the same script with C-Kermit 8.0 or earlier the risk is still
          there. Of course your script could print a warning, or even
          require an appropriate C-Kermit version. Meanwhile even with
          recursion disabled globally you can still force recursion when
          needed with the \frecurse() function:

\frecurse(s1)
 s1 = name of \&x or \&x[] type variable
Returns the result of evaluating the variable recursively.

   Minor bugs
          TOUCH /MODTIME:datetime does not accept all different date-time
          formats, only numeric yyyy:mm:dd:hh:mm:ss or yyyy:mm:dd. The
          HELP TOUCH text was updated to say this.

    C-Kermit 9.0.305 Alpha.07 24 January 2022

   Only some minor changes this time, mainly to eliminate warnings from
   increasingly picky C compilers, e.g. "using the result of an assignment
   as a condition without parentheses" (which has always been perfectly
   legal), or "cast from pointer to integer of different size", etc. Some
   trouble with wait.h and time.h (where are they???): hopefully
   ameliorated, at least on some platforms. #include "ckuath.h" was
   omitted from three source files that needed it, and some
   ck_tn_enc_start/stop() routine references were misspelled, affecting
   only builds that included the optional SSL, Kerberos, or other security
   features.. A few missing text files were added to the tarball/zipfile
   so "make install" will work (not that you'd want to install an Alpha
   test, but somebody tried to and got the errors so...).

   This version builds with MIT Kerberos 5 but not with Heimdal Kerberos.
   No work has been done on OpenSSL either, C-Kermit builds ok with it on
   some platforms, gets lots of warnings on others but still seems to
   work, and fails to build at all on others. Anyone who cares about this
   and can rectify the situation is welcome to pitch in!

    C-Kermit 9.0.305 Alpha.06 15 December 2021

   C-Kermit was first written in 1987 in the version of C that was
   specified in the then-current first edition of The C Programming
   Language by Kernighan and Ritchie (Prentice-Hall 1978). As the language
   became more and more standardized (or less and less, depending how you
   look at it: C89, C90, C95, C99, C11, C17, C2x... -- as someone said,
   "The nice thing about standards is that there are so many to choose
   from")... it became possible to write the same code in different ways.
   For example, there was an "old way" and a "new way" to declare a
   function. In a later version of C, the compiler might complain if you
   did something the old way and, conversely, if you did the same thing
   the new way then compilation would fail with older compilers.

   A central principal of C-Kermit development is to keep all new releases
   backwards compatible, not only in its command repertoire but also in
   its compilability on every platform where it could be compiled before
   no matter how dated its C compiler might be. This is accomplished with
   a huge number of #ifdefs in the code; for example, every function is
   declared two different ways so it can be compiled by both old and new
   compilers.

   Backwards compatiblity was preserved through C-Kermit 9.0.302 of 2011.
   This was possible because the Internet was still open enough for
   developers to get access to hundreds of different platforms going back
   to the early 1980s (e.g. 4.2BSD Unix, Bell Research Unix v8, early
   Xenix versions). Those days are gone, and so now non-backwards
   compatible code can creep into C-Kermit unnoticed until compilation is
   attempted on some old platform that the developers have no access to.

   After the publication of C-Kermit 9.0.305 Alpha.05 such a platform was
   encountered and numerous problems uncovered: unprotected ANSI-style
   function declarations, initialization of automatic arrays, and even the
   use of C++ features, such as // to introduce single-line comments.
   These were caught when Peter Eichhorn, Assyst GmbH, Aschheim-Dornach,
   Germany, C-Kermit's Mr. HP-UX since the late 1980s, who is responsible
   for most of the HP-UX makefile targets, started doing HP-UX builds for
   the first time since 2011. It turns out the HP-UX compiler (HP C 76.3
   in this case) implements multiple C language definitions. By default it
   compiles in non-ANSI, non-optimizing, 1978 K&R C mode and complains
   loudly about any ANSI-C constructions it encounters, and then fails. A
   blessing in disguise, I'd say, since I no longer have access to any
   old-time machines or compilers to check backwards compatibility myself.
   So over the course of a week or two Peter found each problem
   (approximately one per day) and we fixed it. Hopefully, these fixes
   will allow builds on other pre-ANSI C platforms that C-Kermit has
   traditionally supported.

   Meanwhile, two important notes:
    1. C-Kermit's Kerberos support is now officially "deprecated". MIT has
       indicated that it no longer serves any purpose since no Kerberized
       Telnet or FTP servers are known to still be in service. The code
       won't be removed, and if anybody (including myself) can fix a
       problem, it will be fixed.
    2. Similarly, C-Kermit's OpenSSL support is also deprecated because no
       Telnet-S or SFTP servers are known to be in use any more, so there
       is no practical use for this code, even if it works. Unlike
       Kerberos, OpenSSL keeps shifting and changing out from under
       C-Kermit so that C-Kermit has adapted to each new OpenSSL release
       while still working with all the earlier ones. If someone other
       than me wants to take this on, fine, but it should not be done in a
       way that would break backwards compatibility with earlier OpenSSL
       releases; plenty of sites are still running 0.9xxx OpenSSL
       versions. The code will be left in place with little expectation
       that anybody will use it.

   Here are the changes in Alpha.06:
     * 15 Dec 2021:
       New makefile from Peter Eichhorn that enables successful
       compilation on both HP-UX 10.00 and 11.00. Makefile and main
       program dates changed 15 Dec 2021.
     * 10 Dec 2021:
       On HP-UX 10.00, error 'cc: "ckcuni.c", line 16153: warning 562:
       Redeclaration of "isunicode" with a different storage class
       specifier: "isunicode" will have internal linkage.' This suggests
       that the system header files have their own prototypes for some
       library routine or variable of the same name. So I changed all
       references to isunicode to ck_isunicode. Luckily C-Kermit has a
       command for that:

     change /list *.[ch] isunicode ck_isunicode
     * 9 Dec 2021:
       The hpux1000 makefile target (Hewlett-Packard Unix 10.00) build
       successfully for the first time, after much work. This was with HP
       C version 76.c and much assistance and detective work by Peter
       Eichhorn. A new directive -DNO_PTY_XOPEN_SOURCE was added to get
       arround problems caused by the #define _XOPEN_SOURCE 500 directive
       that was added in 2014 (several years after C-Kermit was last built
       on HP-UX 10.00), which in turn was added to get around some other
       problems.

     When building C-Kermit 9.0.305 Alpha.06 or later, if you get
     seemingly nonsensical error messages when compiling ckupty.c, add
     -DNO_PTY_XOPEN_SOURCE to the makefile target's KFLAGS and try again.
     If that doesn't do it, then remove pty support altogether with
     KFLAGS="-DNOPTY"; this also works with older C-Kermit versions, but
     it sacrifices C-Kermit's ability to make SSH connections.
     * 9 Dec 2021:
       ckuusy.c:1538: char xbuf[32] enlarged a bit to silence warnings.
     * 9 Dec 2021:
       ckcfns.c:3364: debug(F110,"sipkt rpar","",rp); had its last two
       arguments reversed.
     * 9 Dec 2021:
       ckuusr.c about line 7928 - changed this:
char * tags[] = { "_whi", "_for", "_sw_", "_if_" };

       to this:
static char * tags[] = { "_whi", "_for", "_sw_", "_if_" };

       In its earlier form, this statement would not be understood by a
       pre-ANSI C compiler, in which initialization of automatic arrays
       was not supported. This change is OK because the tags[] array is
       not referenced in any other modules.
     * 8 Dec 2021:
       Removed a Ctrl‑G character that was accidentally inserted into
       ckupty.c, and one remaining old-school formfeed (Ctrl‑L) in ckcfn2,
       found by Peter Eichhorn. Plus: Minor type or dimension mismatches
       between original and extern array declarations.
     * 7 Dec 2021:
       ckuusr.c: Enclose #include "ckuath.h" in #ifdef CK_AUTHENTICATION
       .. #endif. Given the 10+ modules that #include "ckuath.h" it might
       have made more sense to check this in ckuath.h itself, but all the
       modules bracketed the #include with ifdef
       CK_AUTHENTICATION..#endkf; ckuusr.c is the only one that didn't,
       and this caused failure in a non-ANSI compilation.
     * 7 Dec 2021:
       ckuus3.c: removed 19 C++-style single-line comments (//), which
       blow up old C compilers (or, in this case, modern ones operating in
       non-ANSI K&R) mode. (A pty is a psuedoterminal; Kermit's pty
       support is the basis of its SSH command, which lets you make secure
       SSH connections from C-Kermit to another computer; it also lets
       C-Kermit make a connection to a local application, such as Bash or
       EMACS.)

    C-Kermit 9.0.305 Alpha.05 14 November 2021

   As of December 6, 2021, 56 builds are listed in [210]this table; 48 of
   them successful, 8 of them failed.

     * 16 Nov 2021:
       Tony Nicholson reports clean builds of the November 14 code on:
          + macOS Catalina (10.15.7) x86_64 using "make macos"
          + macOS Monterey (12.0.1) arm64 using "make macos"
          + OpenVMS VAX V7.3 with Process Software Multinet 5.5 TCP/IP
            using @CKVKER "O"
          + OpenVMS Alpha V8.4-2L1 with Process Software Multinet 5.5
            TCP/IP using @CKVKER "O"
          + Raspberry PiOS-32 Buster (Debian 10) using "make linux"
       These are in addition to the succesful builds in the 14 November
       entry just below.
     * 14 Nov 2021:
       From William Bader:
       "Fedora 34 doesn't have the Heimdal version of kerberos, and
       ckuath.c had some sections that needed an ifdef." I applied the
       diff but result does not build on NetBSD: "com_err.h: No such file
       or directory".
       Couldn't build in on Ubuntu because I don't have krb5 installed.
       Build failed on Red Hat: "/usr/bin/ld: cannot find -lgssapi".
       I'm not super concerned about Kerberos or SSL because I have no
       evidence that anybody is using them in C-Kermit.
       From Steven Schweda:
       Removed the "#if 0" command in ckcdeb.h about line 6149, which is
       now extraneous. He also suggested removing the '#include
       "ckodir.h"' from ckuus6.c, but let's not do that until until we can
       once again check C-Kermit builds on MS Windows. He also suggested
       the printing of the MAXPATHLEN value in "show features" but it's
       not doing any harm, and until and unless CKMAXPATH can be 100%
       certified as the same thing, let's leave it in so at least we can
       check in case of any further confusion. Also he noticed some
       variations in the file permissions, now fixed. No functional
       changes.
       From Tony Nicholson:
       I've confirmed a few file transfers using the new version against
       CP/M Kermit-80 v4.11 and PDP-11 T3.63 running under RSTS/E V10.1
       (which has some extra fixes by Johnny Billquist on top of Brian
       Nelson's last version from the Kermit Archive). I'm using a USB to
       serial adapter (FTDI chipset) on my Mac minis to connect up via a
       LAT terminal server for my CP/M and PDP-11 tinkering as well as
       Kermit's built-in Telnet too.

       Kenji Rikitake reports clean builds of the November 7th upload on:
          + macOS 11.6.1 x86_64 with Xcode 13.1 (with the new target "make
            macos")
          + Ubuntu Linux 21.10 x86_64
          + Raspberry Pi OS kernel 5.10.63-v7l+ on Raspberry Pi 4B
       Steven Schweda reports clean builds on:
          + OpenVMS 8.4 on HP rx2600 IA64 (no SSL)
          + OpenVMS 8.4-2L3 on HP rx2660 IA64 (both with no SSL and
            vendor-supplied SSL 111 V1.1-1L based on OpenSSL 1.1.1l).
       William Bader got a clean build on:
          + Fedora 34 with non-Heimdal (MIT?) Kerberos
       I get clean builds (without SSL or Kerberos) on:
          + Red Hat Linux 6.1
          + Ubuntu Linux 20.04.1
          + NetBSD 9.2
     * 7 Nov 2021:
       From Tony Nicholson: a newline was required in ckutio.c at about
       line 2493 to indicate an empty statement. A patch to ckudia.c at
       line 4995 that I missed. For VMS, ckvker.mms was missing from the
       Zip file.
     * 6 Nov 2021:
       From Tony Nicholson in Australia, who put a great deal of effort
       into clearing warnings from Apple's LLVM Clang C compiler that I
       don't get with gcc, notably tons of "add explicit braces to avoid
       dangling else". The original code is correct and complies with the
       definition of the C language, but is now considered dangerous by
       zealots. Also several warnings about constructions like while (c =
       *s++) { ... }: "place parentheses around the assignment to silence
       this warning". What I don't understand is how large segments of the
       world's economy can be based on software written in a language that
       keeps changing out from underneath it.
          + makefile: Entirely new entries for macOS (new new name for
            Mac OS X and OS X). Use "make macos" on newer macOS versions;
            use "make macosx" for older ones. I'm not sure exactly where
            the cutoff is. Also an error in the linux entry where one of
            the "if test" clauses was missing the "if".
          + ckcftp.c: xx.os_specific = NUL; → xx.os_specific = ""; at
            about line 12575.
          + ckcmai.c: Added #include
            multinet_root:[multinet.include.sys]time.h For VMS systems
            with Multinet TCP/IP, instead of <time.h> and then don't
            comment out
          + ckcuni.c: Typo corrected at line 8268... if (c && 0xff80)
            should have been if (c & 0xff80).
          + ckucns.c: xx.typ = 0; xx.dsp = XYFZ_A; xx.os_specific = NUL; →
            xx.typ = 0; xx.dsp = XYFZ_A; xx.os_specific = ""; at line 469.
          + ckcdia.c: if (lbuf && *lbuf) → if (strlen(lbuf) > 0) at line
            4994.
          + ckcdia.c: Several corrections in the "mymdmtype" section.
          + ckuusr.c: Added missing "#include ckuath.h" for Kerberos
            builds.
          + ckuus6.c: Supplied a missing %s for printf("?Modtime error on
            backup file:") about line 6303.
          + ckuusx.c: For newer macOS's in the termcap-related #ifdefs
            starting around line 30, #include <curses.h>.
          + ckutio.c: added missing semicolon after "for (p = ttname;
            isdigit(*p); p++)" at line 2490 (but I had already done that)
          + In several modules the only change was an insertion of a blank
            line; I left those as-was: ckuus2.c ckcpro.w.
       Tony says, "I've managed to eliminate all but two warnings when
       compiled under macOS Catalina (10.15.7) on a x86_64 Mac mini, and
       under macOS Monterey (12.0.1) on an arm64 Mac mini. The remaining
       warnings are to do with use of a deprecated logwtmp() routine --
       still present in the current version of macOS."
     * 6 Nov 2021:
       From Steven Schweda, patches for: Compaq OpenVMS VAX V7.3, VSI
       OpenVMS AXP V8.4-2L1, andVSI OpenVMS V8.4-2L3 for Integrity, sent
       via Tony:
         1. An entirely new ckvker.com (DCL build procedure, the "VMS
            makefile").
         2. An entirely new ckvfio.c module.
         3. ckcdeb.h: A comment about the definition of MAXPATHLEN (or
            lack of it) on VMS, clarifying a previous comment that is
            still there but "#ifdef 0"'d.
         4. ckctel.c: Two references to MAXPATHLEN changed to CKMAXPATH
            (explained in ckcdeb.h comment).
         5. ckufio.c: A reference to MAXPATHLEN in a comment at line 7436
            changed to CKMAXPATH.
         6. ckuus3.c: Two reference to MAXPATHLEN in a stanza around line
            12200 changed to CKMAXPATH.
         7. ckuus4.c: An allusion to MAXPATHLEN appears in a comment about
            line 64; I clarified that this section applies only for Kermit
            95 for MS Windows and IBM OS/2 and didn't change it because
            OS/2-specific modules probably still use MAXPATHLEN rather
            than CKMAXPATH but we can deal with that if ever
            [211]development on K95 resumes. Also, two references to
            MAXPATHLEN around line 10420 were changed to CKMAXPATH. A
            misplaced #endif matching #ifndef VMS at line 13942 was moved
            two statements down, where it should have been.
         8. in ckuus5.c at about line 10344 in the SHOW FEATURES code;
            Steven changed MAXPATHLEN to CKMAXPATH, but I left the
            original and then added a new one for CKMAXPATH; this might be
            more helpful for troubleshooting.
         9. ckuus6.c: "???" by #include ckodir.h in an
            OS/2-Windows-specific section, same as in item 7 above.
            Changed all 17 other occurrences of MAXPATHLEN to CKMAXPATH.
        10. Corrected two misspellings of "weird" in comments.
     * 1 Nov 2021:
       From Tony Nicholson, in ckcdeb.h, about line 6143:
#ifndef MAXPATHLEN
def MAXPATHLEN 1024
#endif  /* MAXPATHLEN */

       should have been:
#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif  /* MAXPATHLEN */

       How'd that happen!
     * 26-29 Oct 2021:
       Bug: Reported by Jacques Charreyron: when C-Kermit was told to SET
       SEND PACKET-LENGTH 10 (by mistake, as it happens), the file that
       was sent (very slowly) arrived with its name truncated.
       Background: The SET SEND PACKET-LENGTH command is a relic of the
       days files were transferred over extremely sensitive and unreliable
       connections such as a noisy telephone line before the days of
       high-speed flow-controlled error-correcting modems (let alone the
       Internet). The longer a packet, the greater the chance of
       corruption by noise. The SET SEND PACKET-LENGTH command was a way
       to force a file through at a cost in efficiency.
       Analysis: This feature was implemented with insufficient thought:
       it limited the length of ALL sent packets including the
       "administrative" ones like those used for feature negotiation at
       the beginning of the transfer and for the filename. It doesn't
       matter what length file data packets are because each one carries
       just a piece of the file, and they are all reassembled by the
       receiver. But the protocol does not allow feature-negotiation
       strings or filenames to be split up over multiple packets. Maybe it
       should have.
       So now C-Kermit has been changed to apply the SEND PACKET-LENGTH
       setting only to outbound file Data packets. This is a rather
       fundamental change that, in a sense, has an impact on the
       definition of the protocol if only by making explicit the
       difference between administrative and data packets.
       The feature negotiation packets are about 30 characters (bytes)
       long and have never presented a problem. However, a filename can be
       any length at all. If it is longer than about 90 characters, it can
       be sent only in a long packet with prior permission from the file
       receiver, allowing file names up to about 9000 characters in
       length. If the filename is longer than the negotiated limit, even
       with today's fix, it is truncated. The fix, however, means that if
       the receiving Kermit doesn't support long packets, filenames longer
       than about 88 characters are truncated. This hardly ever happens in
       practice because filenames are rarely that long.
       But the story doesn't stop there because the file receiver can (but
       is not required to) send the name under which it stores the
       incoming file, perhaps including the path, so the user knows
       exactly how to find it on the receiving computer. This might be
       considerably longer than the original if it includes a path, such
       as:
       /net/w/0/htdocs/fdc/kermitproject/ftp/kermit/archives/
       (That's a typical path on one of the computers I use.) The pathname
       can also be included in the sender's filename packet if you SEND
       /PATHNAMES:ABSOLUTE. But apparently nobody does this in combination
       with SET SEND PATHNAME-LENGTH because I have never received a
       complaint.
       The fact that it took 40 years for this problem to surface does not
       suggest a looming crisis and anyway, it's too late to change the
       protocol. Meanwhile, if we start having problems with very long
       filenames, various approaches are possible, such as:
          + Do nothing; let long names be truncated. This could result in
            files overwriting each other; for example, a series of files
            whose names have the same first 100 characters, followed by a
            serial number. Overwriting in a case like this can be avoided
            with an appropriate SET FILE COLLISION command on the
            receiving end.
          + Have the file sender convert too-long names into shorter names
            that are likely unique; for example, random sequences of
            letters and digits. In this case the user would have to pay
            attention to Kermit's messages to be able to identify the file
            on the receiving end, or to LOG TRANSACTIONS to have a record.
       Disposition: C-Kermit code was changed to make the SET SEND
       PACKET-LENGTH value apply only to outbound Data packets. Modules
       affected: ckcfns.c, ckcfn2.c, ckcfn3.c, ckcpro.w.
     * 13 Oct 2021:
       Changed "%d" in sprintf(vvbuf,"%d",crc16); in nvlook() to "%ld" to
       agree with type change of crc16 from int to long on 8 Oct 2020.
       ckuusr.c.
     * 13 Oct 2021:
       Added serial-port speed of 1500000 bps (1.5MHz), from Elad Lahav.
       Enabled for Linux and QNX. ckcdeb.h, ckutio.c, ckuus3.c.
     * 13 Oct 2021:
       Ao Huang noticed a problem when sending a binary file over a Telnet
       connection using XMODEM external protocol via the sx application:
       if the data contains a 0xff byte (which is also Telnet IAC), it is
       doubled as it should be, but the next byte is skipped. Fixed in
       ckutio.c ttptycmd() about line 14998.
     * 30 Sep 2021:
       From Sébastien Villemot; a printw() statement was changed to
       fputs() to avoid gcc -Wformat -Werror=format-security warning on
       Debian. ckuusx.c,
     * 8 May 2021:
       From Kenji Rikitake, for modern Macintoshes (say, after Mac OS X
       10.12?): in ckuusx.c in the termcap-related #ifdefs starting around
       line 30, #include <term.h>.

    C-Kermit 9.0.305 Alpha.04 14 September 2021

   The following C-Kermit source files specific to the VMS version:

ckvold.c
ckvcvt.c
ckvrtl.c
ckvcon.c
ckvioc.c

   in my working directory on Unix had lines terminated in CRLF (Carriage
   Return and Line Feed), which is appropriate for VMS, but not on a Unix
   file system. The install script created a Zip file that converted *all*
   source files to VMS format, but since these were already in VMS format
   and the zip program wasn't smart enough to recognize this, the copies
   of these files in the Zip archive were corrupted. Thanks to David
   Hittner for noticing and diagnosing the problem. 14 Sep 2021.

   Also corrected a number warnings from the VMS C compiler reported by
   David Hittner, who is attempting to revive C-Kermit for VMS, including
   the new x86-64 version:
     * Reference to uninitialized 'ss' variable in a debug() statement in
       ckclib.c cksplit().
     * The MAXPATHLEN symbol came up undefined in ckuus4 fneval() so I
       added a catch-all definition for it in ckcdeb.h for when, after
       including all the other header files where it should be defined,
       it's still not defined. I arbitrarily chose 1024 as the value; this
       might need tuning. This change also fixes an error in the
       declaration of chgsourcedir[] in ckuus6.c
     * Variable "linkname" not declared in ckuus4.c fneval for
       \ffileinfo(). This is not surprising since VMS doesn't have file
       links. Rearranged the code so looking for a link happens only in
       Unix.
     * ckuus5.c evalmacroarg() changed from int to VOID because it doesn't
       return a value.
     * ckuus6.c domydir() CHANGE command code error message "not a text
       file" was missing the filname argument.
     * ckuus6.c domydir() CHANGE command code symbol STRDIRSEP was not
       defined for VMS -- an oversight; fixed in ckcdeb.h.
     * ckuus6.c domydir() CHANGE command code modtime error message too
       many arguments; added missing %s.
     * ckuus6.c boolexp(): another missing conversion specifier in a
       printf.
     * ckvtio.c ttflui(): "while ((n--) && xx_inc(2) >= 0) ; /* Ignore
       Warning - see comments */" (see comment in source code).

   Updated version and date info in ckcmai.c. 14 Sep 2021

    C-Kermit 9.0.305 Alpha.03  (THIS ONE WASN'T UPLOADED)

     * The "extern int errno;" declaration included by default for many
       non-Glibc Unixes has become a big problem. So I added a symbol
       DCL_ERRNO that can be defined in any desired makefile target,
       otherwise the declaration is omitted except on some old platforms
       where it has always been needed (e.g. some old Cray
       supercomputers). In the "linux" makefile target (which is supposed
       to work for ALL versions of Linux back to Day Zero), I added a
       stanza to check whether errno was declared in any header file and
       then only if it is not, to include DCL_ERRNO in the compilation
       flags at make time. This is in case any old, old Linux releases did
       not declare it (which I doubt) but anyway now this stanza can be
       added to other targets where errno might or might not be declared
       in the header files, or in any other anomolous cases. Or you can
       just include it in your 'make' command:
           make targetname KFLAGS=‑DDCL_ERRNO
       Note that -DDCL_ERRNO results in "extern int errno;", and so is
       mainly appropriate for old platforms where errno is, indeed, an
       integer. In any case, after the special cases (CRAY, STRATUS,
       glibc), if DCL_ERRNO is not defined then we "#include <errno.h>".
       Modules affected: ckcdeb.h, makefile, 7 October 2020.
     * Removed "extern int errno.h" conditionalized for VMS from ckcfns.c
       because this was already handled in ckcdeb.h, which is included by
       every C-Kermit module. Note that many other modules already include
       errno.h: ckcftp.c, ckcnet.c, ckcnet.h, ckuath.c, ckucmd.c,
       ckucns.c, ckucon.c, ckufio.c, ckupty.h, ckutio.c, ckuus4.c,
       ckuus6.c, ckuus7.c, ckuusx.c. Better not to touch these unless
       conflicts arise, and rely on the header file's normal protection
       against multiple inclusion. ckcfns.c, 8 Oct 2020.
     * In the code for the SET SSL CIPHER-LIST and SHOW AUTHENTICATION
       commands, changed the SSL_METHOD function from TLSv1_method() to
       SSLv23_method(). Patch from "$NetBSD: patch-ckuus3.c,v 1.1
       2020/04/08 15:22:07 rhialto Exp $". ckuus3.c, ckuus7.c, 8 Oct 2020.
     * Changed extern int crc16 to extern long crc16 in ckuus4.c. Patch
       from "$NetBSD: patch-ckuus4.c,v 1.1 2019/04/11 02:21:09 mrg Exp $".
     * Updated ckuusr.c edit number and date, because ckuus3.c and
       ckuus7.c are just two of nine parts of what was originally a single
       module. 8 Oct 2020.
     * Updated C-Kermit's date and Alpha level. ckcmai.c, 8 Oct 2020.

    C-Kermit 9.0.305 Alpha.02 19 September 2020

   From Sébastien Villemot (Debian): Remove clauses from the linux+krb5,
   linux+ssl, and linux+krb5+ssl makefile targets that tested to see if an
   executable was actually created, because they violate Debian policy.
   makefile, 18 September 2020.

   From Sébastien Villemot (Debian): Add another "else if" to the search
   for the Kerberos 5 com_err library for Multiarch systems. makefile, 18
   September 2020.

   Addressed warnings issued by gcc 9.3.0 on Ubuntu 20.04.1:
    1. sprintf() into a buffer declared to be 10 bytes long when values
       could (but never would) overflow it: function hhmmss(); increased
       the buffer size to 60. ckclib.c, 18 Sep 2020. NOTE: there were many
       warnings like this. In almost every case the code prechecked the
       length of data to be moved into the buffer. These warnings forced
       me to make buffers bigger unnecessarily. But why don't I just use
       snprintf()?  Because C-Kermit is supposed to build on hundreds of
       different platforms, some dating back to before there was an
       snprintf().
    2. Same thing for obuf[] in function shuffledate() (six times) and
       once for tmpbuf[] in function cmcvtdate(). ckucmd.c, 18 Sep 2020.
    3. Same thing for xbuf[] in a debug clause in doinput() (even though
       the warning was erroneous because it claimed the buffer size was 9
       when it was 24). ckuus4.c, 18 Sep 2020.
    4. Same thing for dbuf[] in function domydir(). ckuus6.c, 18 Sep 2020.
    5. Complaints about implicit definitions of tgetent(), tgetstr(),
       tputs(), and tgoto() in the curses-related routines fxdinit(),
       ck_termset(), ck_curpos(). [212]See notes below. I had the
       prototypes commented out because they caused problems on some
       platforms. Uncommenting causes disaster on Red Hat, NetBSD, etc. I
       had to add a clause to the linux target that looks in /etc/issue
       for "Ubuntu" or "Debian" and if found defines a special symbol,
       NEEDCURSESPROTOTYPES. makefile, 18 Sep 2020.
    6. getslot() needed a prototype. ckuusx, 18 Sep 2020.
    7. Within getslot() ftruncate() needed a cast to void. ckuusx, 18 Sep
       2020.
    8. The ages-old dilemma... what type is main()? Haven't had this
       complaint in decades. Replaced the #ifdef mess with something much
       simpler: if it's OS/2 or Windows, void; otherwise int, period.
       ckwart.c, 18 Sep 2020.
    9. Another sprintf() buffer issue corrected in snddir(). ckcfns.c, 18
       Sep 2020.
   10. Implicit declaration of openpty(). I never needed to declare it
       before. Ubuntu says I need to include <pty.h>. I added a new stanza
       to the Linux target to include <pty.h> if it exists. makefile, 18
       Sep 2020. (this should also eliminate the warning from pty_getpty()
       in ckupty.c)
   11. Commented out "system(ttname);", which raised an implicit
       declaration complaint. I can't even imagine what this statement was
       supposed to do. ttopen() in ckutio.c, 18 Sep 2020.
   12. Bogus complaint about how I was using the return value of link() in
       ttlock(). Recoded it. ckutio.c, 18 Sep 2020.
   13. Fixed a write() statement in zclose() and ftruncate() call in
       logwtmp() to not ignore their return values. ckufio.c, 18 Sep 2020.
   14. Added #include <sys/wait.h> within #ifdef __NetBSD__ .. #endif.
       (even though "man 2 wait" says "<wait.h>". ckufio.c, 19 Sep 2020.
   15. Added #include <util.h> to __NetBSD__ section of ckcdeb.h to fix
       implicit declaration warning for openpty() in ckupty.c and
       ckupty.c. 19 Sep 2020.
   16. Updated version to 9.0.305 Alpha.02 and updated EDITDATE and
       EDITNDATE. ckcmai.c, 19 Sep 2020.
   17. Increased yyyymmdd[] buffer length in cmcvtdate(): ckucmd.c, 19 Sep
       2020.
   18. Doubled the size of linebuf[] in domydir() because one sprintf()
       was putting some extra stuff in it. ckuus6.c, 19 Sep 2020.
   19. Added #ifdefs relating to openpty() to ckcdeb.h because openpty()
       is used in several modules. Tested only in Linux and NetBSD. 19 Sep
       2020.
   20. Casting to void did not suppress some "return value ignored"
       warnings -- write(), ftruncate() -- so I did "dummy = xxx();".
       getslot(), ckuusx.c, 19 Sep 2020.

   The result builds with no warnings or errors on NetBSD 9.0, Red Hat
   6.1, and Ubuntu 20.04.1. It also builds on Red Hat 6.1 with OpenSSL
   1.0.1 with one minor warning, which is OK for now because a lot of work
   on the OpenSSL support is on the agenda, most notably adaptation to
   OpenSSL 1.1, which is not compatible with 1.0 (which, as I recall, was
   supposed to have an API that would be stable for all eternity).

    9.0.305 Alpha.01 24 Jul 2020

   Alpha test for an emergency C-Kermit release because GNU removed the
   symbol "__FILE_defined" (which Kermit uses on glibc systems for stdin
   buffer-peeking) from its stdio headers, thus breaking C-Kermit builds
   on all platforms that use glibc. C-Kermit was pulled from at least the
   Debian and Ubuntu distributions because of this, as opposed to (say)
   contacting me so I could address the problem; I found out about it from
   Debian and Ubuntu users who found that C-Kermit had silently
   disappeared from apt-get libraries. The small change added to this
   Alpha version allows C-Kermit to be built in the normal way ("make
   linux"). Operational testing is needed on all glibc systems, and then
   hopefully C-Kermit can be added back to the distributions again, and it
   will also have a lot of new features, improvements, and fixes since the
   last release, 9.0.302 in August 2011.

   Modules changed:  ckucmd.c, ckcmai.c.
   Date: 24 Jul 2020.
   Results:

   Platform No security OpenSSL Kerberos 5
   Red Hat Linux 6.1 / OpenSSL 1.0.1e OK (no warnings) OK (no warnings)
   (libs not installed)
   NetBSD 9.0 / OpenSSL 1.1.1d OK (no warnings) Fails (many warnings)
   (libs not installed)
   Ubuntu Linux 20.04.1 / OpenSSL 1.1.1f OK (many warnings) Fails (many
   warnings) (libs not installed)

   Note:  This version was placed back in the Debian distribution 17
   September 2020, but "will take some time before the package hits the
   Debian repositories because it needs to get manually approved, since it
   is a package reintroduction. Further updates will be much faster."

    9.0.304 Dev.24 25 Apr 2020

   Under certain circumstances, the CHANGE command could cause a
   segmentation fault. Diagnosis: a variable (k) was incremented before it
   was initialized. - domydir(), ckuus6.c, 25 April 2020.

   The cmcvtdate() routine in ckucmd.c has been there since 2000 (C-Kermit
   7.0); its purpose is to parse free-format date-times (possibly
   including offests and/or timezones) and convert them into canonical
   local-timezone date-times. It's used by the DATE command and also by
   any other command than can parse date-times, and by the script language
   \fcvtdate() function. Among the many formats I thought it was supposed
   to understand is the one used in Apache weblogs: yyyy:mm:dd:hh:mm:ss.
   Apparently this has never worked. I changed the cmcvtdate() routine
   (and thus the DATE command and the \fcvtdate() function) to preprocess
   its argument and strip the colons from any dates in this format before
   proceeding. ckucmd.c, ckcmai.c, 25 Apr 2020.

    9.0.304 Dev.23 4 Sep 2018 (announced 31 Jan 2020)

   It was annoying me that constructions like:

if \findex(not rated,\m(line)) {
    .line := \freplace(\m(line),not rated,sin ranking)
}

   failed with a message like "?<ERROR:MISSING_ARG:\findex()>". This has
   been the case forever. The standard advice was to work around in ways
   like this:

.x := \findex(not rated,\m(line))
if x .line := \freplace(\m(line),not rated, sin ranking)

   or:

if \findex(not\32rated,\m(line)) {
    .line := \freplace(\m(line),not rated, sin ranking)
}

   or:

.notrated = not rated
if \findex(\m(notrated),\m(line)) {
    .line := \freplace(\m(line),not rated, sin ranking)
}

   The IF command expects a keyword, a symbol, a number, or a "field", and
   therefore breaks on the first space. This is not a problem only with
   the IF command, nor only with the \findex() function; the same thing
   happens in any context where a "word" is expected and you include a
   \function() invocation that has spaces in its argument list. A
   universal fix was required at the very deepest level of the command
   parser: a state machine that recognizes function calls and prevents any
   blanks contained in their argument lists from triggering a premature
   word break. Now you can write function calls consistently in any
   context, no matter whether they contain spaces or not. The new code was
   added to gtword() and setatm() in ckucmd.c, enclosed in #ifdef
   FUNCTIONTEST..#endif, which is defined at the top of the file. 3-4
   September 2018. By the way, doing this revealed significant unnecessary
   duplication of effort between gtword() and setatm(), not worth fixing
   at this late date.

   CHANGE /COUNT:variablename always set the variable to 0 or 1, where it
   should have set it to the number of changes that it made. Diagnosis: it
   was sharing too much code with DIRECTORY /COUNT. Fixed in ckuus6.c, 8
   May 2017.

   Changed copyright year to 2018. ckcmai.c, 10 August 2018.

   CHANGE command: Got rid of the "Would create temp file" message, it
   overwhelms all the other feedback. ckuus6.c, 10 August 2018.

   \fpictureinfo(s[,&a]) apparently never has worked for getting the
   orientation of a JPG that comes straight out of a camera (or certain
   cameras). The reason I never noticed this is that I almost always run
   every image in a gallery through Photoshop first. Kermit only looks at
   the ImageLength (i.e. height) and ImageWidth Exif items, but in the
   camera's files they are the same for all orientations; the actual
   orientation is given by the Exif Orientation tag. Photoshop uses this
   to orient the picture properly when loading it, and sets the width and
   height correctly on writing it out.

   But there is nothing Kermit can do about this; even if I could figure
   out how to find the Orientation tag, what would I do with it?
   Eventually it dawned on me that the right place to handle this (to fix
   the problem when it occurs in the [213]Photogallery script) was on the
   Imagemagick command line. Simply adding -auto-orient did the trick.
   Photogallery 2.14, 21 Jul 2017. No changes to Kermit. But if there were
   an EXIF library for Unix...

   Fixed Lisp (ROUND -5.6666 2), it was losing the minus sign (result 5.67
   instead of -5.67). ckcklib.c, 19 July 2017.

   Added a new option to \freplace(): a 5th argument specifying "word
   mode", meaning that the target string will be replaced only if it's a
   "word", i.e. surrounded by whitespace or punctuation, etc, so as to
   avoid the case where the target word happens to also be a substring of
   other words. For example, changing the word "a" to the word "the"
   without changing all the other letter a's to "the". That would be
   simple enough but I also wanted to handle things like replacing "--" by
   &mdash; and "..." by &hellip; (for the html-to-text script). Added 4
   new routines -- isalphanum(string), cisalphanum(char),
   nonalphanum(string), cnonalphanum(string) -- which the \freplace() code
   uses to check the context of the target string. All of the new code is
   in #ifdef RPLWORDMODE..#endif, so can easily be deselected if
   necessary. ckuus[24].c, 5-7 Oct 2017.

   Simplified "hints" given after a GET command failed. ckuus5.c, 8 Oct
   2017.

   I used this C-Kermit version myself continuously for 17 months with a
   ton of heavy-duty scripting and a great deal of testing on NetBSD and
   Red Hat Linux, finally installed it on the FTP server and announced it.
   31 January 2020

    9.0.304 Dev.22

   Fixed \fcode() to not throw errors if given an empty string (or nothing
   at all) as an argument. ckuus4.c, 22 Apr 2017.

   In the parser for DO command (macro invocation)... Prior to C-Kermit
   9.0.304 Dev.22, cmtxt() was called in all cases with zzstring. But this
   fouled up the identification of macro arguments when their values
   contained grouping characters such as doublequotes and braces. I
   changed the cmtxt() evaluation function pointer from zzstring to NULL,
   so we get a correct list of arguments, and then changed xwords (which
   was a big mess) to evaluate each one. I made a new evalmacroargument()
   routine for this, because xwords() needed to do this in about five
   places. ckuusr.c, ckuus5.c, 24 Apr 2017.

   Added a new routine newerrmsg(s); that prints an error message, and if
   it's from a command file, it shows the line number where the command
   started and the first part of the command (hence the need for
   snprintf(), to make the assembled message fit on one line). While
   working on xwords() I realized that the whole big mess was totally
   unnecessary now that I have the cksplit() C-Kermit library function, so
   I replaced the mess (or at least the "if (macro)" parts of it) with a
   single ckpslit() call. ckuusr.c, ckuus5.c, 25 Apr 2017.

   The resulting Kermit program had big problems running production
   scripts, so the next few edits are to aid in tracking them down.

   Added HAVE_SNPRINTF macro to ckcdeb.h so we can use snprintf() safely
   in conditionals. True for Linux, Mac OS X, and *BSD but others can be
   added easily. ckcdeb.h, 25 Apr 2017.

   When used for macro arguments, cksplit() was using '\' as a quote
   character, and thus variable names were not being recognized. I added a
   new cksplit() argument for this, and it works, but now cksplit doesn't
   split the string into words. That was because 'while (c = *ss++ &&
   !flag)' should have been 'while ((c = *ss++) && !flag)', now it is, all
   OK, except it didn't set the macro arguments. This goes back to when I
   decided to allow any number of macro args, instead of just 10, and
   created the macro argument vector \&_[]. For arguments 1-9, you also
   have to do addmac() for each argument, which I did. Really there should
   not be duplicate lists, but that's for another day. ckclib.c, 26 Apr
   2017.

   Fixed a bug in cksplit(), it wasn't filling the notsep[] string array,
   which could have affected CSV, TSV, or ALL include sets. ckclib.c, 26
   Apr 2017.

   newerrmsg() reveals that that the new "Definition is circular or too
   deep" errors are at the beginning of FOR and WHILE loops, but the loops
   still sort of work. This almost certainly is because FOR and WHILE are
   internally defined macros that have not been passed through command
   parser. Debugging continues...

   Fixed a bad debug() statement in the FOPEN (or FREAD?) code that was
   added in Dev.21 that could cause segfaults on certain platforms.
   ckuus7.c, 26 Apr 2017.

   The FOR, WHILE, IF, and SWITCH commands are defined in ckuus5.c like
   this:

/* WHILE macro */
char *whil_def[] = { "_assign _whi\\v(cmdlevel) {_getargs,",
":_..inc,\\%1,\\%2,goto _..inc,:_..bot,_putargs},",
"_define break goto _..bot, _define continue goto _..inc,",
"do _whi\\v(cmdlevel),_assign _whi\\v(cmdlevel)",
""};

   It seemed to me that the easiest way to fix the problem with the
   built-in macros would be parse them the same way they were parsed
   before. I moved the internal-macro check to a routine,
   isinternalmacro(). It works by checking the macro name. We have to
   stick to the discipline that internal macros have names starting with
   '_' followed by 3 unique characters. For WHILE the "master macro" is
   '_while', and the generated macros are _whi2, whi3, etc, where the
   number indicates the execution stack level (so we can have nested
   loops). ckuus5.c, ckuusr.c, 27 Apr 2017.

   Then in ckuusr.c where the cmtxt() call was changed to not use
   zzstring, put the zzstring call back if it's an internal macro, in
   theory undoing the original change to dodo() but only for internal
   macros. After some serious juggling of the quoting levels in the
   internal WHILE macro definition, it worked. At least for my test
   script, and for the HTML script. ckuus5.c, ckuusr.c, 27 Apr 2017.

   Now to fix the other internal macro definitions... I fixed foz_def (the
   macro to use when the loop variable is a macro rather than a \%x
   variable), now it works too. ckuus5.c, 27 Apr 2017.

   A problem with FOR was noted where the loop variable disappears inside
   the loop: "for \%i 99 99 1 { echo [\%i] }" printed "[]" instead of
   "[99]". Fixed by adjusting the quoting in for_def. ckuus5.c, 28 Apr
   2017.

   The IF command (also implemented as an internal macro) was adjusted the
   same way. ckuus5.c, 28 Apr 2017.

   The next problem comes up when running the text-to-html script on this
   update notes file: it gets errors like
   "?<ERROR:MISSING_ARG:\farraylook()>". This problem was not in Kermit
   but in the script: \m(line) was being passed as an argument to a macro,
   and the line contained the string "\farraylook()". The argument is seen
   as \%1 from the macro's point of view and therefore evaluated
   recursively. The solution is to refer to this argument as
   \fcontents(\%1). No wonder the Kermit programming never caught on! I
   forgot about this, even though it was standard advice for (for example)
   passing Windows pathnames as arguments to macros. Anyway, with this
   change the html script runs without complaint and productes the correct
   result. April 28, 2017.

   But running other long, complex production scripts, a new problem came
   up: when a macro passes one (or more) of its arguments to another
   macro, the other macro gets an empty value for it. dodo():

     * Makes a new macro level (maclvl) and a new command level (cmdlvl).
     * Initializes the new cmdlvl stack frame.
     * Initializes the return value for this level to NULL.
     * Deletes any old macro arguments (\%1-\%9) at this level.
     * Calls xwords() to get the new argument list.

   Suppose macro A has been called with an argument \%1, and then invokes
   macro B with that same argument. Macro B gets "\%1" rather than the
   value of \%1, but since it is at a new level, \%1 does not have a
   value. Previously, these variables were evaluated in docmd() case XXDO,
   before dodo() was called, therefore they received the values from level
   where the macro was invoked. Now they are evaluated after dodo() starts
   a new macro level, but in the new level zzstring() doesn't find any
   definitions for the \%1-9 variables. The solution is not exactly
   elegant:

maclvl--;
evalmacroarg(&p);
maclvl++;

   but it's the only safe way to do it, because it is only in this place
   that we know that (say) \%1 is on the macro invocation's argument list
   and not in some other context. ckuus5.c, 29 Apr 2017.

   In running the suite of script-language torture tests, most of them
   (the ones published on the website) give the same results in previous
   and new C-Kermit. An incompatibility was noted in the 'demo' script:

ask \%x { Type 3 numbers separated by spaces or an empty line to quit:  }
if not def \%x break
smallest \%x

   In old Kermit, the 'smallest' macro saw three arguments; the new Kermit
   sees only one. I think the old behavior was too much magic; the new
   behavior is proper. From now on, if you want a macro to receive 3
   arguments, you'll have to call it with three arguments. Or recode the
   macro to \fsplit() any compound arguments.

   The S-Expression torture test gets errors now that it didn't before,
   but the errors are correct: e.g.

?Not defined - "c"
?sexp[37]: "(++ a 1 b 1 c 1 d)": Syntax error'

?Too few operands - "/ 2"
?sexp[110]: "(/ 2) ----} - c a))  t2 t1)..."

?Too few operands - "++"
?sexp[189]: "(++)  ate result) f (objective \%1) ..."

   Added FOPEN /STDOUT and FOPEN /STDERR. This allows a Kermit script to
   be fully pipeable. A minor wrinkle here was to not actually close any
   of these if the script contained an FCLOSE for them. ckcker.h,
   ckuus[27].c, 30 Apr 2017.

   The SWITCH command internal macro definition needed another adjustment.
   ckuus5.c, 30 Apr 2017.

    9.0.304 Dev.21

   April 19, 2017: Coming back to the code after a year of not touching
   it. If there are still any C-Kermit users out there, they don't seem to
   have any issues. Nevertheless, I do believe there are problems with the
   OpenSSL support. But I'm really not qualified or equipped to deal with
   them.

   It was bothering me that in Unix, you can't pipe a command or shell
   script to the kind of Kermit script that is designed to read from a
   file whose name specified on the command line; that is, that has an
   FOPEN /READ command in it. If FOPEN had a way to "open" standard input,
   then if no filename was given on the command line, FOPEN could
   accommodate:

if defined \%1 fopen /read \%c \%1
else fopen /stdin \%c
if fail ...

   So using this code, you could run a script "averages" in either of two
   ways:

average list               # The 'list' file contains a list of numbers
someprogram | average      # 'someprogram' outputs a list of numbers

   Code was added to support this. To see the C-Kermit changes search for
   "stdin" (case-independent) in ckuus7.c. It's not super-elegant,
   codewise, but I didn't want to totally redesign the data structures.
   Nothing was done for stdout or stderr, but they could follow the same
   path if there's ever a need. UNIX only for now, but could probably be
   adapted to VMS or Windows without much trouble. ckcker.h, ckuus2.c,
   ckuus7.c, 19 Apr 2017.

   Added switches for GETC... GETC /TIMEOUT:sec (so as not to have to SET
   ASK-TIMER before and after), /QUIET (so as not to see "?Timed out"
   message), and GETC /CHECK to see if anything is waiting to be read in
   the standard input stream (what it actually does is checks to see if
   stdin is a terminal; normally it won't have anything waiting if it is,
   and if it isn't, that means stdin is being piped to C-Kermit (or, more
   usefully, a C-Kermit script). This way a script can be written that can
   read its input from a disk file whose name is given on the command
   line, or have its input piped from another program, and still be able
   to give a usage message if no filename was given and nothing was piped.
   ckuus6.c, ckuus2.c, 21 Apr 2017.

   Here's how to write a script that reads from a file if a filename was
   given or, if not, reads from stdin:

  if defined \%1 {                # filename given on command line
      fopen /read \%c \%1
      if fail exit 1
  } else {                        # No command-line argument given
      fopen /stdin \%c
      if fail exit 1              # Open failed (shouldn't happen)
      getc /check                 # Check if stdin is redirected.
      if fail exit 1 \m(usage)    # If not exit with usage message.
  }

   For this purpose, it turns out that IF NOT BACKGROUND works just as
   well as GETC /CHECK followed by IF FAIL. IF BACKGROUND is true not only
   if the program is running in the background, but also if its standard
   input is a pipe.

   Updated makefile dates. makefile, 27 Apr 2016.

   Updated Dev version and dates, plus added comments about how to do
   this. ckcmai.c, 27 Apr 2016.

    LISP subsystem changes in April 2017

   Fixed the LISP ECHO command to always do unquoting itself, so UNQUOTE
   is only necessary for things like creating a string valued variable in
   Lisp that can be referenced in the Kermit domain:

(setq a (unquote '(This is a Lisp string constant)))
show macro a
This is a Lisp string constant

   We still need the inverse of Unquote, say REQUOTE or DOQUOTE or
   ADDQUOTE or IMPORT, whose argument is a variable containing a Kermit
   string, which returns the equivalent Lisp string. Like QUOTE, but
   evaluates the operand first.

   The sexp torture test still runs correctly.

   Meanwhile I think there is a lot of redundant or unused code in
   dosexp().

   Explanation for docs:

   Everything in an S-Expression is an operator, a variable name, a
   numerical constant, or a string constant. Strings in Lisp are
   represented as '(contents of string). The ECHO operator understands
   these and outputs them without the syntax, but it also understands
   regular Kermit strings, so you can use Kermit variables

   Kermit variables that start with backslash like \%a, \v(date), etc,
   don't look like Lisp variables so they have to be quoted: (echo '(\%a)
   '(\v(date)))

   Now do we need other string functions like CAR, CADDR, and CONCAT?

   (End of April 27, 2016, notes)
   ....................

   Added UNQUOTE command to deal with Lisp string constants like:

'(this is a string)

   so they can be echoed without the syntax, or exported into Kermit land.
   Also fixed bug where dosexp() could return a previous value if the
   current one was empty. ckuus3.c, 26 Apr 2016.

   There was no way to print stuff within S-Expression code, so I added an
   ECHO command that takes any number of arguments to be printed in
   series, but unlike the mainline ECHO command, this one evaluates each
   element in its argument list as an S-expression, or if it is not an
   S-Expression, then as a macro. Literal strings and Kermit backslash
   items (variables, function calls) must be entered as Lisp quoted
   strings:

(echo '(\fupper(abcdefg)))

   which prints "ABCDEFG".

   This example shows how Kermit code can be transformed to all Lisp:

define a three plus four is
  define b 3
  define c 4
  increment b c
  echo \m(a) \m(b)

   Results in "three plus four is 7". The more-compact all-Lisp version
   gives the same result:

(setq b 3 c 4)
  (echo '(three plus four is) (+ b c))

   Thus the main utility of the S-expression ECHO directive is to be able
   to print macro named variables (i.e. variables whose names don't start
   with backslash) without enclosing them in \m(). Or to put it another
   way, to be able to write LISP code that prints results in regular Lisp
   syntax without having to leave the Lisp environment. ckuus3.c, 25 Apr
   2015.

   \fcvtdate(string,code)... code is a number or a variable with an integer
   value. Function args that must be numeric can be given as macro names
   without the \m(xxx) notation, i.e. just xxx, but that didn't work with
   \fcvtcate():

for i 1 6 1 { echo \m(i). \fcvtdate(,i) }

   Now it does. ckuus4.c, 23 Mar 2016.

   Fixed HELP SEXP to also show ROUND with optional second argument.
   ckuus2.c, 24 Apr 2016.

    Dev.20

   I got a report that the photogallery script could not create files in
   Mac OS X. Sure enough, C-Kermit 9.0.304 got an error every time it
   tried to create a file. This happened in both zchko() ("check if file
   can be created") and in zopeno() ("open file for output"), whichever
   was called first, even though the code in these routines had not
   changed, probably in decades. I couldn't take a debug log either
   because that required opening a file. The user who reported the problem
   discovered that if she created the desired file first outside of
   Kermit, then Kermit could open it for output. It seems that ever since
   1985, I have been calling open() with just O_WRONLY. Evidently that's
   not good enough any more in recent Mac OS X releases; experimentation
   shows I have to use O_WRONLY|O_CREAT, but then I also have to put
   perms, so I put 0600. I made this change in both zchko() and zopeno().
   Tests OK in Mac OS X 10.10.5, NetBSD 6.1.5, Solaris 9, and Linux
   RHEL6.6. ckufio.c, 16 Feb 2016.

    Dev.19

   As noted, Dev.17 dumped core immediately upon startup on certain 64-bit
   platforms such as Ubuntu 15.04 and Mac OS X 10.11. Since I don't have
   access to these platforms I asked Mark Sapiro to look at the changes I
   made and try to narrow them down. He found that these did the trick:

--- cku304.17/ckucmd.h  2016-02-03 11:28:00.000000000 -0800
+++ cku304.18x/ckucmd.h 2016-02-04 17:54:33.872465535 -0800
@@ -103,7 +103,7 @@
#define HLPBL  100                     /* Help string buffer length */
#ifdef BIGBUFOK
#ifdef CK_64BIT

-#define ATMBL 163808                  /* Command atom buffer length */
+#define ATMBL 20470                   /* Command atom buffer length */
#else
#define ATMBL 10238                    /* Command atom buffer length */
#endif /* CK_64BIT */

@@ -122,7 +122,7 @@
#else
#ifdef BIGBUFOK
#ifdef CK_64BIT

-#define CMDBL 8388608
+#define CMDBL 65500
#else
#define CMDBL 32763
#endif /* CK_64BIT */

   So I put back my changes from to ckcdeb.h, ckcker.h, ckucmd.h, and
   ckuusr.h, from Feb 3, and then made the adjustments just above. I
   suspect the segfaults occurred when a bunch of these very large buffers
   were malloc'd in cmsetup() upon program startup. Time will tell if the
   new values are safe. ckucmd.c, 5 Feb 2016.

   Updated locale documentation on the website in locale.html, 5 Feb 2016.

   Added new format code 6 to \fcvtdate() for "dd fullmonthname yyyy
   hh:mm:ss". This prints the monthname from the Locale, or if there is no
   Locale or it is disabled, the full monthname in English. ckucmd.c, 5
   Feb 2016.

   In doing this, I noticed that if I included any command that referenced
   the locale in a kerbang script or any other script invoked on the
   command line, that the locale wasn't used. I moved the initialization
   of the locale a bit higher up in the program start code. ckcmai.c, 5
   Feb 2016.

   Added locale support to \fcvtdate() so month name comes out in the
   desired language in formats where an "English month name" was
   previously returned. Works OK in Red Hat EL6.6, but localized dates
   aren't supported on the other platforms I have access to (Solaris 9,
   various NetBSD versions). As a start, I always use 3-letter short month
   abbreviations, even though some countries might use longer ones. If
   anybody cares about this, they will let me know. But this way, all date
   formats that have textual month names come out in the same format and
   dates in the same format are always the same length. ckucmd.c, 5 Feb
   2016.

    Dev.18

   Fixed four debug() statements that had a string as the final parameter
   instead of a number, noticed by gcc on NetBSD 7. ckuusx.c, ckudia.c, 4
   Feb 2016.

   Mark Sapiro says Dev.17 segfaults immediately on startup on Ubuntu
   15.04. Asked him for a debug log. Meanwhile I checked the tarball,
   rebuilt from it, all OK on 64-bit Linux RHEL6 and on 32-bit NetBSD
   6.1.5. Built on NebBSD 7.0 also, no problem there except a few new
   warnings. Backed off the 64-bit size changes. ckcdeb.h, ckcker.h,
   ckucmd.h, ckuusr.h, 4 Feb 2016.

    Dev.17

   Added missing "help xmessage" text. ckuus2.c, 3 Feb 2016.

   The command "date 29-feb-1996 +1year" failed with "?Base day out of
   range". Fixed in ckucmd.c, 3 Feb 2016.

   Removed misleading display of Z_MAXCHAN from SHOW FEATURES because in
   Unix we don't use this symbol; we get the real maximum number of open
   files from sysconf(). ckuus5.c, 3 Feb 2016.

   Changed definitions of sizes of things (command buffers, packet
   buffers, etc) to be much bigger on 64-bit architectures. This will
   allow bigger script programs, bigger packet buffers (and thus
   conceivably faster file transfers), more macros, more variables, longer
   values of variables, etc. The bigger sizes are dependent on the symbol
   CK_64BIT, which is set in ckcdeb.h based on what it can figure out from
   compiler builtins, header files, etc, but can also be set on the CC
   command line in case ckcdeb.h doesn't pick it up. ckcdeb.h, ckcker.h,
   ckucmd.h, ckuusr.h, 3 Feb 2016.

   Added __x86_64 to the symbols looked for when defining CK_64BIT.
   ckcdeb.h, 3 Feb 2016.

   Added __x86_64 to the symbols looked for and displayed by SHOW
   FEATURES. ckuus5.c, 3 Feb 2016.

   Mark Sapiro also noticed that the "localarray" stresstest revealed that
   if an array (say \%a[]) was declared as local in a macro, but the same
   array was NOT declared at any higher level, then the array persisted
   even after the macro returned, instead of disappearing as it should.
   Fixed in popclvl(): ckuus5.c, 3 Feb 2016.

   Mark Sapiro reported C-Kermit crashing on some platforms but not others
   when evaluating any rounding operation in an S-expression, e.g. (round
   1.75). My mistake, I had sprintf() writing into a buffer that was too
   short. I know I should use snprintf() but it's not portable and it
   would be a big deal to enumerate all the platforms where it's available
   and where it's not and tailor the code accordingly, so I just made the
   buffer (more than) big enough, barring any misbehaving printf() format
   interpreters. ckround(): ckclib.c, 3 Feb 2016.

   Used STRDIRSEP in the CHANGE code to keep it portable, in case C-Kermit
   is ever built on any non-Unix platform again (WARNING, VMS will still
   require some special code). ckuus6.c, 2 Feb 2016

   We have always had DIRSEP and ISDIRSEP macros for referring to
   directory separators in the code, e.g. '/' for Unix, ':' for AOS/VS,
   '>' for VOS, '\' for OS-9, etc, but we needed a string version, so I
   added STRDIRSEP analogs for each DIRSEP (like "/" for '/') so we could
   use them as arguments to ckindex(), ckstrncat(), etc. ckcdeb.h, 2 Feb
   2016.

   In adding the /BACKUP switch, something caused a core dump when using
   /MODTIME:PRESERVE, a bad value in the "generic permissions" field of
   the zsattr struct when going to copy the modtime and perms from the
   original file to the backup file. It's because I wasn't initializing
   all the struct members. I changed zsattr() to defend itself against
   out-range-values, clarified the calling convenstions for zstime() in
   the opening comments (if you are not setting attribute blah, then set
   blah.len = 0 in the argument struct), and I fixed the struct
   initializations in the calling code. ckuus6.c, ckufio.c, 2 Feb 2016.

   Added a /BACKUP:directory switch for CHANGE. ckuus6.c, 1 Feb 2016.

   Added a /DESTINATION:directory switch for CHANGE. Some problems I had
   doing this revealed an error in domydir()... For reasons too hard to
   explain the DIRECTORY command sets a global flag "diractive" to let the
   command parsing routine cmifi2() know that a DIRECTORY command is in
   progress, and therefore to do some special things in that case when a
   wildcard expansion includes directory names. Later on I added TOUCH and
   CHANGE commands to domydir(), because writing separate routines would
   have meant duplicating tons of code. BUT... The "diractive" flag should
   NOT be set when the command is TOUCH or CHANGE. Once that was fixed,
   the rest was pretty straightforward. ckuus6.c, 1 Feb 2016.

   I discovered that the CHANGE command didn't work on Linux. This opened
   a whole big can of worms, read on...

   CHANGE command failed on platforms like Linux where fputs() did not
   return 0 on success. Fixed in ckuus6.c, 29 Jan 2016.

   But after this fix it still didn't work if I did not have en
   environment variable defined that said what directory to use for
   temporary files because the \v(tmpdir) variable was not falling back
   correctly. In Unix, first it tried the environment variables CK_TMP,
   TMPDIR, TEMP, and TMP, in that order, and if nothing turned up it tried
   /tmp/. Then if the resulting value doesn't end in a directory
   separator, one is tacked on. There were a couple mistakes in the code
   causing the /tmp/ part to be skipped, and tacking '/' onto the null
   string, thus setting the temporary directory to be the root directory,
   resulting in big trouble when writing temporary files, e.g. in the FTP
   GET command, the CHANGE command, who knows what else. Fixed in
   ckuus4.c, 29 Jan 2016.

   Another problem with this was that the temporary directory might be
   referenced before it was defined, e.g. in an FTP GET command. Remedied
   by "invoking" \v(tmpdir) before any commands are processed. ckcmai.c,
   29 Jan 2016.

   And Yet Another Problem was that the SET TEMP-DIRECTORY command simply
   did not work. Plus it didn't store its argument as a full pathname, so
   it would not work after the user CD'd to someplace else. ckuus3.c, 29
   Jan 2016.

   A related problem was that IF WRITEABLE didn't work when given a
   directory name. Fixed in ckufio.c, 29 Jan 2016.

   Another problem was that there was no SHOW TEMP-DIRECTORY command.
   Every SET should have a SHOW. Fixed in ckuusr.h, ckuusr.c, 29 Jan 2016.

   Updated HELP SET TEMP-DIRECTORY text. ckuus2.c, 29 Jan 2016.

   Added TMP-DIRECTORY as an invisible synonym for TEMP-DIRECTORY in the
   SET and SHOW commands. ckuusr.c, 29 Jan 2016.

    Dev.16

   Updated copyright year to 2016. ckcmai.c, 18 Jan 2016.

   Made a new "linux" target for the makefile. Kept the previous one
   available as "linux-2015". The feature tests in the old one looked for
   libraries in specific places, like "if test -f
   /usr/lib64/libncurses.so.5" which is stupid because there is an endless
   number of places where Linux packagers will dream up to put them,
   especially for multiarchitecture distributions. Well, who really knows
   where the libraries are, and what the library search path is? ld,
   right? So now instead of looking in 20 different places for (say)
   libncurses under several different names, we just ask ld if it can find
   it and if so -- and if we also can identify the corresponding header
   file (if any) -- then we set the appropriate HAVE_BLAH feature flags.
   makefile, 18 Jan 2016.

   Mark Sapiro noticed that "OK" is no longer a valid IF condition (it was
   a synonym for SUCCESS), which is true; I removed it years ago because
   of some conflict but didn't make a note of it, can't remember the
   reason, but IF OK still showed up in HELP IF. Removed it in ckuus2.c,
   and put a new version of the iftest script in the script library. 31
   Dec 2015.

    Dev.15

   Patches from Bernard Spil for LibreSSL: "Currently Kermit fails to
   build when openssl libraries have been built without SSLv3 are used
   (configure --no-ssl2 --nossl3). This has surfaced when building with the
   latest LibreSSL 2.3. In addition, there are issues with LibreSSL as it
   does not support SSL compression nor perl EGD as entropy source.
   Attached patches address all these issues. These can be improved upon
   by using only SSLv23_ methods or even TLS_ methods and setting
   SSL_CTX_set_options(ctx, SSL_OP_NO_SSL2 | SSL_OP_NO_SSL3) but I've
   tried to make the patches minimally intrusive. OpenSSL 1.1.0 will
   deprecate SSLv23_ methods and introduces compatible TLS_ methods."
   ckssl.h, ck_ssl.h, ck_ssl.c, ckcftp.c, ckupty.c. Built OK on NetBSD
   6.1.5 with OpenSSL 1.0.1e and Linux RHEL6.6 with 1.0.1k, and also on
   both without SSL selected, but with some warnings; in functions
   'tls_is_anon' and 'tls_is_krb5': "assignment discards qualifiers from
   pointer target type".

   Updated dates and Dev number, ckuus5.c, ckcmai.c.

   Trying to build C-Kermit on Red Hat RHEL6 it failed at link time
   because it couldn't find libncurses. It was really hard to track this
   one down because all the symptoms were totally misleading. The real
   problem was that ncurses.h was not installed on the system, and the
   elaborate checking in the linux targe of the makefile didn't allow for
   the case when the libraries were installed but the header file not.
   After fixing the makefile it compiles and links correctly without
   curses support. Also fixed a large number rule lines that started with
   spaces in stead of Tab. makefile, 17 Dec 2015.

  NOTE FOR DOCS: If C-Kermit builds silently but the result has no curses
  support, it means that lib[n]ncurses is missing OR [n]curses.h is missing.
  There should be a way to issue a message from the makefile but I couldn't
  find it (echo, @echo, etc, none of them worked).

    Dev.14

   Two closing braces were missing in ck_ssl.c at line 2207, which
   prevented Dev.13 from being built with OpenSSL support. 10 Oct 2015.

    Dev.13

   Compiles, links, and runs OK with "make netbsd+ssl" except for these
   warnings:


ck_ssl.c: In function 'ssl_display_connect_details':
ck_ssl.c:1089:12: warning: assignment discards qualifiers from pointer target ty
pe
ck_ssl.c: In function 'tls_is_anon':
ck_ssl.c:3139:12: warning: assignment discards qualifiers from pointer target ty
pe
ck_ssl.c: In function 'tls_is_krb5':
ck_ssl.c:3189:12: warning: assignment discards qualifiers from pointer target ty
pe


   Resulting binary connects with TLS 1.0 to https://www.google.com.

   From Jake Thompson: "ckcftp.c is currently set up to allow only SSL 3.0
   by default when using AUTH SSL/AUTH TLS, and no later versions
   (SSLv3_client_method). After the POODLE vulnerability, most sites have
   disabled SSL 3.0, allowing only TLS 1.0 or later. The attached patch
   changes ckcftp.c to allow TLS 1.0 and later only by default, adding a
   new bug option use-ssl-v3 in order to downgrade to SSL 3.0 if needed.
   ck_ssl.c looks like it may need similar changes; I haven't looked
   extensively." I applied Jake's patch to ckcftp.c, and the analogous
   patches to ssl_tn_init() and ssl_http_init() in ck_ssl.c, with improved
   structure and debug logging. 5 Feb 2015.

   Apropos of the previous item, SHOW FUNCTIONS is not very useful. It
   gives a list of all the functions, period. But if I wanted to find only
   the functions that have to do with PIDs, it would be nice to be able to
   include a string to match the function names, as in "show function
   pid". Other examples include "show func info", "sho func code", "sho
   fun date", etc. This was added doshow() ckuus5.c, with a special
   function code parameter value added to kwdhelp() in ckucmd.c and new
   HELP FUNCTION text in ckuus2.c. It's not really pattern matching, just
   a substring. Anything more ambitious would have required a rewrite of
   kwdhelp(). 5 Feb 2015.

   Changed \fgetpidinfo() to \fpidinfo() to be easier to find, but left
   the original name as an invisible synonym. ckuusr.c, 5 Feb 2015.

   Edward Berner noticed that K95 built with Open Watcom was crashing
   because of "inconsistent extern declarations of vmode". vmode is
   declared BYTE vmode = VCMD; in ckoco2.c and referenced as extern BYTE
   in all but two cko*.c modules, but as extern int in all cku*.c modules
   except cko[tf]io.c. BYTE is not a known type to mainline C-Kermit code.
   However, all references to vmode in mainline code are within #ifdef
   OS2. Fixed in ckofio.c, ckotio.c, ckuus3.c, ckuus6.c, ckuus7.c,
   ckuusx.c, 5 Feb 2015.

   Edward also reported a similar problem with marginbot, but in my
   sources all declarations are consistent (int). But he is working with
   2003 source code, probably it's fixed.

   SET LOGIN USER xxx did not evaluate xxx if it was a variable. If there
   was ever a reason for this I can't recall it. Fixed in ckuus3.c, 5 Feb
   2015.

    Dev.12

   Fixed the previous fix. ckufio.c 9.0.220, 12 Jan 2015.

   Updated copyright year to 2015. ckcmai.c, 11 Jan 2015.

   On QNX 4.25 an FTP GET command always failed with a segmentation fault.
   In fact, this would happen in any Unix version of C-Kermit that has
   NOUUCP defined, such as Mac OS X. The code in the #ifdef NOUUCP section
   of zchko() was wrong, clobbering the variable (x) that held the length
   of filename string. I fixed zchko to not do that. ckufio.c 9.0.219, 11
   Jan 2015.

    Dev.11

   I received reports from both Alan Jones and Harold Baldwin around the
   same time that REMOTE commands were getting "?Not confirmed" parse
   errors in C-Kermit 9.0.302 and later. Incredibly, this was broken long
   ago in remcfm(); see the comment there in ckuus7.c about line 7177. The
   problem was that I commented out the test for an empty cmtxt() result
   string. Apparently at least 10 years have passed without anybody
   noticing and reporting this (it works right in K95 2.1.3 from 2003).
   Fixed in ckuus7.c, 3 Nov 2014.

   Updated HELP SET FILE text to mention that SET FILE COLLISION OVERWRITE
   doesn't work for a server unless it has also been told to ENABLE
   DELETE. ckuus2.c, 3 Nov 2014.

   The photogallery script documentation contains a hint that didn't work,
   namely that to create a list of the names of all the non-thumbnail,
   non-resized original image files, use:

directory /brief /except:*-[tr].jpg /output:somefile *.jpg

   This did not work; the /EXCEPT switch was ignored whenever the /BRIEF
   switch was included in a DIRECTORY command. Fixed in domydir() by
   moving two lines of code to where they always should have been.
   ckuus6.c, 3 Nov 2014.

    Dev.10

   From Mark Wooding: Fix inconsistent declarations of a couple variables
   across modules; he actually reported a bunch of them but all the
   serious ones (int vs long or off_t) had been fixed in 2005 with the
   introduction of CK_OFF_T, and the only two that needed fixing were char
   * vs char [] (prevcmd and cmdfil). ckucmd.c, ckuusy.c, 23 Feb 2014.

   From Mark Wooding: supply default "(none)" value for \v(dialmsg).
   ckuus4.c, 23 Feb 2014.

   From Mark Wooding: add #define _XOPEN_SOURCE 500, #include <stdlib.h>
   in the PTY module, "Needed along with -DHAVE_PTMX for working ptys".
   Also fixed a debug() statement that had a string argument that should
   have been an int. ckupty.c, 23 Feb 2014.

   From Ian Beckwith, updates to the Debian Linux MULTIARCH support. "I've
   checked through the patched makefile, every library is checked in
   /usr/lib/$(MULTIARCH)/, except for libdes425, which isn't in debian."
   These changes are presently in Debian testing for amd64, armel, armhf,
   i386, kfreebsd-amd64, kfreebsd-i386, mips, mipsel, powerpc, s390x,
   sparc. makefile, 23 Feb 2014.

   Documentation for MULTIARCH:

   [214]https://wiki.debian.org/Multiarch/Implementation
   [215]https://wiki.ubuntu.com/MultiarchSpec
   [216]https://wiki.debian.org/Multiarch/HOWTO

   From my to-do list.... I noticed a while back that \fsplit(s,&a,,TSV)
   could mess up if the data fields contained grouping characters like
   parens, quotes, brackets, or braces. \fsplit() and \fword() are handled
   by cksplit(), which is designed to allow grouping, nesting, quoting,
   recursion, and so on (for parsing such things as complex LISP
   S-expressions and Comma-separated lists full of quoting) and I guess
   some of that code was being executed for TSVs. Rather than mess with
   the existing code and possibly break something else, I added a chunk of
   new code at the beginning of the byte loop in cksplit() to handle TSVs,
   which are extremely simple, and so the new code is too. And also way
   more efficient. Seems to work right, and other things like LISP
   programs still work. ckclib.c, 31 Jan 2014.

    Dev.09

   Updated version number and date and copyright date. ckcmai.c and many
   other modules. 20 January 2014.

   Fixed core dump that happened only in Solaris (as far as I know) with
   "ftp open kermitproject.org" (which should have been
   "ftp.kermitproject.org"). The problem was that perror() was being
   called with a pointer to an empty string, which should be OK but
   apparently is not in Solaris. ckcftp.c, 20 January 2014.

   Various minor touch-ups to HELP, NEWS, VERSION text. ckuus[r2].c, 20
   Jan 2014.

   Added CHECK LOCALE. ckuus3.c, 20 Jan 2014.

   Fixed an aggregrate array initialization (not legal in non-ANSI).
   ckuus4.c, 20 Jan 2014.

   From David Goodwin: Remove all references to K95 registration and
   time-limited demo versions, and fix a couple minor compilation problems
   for the Windows version. ckcmai.c, ckcpro.w, ckucmd.c, ckuus[34rx].c,
   ckuusr.h, 20 Jan 2014.

   Corrected HELP SHIFT text, which previously said it affected only
   arguments 1..9, but really affects all arguments, no matter how many.
   ckuus2.c, 17 Dec 2013.

   Got rid of the "ok" keyword as an IF condition. OK was an undocumented
   and invisible synonym for SUCCESS, but this has bitten me too many
   times, when I create a variable named OK and use it as a "lazy IF
   condition" as in:

.ok = 0
if match \&a[i] img_[0-9][0-9][0-9][0-9].jpg .ok = 1
else if match \&a[i] img_[0-9][0-9][0-9][0-9][0-9].jpg .ok = 1
else if match \&a[i] dscf[0-9][0-9][0-9][0-9].jpg .ok = 1
else if match \&a[i] scan[0-9][0-9][0-9][0-9].jpg .ok = 1
if not ok exit 1 "\&a[i]: Not a recognized image file name"

   ckuus6.c, 17 Dec 2013.

   For Unix only, changed default prompt to show "~/" instead of the full
   home path, which these days can get ridiculously long. So now, for
   example, "(/hmt/sirius1/prv0/kd/fdc/) C-Kermit>" becomes "(~/)
   C-Kermit>". If I'm cd'd to the "src" directory of my home directory,
   it's "(~/src/) C-Kermit>". If my current directory is not in my home
   tree, its full path is shown as before. ckuus5.c (definition of
   ckprompt), 17 Dec 2013.

   Reported by Christoph Sievers... the following sequence:

SET FTP AUTOENCRYPTION ON
SET FTP AUTHTYPE TLS
SET AUTH TLS VERBOSE ON
SET AUTH TLS VERIFY NO
ftp open 127.0.0.1 12345 /USER:fu /PASSWORD:bar /NOINIT

   is supposed to allow a secure FTP connection to proceed without the
   question:

Warning: Server didn't provide a certificate
Continue? (Y/N)

   but the question was coming out anyway. Jeff noticed that the FTP/SSL
   code was missing an IF clause that was present in the TELNET/SSL code.
   Fixed in ckcftp.c, 17 Dec 2013.

   The TOUCH command was dumping core because of a clever optimization I
   put in the code at some point, probably not too long ago or I would
   have noticed it. Fixed the problem by removing the optimization.
   ckuus6.c, 17 Dec 2013.

    Dev.08

   Branding of C-Kermit for Windows... I removed the special version
   numbering for C-Kermit for Windows (nee K95) so now it should show the
   regular C-Kermit version herald. Changed \v(program) to always be
   "C-Kermit", not "K-95", "K/2", etc. Changed default prompt for Windows
   and OS/2 to [dir] C-Kermit>. Added "IF WINDOWS" and made "IF K-95" an
   invisible synonym for it. Performed a rather massive edit on the help
   text module to remove references to Kermit 95. Builds OK in Unix but so
   far I don't have a way to test it in Windows. ckcmai.c, ckuus2.c,
   ckuus4.c, ckuus5.c, ckuus6.c, 6 Dec 2013.

   DIR /ARRAY:&a *.jpg doesn't work right if only one file matches: it
   creates the array with dimension 1, but element 1 is empty. But it
   works OK if two or more files match. This is because the code to load
   the array is executed only if we sort the result, a step which we
   cleverly skip if there is only one file in the listing. For that
   matter, DIR /NOSORT /ARRAY:&a *.* doesn't work at all, no matter how
   many files match. It turns out a lot of code is in the sorting block
   that doesn't actually have anything to do with sorting. So I changed
   domydir() so it the "xsort" flag (which selects this code) is always
   on, and added a new flag that says whether we actually call the sort
   routine, which was safer than reorganizing a ton of code. ckuus6.c, 6
   Dec 2013.

   Changed ckstrcmp(), which is used by the DIRECTORY command, the ARRAY
   /SORT command, the \fstrcmp() function, and who knows what else (this
   function is called from 261 different places in C-Kermit), to use the
   collating sequence of the current locale, which works as long as the
   character set is single-byte (e.g. ISO-8859-1 or KOI8). The way I did
   it is not pretty, but there is no standard locale-aware string
   comparison function that has the options that ckstrcmp() has (and
   uses), and as far as I can tell there is no standard way to compare two
   characters according to the locale, only two NUL-terminated strings. So
   I turn each character into a string and compare them with strcoll(). I
   can't just compare the strings directly because (a) strcoll() doesn't
   allow the comparison of pieces of strings and (b) there is no
   case-independent version of strcoll(). The new code is within #ifdef
   HAVE_LOCALE..#endif, but some adjustments might be needed if strcoll()
   (circa 1989) is not found everywhere that locales are found. Anyway,
   now non-ASCII filenames and arrays (except in multibyte character sets
   like UTF8) will sort correctly if the locale has the required collating
   sequence; otherwise they come out as before. ckclib.c, 6 Dec 2013.

   In the same vein... Lazy IF Conditions, in which a variable name can be
   used as an IF condition as long as it evaluates to a number (0 being
   false, nonzero being true)... The error message given when the variable
   (or other random string) did not have a numeric value, or any value at
   all, was less than informative. Now it prints the variable name, which
   is a good trick because it had already been wiped out in the act of
   trying to evaluate it. ckuus6.c, 6 Dec 2013.

   Another fundamental change to the parser. Script writers might have
   noticed that an innocent-looking statement like:

if equ \%a xx echo "Dos equis"

   would work correctly sometimes and others would get a parse error,
   depending on whether the variable (\%a in this case) had a non-empty
   definition. The normal workaround is to write it like this:

if equ "\%a" "xx" echo "Dos equis"

   but that shouldn't be necessary, since the parser knows that (a) the
   statement does not have a syntax error and (b) it has evaluated a
   variable that has an empty (or no) value, in which case it should
   simply return an empty string instead of a failure code. I ran several
   of my huge production scripts with this change with no ill effects, and
   in fact it let me track down several long-elusive problems in the
   scripts. ckucmd.c, 6 Dec 2013.

   A major annoyance with C-Kermit scripts is that when a command fails,
   we often get no clue about which command it was or where it was. This
   happens when the command issues its own error message (e.g. "?Text
   required") and returns -9 to the parser to indicate an error message
   was already printed (on the assumption that the user just typed the bad
   command and so knows what it is). In the cases where the command did
   not already issue an error message, the parser already echoed the
   command that failed. I changed the parser to do this in the -9 case
   too. ckuus5.c, 6 Dec 2013.

   (Another problem in this area is just too hard to fix, namely that when
   the parser is executing a script and a command fails, the parser often
   has no idea which line of the script file the failing command came
   from. That's because when reading a script file, the parser
   concatenates each {...} block into a single line, so when a command
   within the block fails, the parser only knows the line number of the
   first line of the block.)

   From Jake Thompson: Fixed a typo in applying diffs to ckcsig.h. Fixed
   some locale-related #ifdefs in ckuusr.h and ckuus5.c. Also added the
   ability to suppress locale support at compile time via -DNOLOCALE
   (ckcdeb.h). 6 Dec 2013.

    Dev.07

   Built OK on NetBSD 6.1.2. Built OK on RHEL4. Could not build with SSL
   on NetBSD because "can't open config file: /etc/openssl/openssl.cnf".
   Built OK on Linux with OpenSSL 0.9.7a but for some reason a ton of
   "passing arg ... from incompatible pointer type" messages came out of
   DES_*() function invocations, which didn't happen before. Built OK on
   Solaris 9 without SSL, and with OpenSSL 0.9.8q (with no warnings, but
   this one doesn't have DES). 24 Nov 2013.

   Commented out calls to shoreg(). ckuus[r5].c, 24 Nov 2013.

   Changed program name in Windows from "Kermit 95" to "C-Kermit".
   ckcmai.c, 24 Nov 2013.

   Removed or updated numerous references to Columbia University, many
   modules, 24 Nov 2013.

   Changes to make current C-Kermit source code integrate with Kermit 95
   code, from from Jake Thompson, 21 Nov 2013:
     * Inconsistent declarations of nzxpand() in Unix and Windows,
       ckcdeb.h.
     * Extraneous prototype of ckcgetc() in ckcker.h.
     * Duplicate definition of __inline int in ckcsig.h.
     * Similar issues in ckcuni.h.
     * Windows OpenSSL doesn't have X509_to_user() or X509_userok(),
       ck_ssl.c.
     * No longer necessary to #include ckosslc.h and ckossl.h in ck_ssl.c.
     * zgfs_link and linkname not implemented in K95: ckuus4.c.
     * Include ckodir.h for MAXPATHLEN in ckuus[46].c.
     * chkaes() calling sequence is different in K95: ckuusr.h.

   Each change marked with "[jt] 2013/11/21". 24 Nov 2013.

   Android changes from Jake Thompson, 17 Nov 2013:
     * Disable locales in android.mk
     * Disable "format string checks" in the ndk-build invocation,
       android.txt.

   Updated HELP FUNCTION PICTUREINFO. ckuus2.c, 15 Oct 2013.

   \fpictureinfo() problem from 17 Sep 2013 was because I was using a tail
   anchor ($) on the pattern but had not set the ckmatch() opts bit saying
   so. Removed the tail anchor. Also changed the function to return 3
   ("square") if width == height (so it's kind of like a bit mask).
   ckuus4.c, 15 Oct 2013.

   The documentation had the sense of the second argument to \fdayname()
   and \fmonthname() backwards. Fixed in locale.html, 15 Oct 2013.

   \fdayname(\v(nday)) would fail if executed on Sunday because \v(nday)
   numbers days 0 (Sunday) to 6 (Saturday), whereas \fdayname() wants 1
   (Monday) through 7 (Sunday). Also, \fdayname(,1) would return "Jan" if
   today was Sunday. Fixed by allowing both 0 and 7 to mean Sunday. All
   the other day numbers agree. ckuus4.c, 15 Oct 2013.

   If the CHANGE command was used repeatedly, eventually C-Kermit would
   get a memory allocation error. A dynamic buffer was not being freed.
   Fixed in ckuus6.c, 15 Oct 2013.

   Changed CHANGE message to put spaces around the "->" so it doesn't get
   intepreted by the terminal emulator as part of a URL. ckuus6.c, 11 Oct
   2013.

   \fpictureinfo() was checking the filename against a pattern and failing
   on no match, sometimes incorrectly. I took out the filename check,
   since the next thing it does is check the internal structure of the
   file. ckuus4.c, 17 Sep 2013.

   ckuus5.c:597:29: warning: missing terminating " character <- fixed 3
   Sep 2013.

   NetBSD 6.1, man 3 time: "In NetBSD 6.0 the time_t type was changed to
   be 64 bits wide, including on 32-bit machines, making rollover a
   concern for the far distant future only. Note however that any code
   making the incorrect assumption that time_t is the same as long will
   fail on 32-bit machines in 2038." C-Kermit builds OK but warns:

ckcmai.c:(.text+0x1e92): warning: warning: reference to compatibility
time(); include <time.h> for correct reference


   Did this and all's OK. But it might have repercussions elsewhere.
   ckcmai.c, 3 Sep 2013.

   Added clarification to HELP CHANGE about string format. ckuus2.c, 3 Sep
   2013.

   Changed CHANGE /SIMULATE to list files that would NOT be changed only
   if the /VERBOSE switch was included. ckuus6.c, 4 Aug 2013.

   The CHANGE command would indicate failure even when there was no error.
   Fixed in ckuus6.c, 4 Aug 2013.

    Dev.06

   A new command-line options, --nolocale, was added to disable use of the
   locale by forcing the "C" locale. Ditto if the environment variable
   K_NOLOCALE is set to a nonzero integer value. ckuusr.h, ckuusy.c,
   ckcmai.c, 24 Jul 2013.

   Developed, built and tested on NetBSD with English, Spanish, and
   German. Built and tested OK on Linux RHEL5 with the same languages.
   Built OK on Solaris 9, which supports the locale APIs, but does not
   have any locales installed except en_US. 24 Jul 2013.

   CAUTION: Except where C-Kermit is explicitly dealing with multibyte
   character sets, such as in file transfer and in the terminal emulator,
   there is no special support for multibyte character sets such as UTF-8,
   Shift-JIS, etc. So while \fupper(), \flower(), and \fcapitalize() can
   work with ISO-8859-1, KOI-8, and other single-byte character sets, they
   won't work with UTF-8 because they are just byte loops, unless the
   underlying isupper, tolower, etc, functions (or macros, or whatever
   they are) do some magic. Ditto for Shift-JIS, Japanese EUC, etc.

   Added HELP text for \fmonthame() and \fdayname(). ckuus2.c, 24 Jul
   2013.

   Added \fmonthame(), like \fdayname() but for months. ckuusr.h,
   ckuus4.c, 24 Jul 2013.

   Added locale_monthame(month,fc), like locale_dayame(day,fc) but for
   months. ckutio.c, 24 Jul 2013.

   Added \fdayname(date,fc), where date can be any free-format date/time
   string, with or without the time, or omitted to give the name of the
   current day. fc is a function code: 0 to return the name in full,
   nonzero to abbreviate it according to the locale; if fc is omitted, the
   abbreviated form is returned. The full or abbreviated day name is
   returned in the language and character set specified or implied by the
   locale if the underlying platform is configured for it; otherwise they
   come out in English. These routines builds upon all of the date-time
   code that was added in 2003, particularly cmcvtdate(), the free-format
   date parser, and mjd(), that calculates a Modifed Julian Date, from
   which the day of the week can be derived by a simple modulus. This
   function pretty much supersedes \fday() (which returns only the
   3-letter English day name), but \fday() remains available for
   compatibility. ckuusr.h, ckuus4.c, 24 Jul 2013.

   Put a locale_dayname() function in ckutio.c. This is compiled if
   HAVE_LOCALE is defined and NO_LOCALE is not defined. HAVE_LOCALE is
   defined for BSD44 and POSIX, VMS, OS/2, and Windows. These definitions
   can be adjusted if necessary in ckcdeb.h and NO_LOCALE can be included
   on the make command line to override in case of trouble. ckcdeb.h,
   ckutio.c, 23 Jul 2013.

   Added \v(year), which evaluates to the current year, e.g. 2013. Mainly
   because I keep expecting it to be there. Also \v(month) (three-letter
   month abbreviation, English) and \v(nmonth) (2-digit month number,
   01-12). ckuusr.h, ckuus4.c, 22 Jul 2013.

   Note that \v(month) and \v(day) are not ideal -- abbreviations, not full
   names, and English only. I added \v(month) and \v(nmonth) only for
   symmetry with \v(day) and \v(nday). These shortcomings are remedied in
   the next items.

   Until now there was no straightforward way to extract a field from a
   date-time string. As a start, I added a new output format, 5, for
   \fcvtdate(), to make the result be numeric with fields delimited by
   ':', for example: 2013:07:22:15:19:43. Any desired field can be
   extracted with \fword(), for example to get the current year:
   \fword(\fcvtdate(,5),1), or for the current month
   \fword(\fcvtdate(,5),2). And so on. Since each field is numeric, it can
   index into tables of (say) month names or day names in the desired
   language and character-set. ckucmd.c, 22 Jul 2013.

   CHANGE works by copying each file to a temporary directory, making
   changes to the copy, and then renaming the copy over the original file.
   It was doing this for all files, even when they weren't actually
   changed (i.e. did not contain string1). Also if \v(tmpdir) was defined
   to be a directory that did not exist, the CHANGE command didn't try to
   create it. Both fixed in ckuus6.c, 22 Jul 2013.

   Added HELP CHANGE text. ckuus2.c, 22 Jul 2013.

   Suppose you want to do something to all the files whose names match a
   certain pattern and that contain a certain string or text that matches
   a certain pattern. For example, in a website with thousands of html
   files, all the ones that contain links to a site that disappeared. How
   to get a list of such files? I added an /ARRAY:&x switch to Kermit's
   GREP command for this. Then after the GREP command the resulting array
   can be accessed in a loop to process the desired files -- delete,
   rename, transfer, etc. Element 0 of the array tells now many files
   contained a match and how many elements are in the array (1-based).
   ckuus6.c, 22 Jul 2013.

   Updated SUPPORT command text. ckuus2.c, 3 May 2013.

   Added a CHANGE command that's part of the DIRECTORY / TOUCH family,
   with most of the same file-selection switches:

CHANGE /switches filespec string1 [ string2 ]

   Example:

CHANGE /RECURSIVE ~/web/*.html http://www.oldsite.com http://www.newsite.com

   The syntax of the command is a little annoying because Unix users would
   expect the filespec to come last, but the command shares a vast amount
   of parsing and execution code with DIRECTORY and TOUCH, which I didn't
   want to duplicate.

   CHANGE-specific switches:

/CASE:{ON,OFF} - Honor/Ignore alphabetic case when searching for string1
/MODTIME:{PRESERVE,UPDATE} - Modtime for changed file
/SIMULATE - Say which files would be changed without changing them.

   ckuusr.[ch], ckuus6.c, 3 May 2013.

   Built on Linux RH 5.9 x86_64, 18 Apr 2013.

   But when doing the Kerberos+SSL build:

 -L/usr/kerberos/lib -L/usr/local/ssl/

   lib -lssl -ldes425 -lpam -lz -lcrypto -lgssapi_krb5 -lkrb5 -lk5crypto
   -lcom_err -lncurses -lutil -lresolv -lcrypt -lm

   ?OpenSSL libraries do not match required version:
     * C-Kermit built with OpenSSL 1.0.1c 10 May 2012
     * Version found OpenSSL 0.9.8e-fips-rhel5 01 Jul 2008 OpenSSL
       versions prior to 1.0.0 must be the same. Set LD_LIBRARY_PATH for
       OpenSSL 1.0.1c 10 May 2012. Or rebuild C-Kermit from source on this
       computer to make versions agree. C-Kermit makefile target:
       linux+krb5+ssl Or if that is what you did then try to find out why
       the program loader (image activator) is choosing a different
       OpenSSL library than the one specified in the build.

   Looked into making ==, if >, etc, work with strings, as one might
   expect from other languages like Javascript. Turned out to be
   unworkable because these constructions accept not only numeric
   constants and numeric-valued variables, but also arithmetic
   expressions. The idea would have been that if either of the two
   operands was non-numeric once evaluated, lexical comparison would be
   done instead of arithmetic comparison. The fly in the ointment is
   something like this:

if > x*(x+1) 2000 ...

   When the arithmetic comparison operators are used, Kermit knows that
   the operands must be numbers, so any non-numeric strings like 'x' in
   the example above are automatically treated as macros and evaluated.
   But if we check first to see if the string is non-numeric, it will be,
   and the same evaluation will not be done, and the operands will be
   compared as strings, giving a result that could only be right by
   accident.

   For convenience, two new IF conditions have been added: IF BINARY
   filename succeeds if the named file is a binary file (meaning that it
   would be transferred in binary mode by Kermit): an executable program,
   an object file, an image file, etc. IF TEXT filename succeeds if the
   named file is a text file, such as the file you are reading, or program
   source code, or an HTML or XML file, etc, regardless of the character
   encoding. If the file is a directory, both IF TEXT and IF BINARY fail.
   If the file is a link, the result reflects the contents of the
   linked-to file. ckuus[26].c, 17 Apr 2013.

   Added a 9th element to the \ffileinfo() result array: analysis of
   contents of the file, if it is a regular file (not a directory or a
   link):

text:7bit      7-bit text (e.g. ASCII, ISO 646)
text:utf8      Unicode 8-bit Transformation Format (UTF-8)
text:ucs2      Raw Unicode
text:8bit      8-bit text (e.g. ISO 8859-1, Windows CP 1252)
text:unknown   Text, unknown encoding
binary         Binary (e.g. an executable, object, or image file)

   This analysis is performed using the same file scanner that is used
   during file transfer to set up text mode versus binary mode, and to set
   up the character-set conversion if possible. If the file is not a
   regular file, the 9th element is empty. Suppose the array is \&a[].
   Then:

if equ "\fleft(\&a[9],4)" "text"  (or if equ "\fword(\&a[9],1) "text")

   or:

if neq "\&a[9]" "binary"

   the file is a text file, not a binary file, a directory file, or a
   link. This is useful if you don't care about the encoding. ckuus4.c, 16
   Apr 2013.

   Sure enough the next day this caught mistakes in TWO of my overnight
   cron job scripts: One was "if not <misspelled variable name>". The
   other was "if neq ...". There is no "if neq". Added IF NEQ, IF LLE, IF
   LGE, since even I expected them to be there. ckuus[26].c, 16 Apr 2016.

    Dev.05

   Built on NetBSD 5.1.2, Solaris 9, FreeBSD 6.4, SCO OSR6.0.0, Linux
   Slackware 13.37.0, Linux RHEL5 (64-bit), Linux RHEL4 32-bit (with and
   without OpenSSL), all with no complaints.a

   Changed references in C-Kermit help text from kermit.columbia.edu to
   www.kermitproject.org. ckuus2.c, 15 Apr 2013.

   Here is an incompatible change: Noticed that "if lkjlkjlkj" (where
   lkjlkjlkj is just some gibberish) did not produce an error. The token
   following IF is supposed to be a keyword, a number, a variable that
   evaluates to a number, or the name of a macro whose value is a number.
   A string of gibberish is none of these, but the code in this case would
   treat the gibberish as "false" (i.e. as the name of a macro whose value
   was 0) and proceed to not execute the statement (or worse, if there
   were an ELSE part, it would execute it). I would hope that nobody ever
   noticed, much less relied on, this undocumented misfeature. Fixed in
   boolexp(), ckuus6.c, 15 Apr 2013.

   Added IF FUNCTION name, to test if the given built-in function is
   available. The name can be entered as name, \fname(), \\fname, or any
   combination, e.g. "if function left", "if func \fleft()", "if func
   left()", etc. ckuus[26].c, 15 Apr 2013.

   Added \ffilecompare(file1,file2) function. Returns 0 if the contents of
   the two files is identical, 1 if they differ, and -1 on any kind of
   error (file not found, etc). ckuus[24].c, 15 Apr 2013.

   Discovered that TOUCH /MODTIME could, in some cases, destroy an
   existing file, oops. Fixed in domydir(), ckuus6.c , 15 Apr 2013.

   Fixed \fpictureinof() to handle Unix filenames with tilde notation.
   Also checked to make sure that no other \functions() had this problem.
   ckuus4.c, 15 Apr 2013.

   Added a third element to the \fpictureinfo() result array: the "date
   taken", if any, recorded by the camera or scanner. This is done in the
   dumbest possible way, without attempting to parse the Exif structure;
   Kermit simply scans the first 8K of the JPG file looking for valid
   date-time strings, and keeps the earliest one found. ckuus4.c, 14 Apr
   2013.

   Looking at this in more detail... C-Kermit says DO KERMIT, WILL KERMIT.
   Remote says WILL KERMIT, DON'T KERMIT. In other words the remote is
   saying "I will do Kermit, I refuse to negotiate about Kermit". As soon
   as C-Kermit receives WILL KERMIT, it sends SB KERMIT SOP to tell the
   remote what its Kermit-protocol start-of-packet character is; this is
   required by RFC2840. The remote is required to respond with *its*
   start-of-packet character, but it never does, since its WILL KERMIT was
   in error. So upon receiving DONT Kermit I turned off the flag that said
   the other Kermit supports and will use the Kermit option. This allows
   the connection to be made to the Synchronet Telnet server without
   forcing the user to SET TELNET WAIT OFF or (even more obscure) SET
   TELOPT KERMIT REFUSE REFUSE. ckctel.c, 12 Apr 2013.

   Lawrence Woodman reported that with SET TELNET WAIT OFF, if C-Kermit
   telnets to a site that doesn't properly respond to all Telnet
   negotions, such as b4bbs.sampsa.com (running Synchronet BBS software),
   the initial connection works OK (Kermit doesn't wait), but then after
   escaping back and connecting again, TELNET WAIT switches back to ON.
   This is evidently because of the TELNET KERMIT negotiations, which
   require waiting. But it occurs to me that nobody is using the TELNET
   KERMIT option due to lack of support for it, so if the user says SET
   TELNET WAIT OFF, this should not be overriden silently. (In fact,
   C-Kermit said WILL KERMIT, the remote said DONT KERMIT, so I think the
   problem is deeper, because for some reason C-Kermit was sending SB
   REQ_STOP even though the Telnet KERMIT option was not negotiated, but
   let's come back to this if there is ever any reason to.) I fixed the
   problem by not sending SB_STOP_REQ is SET TELNET WAIT is OFF. ckctel.c,
   line 2238, 9 Apr 2013.

    Dev.04

   Made a new function \ffileinfo(name,&a) that populates the specified
   array with 7 or 8 elements:

 1. the file's name;
 2. the full path of the directory where the file resides;
 3. the file's modification date-time yyyymmdd hh:mm:ss;
 4. platform-specific permissions string, e.g. "drwxrwxr-x" or "RWED,RWE,RE,E";
 5. platform-specific permissions code, e.g. an octal number like 40775;
 6. the file's size in bytes;
 7. file type: 1=regular file; 2=executable; 3=directory; 4=link; 0=unknown.
 8. (if filename is link) name of linked-to file.

   ckuusr.h, ckuus[24].c, 14 Mar 2013.

   ziperm() and zgperm() did not work in Unix for filespecs that used
   tilde notation, e.g. ~/kermit/ckuusr.h. Fixed in ckufio.c, 14 Mar 2013.

   Added SET EXIT MESSAGE { ON, OFF, STDOUT, STDERR }, so the text (if
   any) from an EXIT command (e.g. EXIT 1 "File not found") can be
   supressed, printed normally, or sent to stderr. Added EXIT MESSAGE
   status to SHOW EXIT and updated HELP SET EXIT. ckuus[235].c, 13 Mar
   2013.

    Dev.03

   Since Oct 2006 C-Kermit has had a very handy TOUCH command, much more
   useful that Unix's because of all the file-selection options (switches)
   that go with it, the same, in fact, as the DIRECTORY command, even
   though a few of them (such as /OUTPUT) don't make much sense with
   TOUCH. But one thing that Kermit TOUCH can't do that Unix touch can is
   to set the file's mod time to an arbitrary date-time. Up until now,
   Kermit TOUCH can only give it the current date-time. To add this
   capability in a sensible way, I started by giving TOUCH its own switch
   table. In doing this I also corrected a long-standing error in the
   original DIRECTORY switch table, in which one of the keywords,
   /FOLLOWLINKS, was out of order, which could have resulted in spurious
   parse errors or failures. ckuusr.h, ckuus6.c, 12 Mar 2013.

   Added TOUCH /MODTIME:xxx, allowing a specific date-time to be set; xxx
   is a free-format date and/or time as described by "HELP DATE". This
   works both for all existing files that are selected by the switches and
   wildcard patterns, or for a single nonexistent file, i.e. to create a
   new file with a given modification date-time. Also added TOUCH /LIST,
   which lists the files that were touched, and and TOUCH /SIMULATE which
   lists the files that would be touched without actually touching them.
   ckuus6.c, 12 Mar 2013.

   New HELP TOUCH text. ckuus2.c, 12 Mar 2013.

   Fixed HELP INCREMENT and HELP DECREMENT to clarify that the operations
   use integer arithmetic and the result is always an integer. ckuus2.c,
   13 Mar 2013.

   A large manufacturing company upgraded from MS-DOS Kermit to Kermit 95
   because new PCs were installed that could no longer use MS-DOS Kermit.
   These PCs are used to control Cincinnati (now MAG IAS) machines (press
   brakes, composite tape layers, etc), which use their own implementation
   of Kermit protocol to exchange data with the PC. Where MS-DOS Kermit
   had been working fine in this capacity for some 20 years, K95 failed
   consistently after the 13th packet. The Cincinnati machines are quite
   old and (from the standpoint of their communications) quite primitive,
   communicating over a serial port at 19.2Kbps with no flow control. When
   receiving a file, they buffer the incoming file data and when the
   buffer fills, they "turn around" to write out the buffer, but this
   takes a long time. The difference between MS-DOS Kermit and K95 (and
   C-Kermit for that matter, which runs the same protocol code) is that
   packet timeouts in MS-DOS Kermit are fixed, whereas those in
   C-Kermit/K95 are dynamic, varying according to the characteristics of
   the transfer in progress. In this case the first 12 ACKs were received
   promptly so K95's timeout reduced itself to an interval shorter than
   the time needed by the machine to write out its buffer. K95 resent the
   packet at a time when the machine was not prepared to receive it and
   matters went downhill from there. The resolution was to tell K95 to use
   a longer timout interval, and to make it fixed, not dynamic:

SET SEND TIMEOUT 20 FIXED

   This raised two issues:

 1. This feature was implemented in C-Kermit 6.0.192 from 1996, and
    as such is documented in "Using C-Kermit", but not online, so it
    took me quite a while to find it even though it's my own creation.

 2. It's not documented in the brake.html page, which discusses how to
    use Kermit software with Cincinnati CNC machines.

 3. A long fixed timeout should have been included in the ROBUST command.

   I updated the ROBUST command in ckuus5.c, and updated the brake.html
   page on the new Kermit website. 12 Mar 2013.

   The change of Nov 2 still needs work. Modern Unix servers tend to have
   ever-longer pathnames so even with the previous change we're still
   seeing the truncated pathnames on the file transfer display of the
   sender which is less than helpful when sending a large group of files;
   you can't see the filenames and have no idea how far along the transfer
   is (because the thermometer applies only to the current file, not the
   whole group). Why should C-Kermit, when receiving files, send back the
   entire pathname when the incoming file is being stored in its current
   directory? No reason. Added code to chop it off. ckcpro.w, 11 March
   2013.

   (Obviously it would be better for the progess indicator to apply to the
   whole transfer than to the current file out of possibly many, but that
   would require a change to the protocol itself, in which the file sender
   makes a pass through the file list to get the total size of all files
   and then sends a new kind of message to the receiver with this
   information. Possibly this could be done in the A packet: File #x out
   of y in a transfer of total size z.)

   In the 1980s and 90s, before switches were added to Kermit command
   syntax, there was a MOVE command, which meant to send a file and then
   delete the original after it had been sent successfully. When switches
   were added in C-Kermit 7.0 in 2000, this function was assigned to SEND
   /DELETE. The MOVE command was left behind for compatibility.
   Unfortunately it's so similar to the Unix 'mv' that I (for one) keep
   using it when I mean RENAME. On the supposition that nobody uses MOVE
   in the SEND /DELETE sense any more (if they ever did), I changed it to
   be a synonym for RENAME. If you build C-Kermit with -DOLDMOVE in
   KFLAGS, the old behavior is restored. ckuus[r2].c, 11 Mar 2013.

   The DIRECTORY command has a lot of switches for file selection, sorting
   of results, etc. These include an /ARRAY: switch that allows the
   resulting filenames to be stored in an array rather than being printed,
   so they can be processed by a script; for example, to do something with
   the files that were selected by the DIRECTORY command switches. But the
   array was constructed before processing the switches and doing any
   sorting. So, for example, DIRECTORY /SORT:SIZE /TOP:10 /ARRAY:&a, which
   you would expect to load the array a with the 10 largest files in the
   current directly in reverse order of size, loads all the files in
   alphabetical order. Fixed in domydir(), ckuus6.c, 11 Mar 2013.

   The S-Expression processor sometimes dumped core if an invalid operator
   was given. Fixed in dosexp(), ckuus3.c, 11 March 2012.

   Added note about Raspberry Pi (that it builds normally with any of the
   Linux targets) to the Makefile, 11 Mar 2013.

   Correction to yesterday's, which didn't account for SET CD HOME.
   ckcpro.w, ckcmai.c, ckuus[454].c, 3 Nov 2012.

   When uploading files to Unix from K95, it has become increasingly
   unlikely that the filename is shown on the file-transfer display
   because Unix pathnames are growing longer and longer all the time, and
   the name part disappears off the edge. This can't be fixed in K95
   (since nobody has yet been able to build it from source code), but it
   can be ameliorated in C-Kermit in many cases by shortening the pathname
   sent back to K95 when receiving files from or under the user's Unix
   login directory, by replacing login directory path prefix with "~/".
   This was done within #ifdef UNIX .. #endif in ckcpro.w, in the place
   where the protocol state machine handles an F packet. It could probably
   also be done in VMS, but probably not worth it ("SYS$LOGIN:" is not
   exactly short). This could be expanded, with some effort, to other
   people's directories ("~eddie/"). ckcpro.w, ckcmai.c, makefile, 2 Nov
   2012.

   Added android.mk (makefile) and android.txt (README) to regular Unix
   tarball. 20 Jul 2012.

   Built OK on Linux RHEL4 32-bit with: "make linux", "make linux+SSL"
   (OpenSSL 0.9.7a). Built OK on Linux RHEL5 64-bit with: "make linux",
   "make linux+krb5", "make linux+SSL KFLAGS=‑UCK_DES" (0.9.8q). Also with
   "make linux KFLAGS=‑DANDROID" to see the vanity herald. Built OK on
   Solaris 9 with and without OpenSSL (0.9.8q). Built OK on NetBSD 5.1.2
   with and without OpenSSL (0.9.9-dev). Built on NetBSD 5.1.2 with
   Kerberos V 1.6.3; lots of warnings but it runs.

   From Ian Beckwith (Debian), support for multiarchitecture curses
   library in Linux; also libresolv, libcrypt, liblockdev, libk5crypto,
   libgssapi_krb5. Don't know if these changes work, but at least they
   don't seem to hurt anything. makefile, 20 Jul 2012.

   From Adam Friedlander: an updated OpenSSL version test obtained after
   consultation with Jeff Altman incorporating the new rules for when the
   OpenSSL 1.x.yz ABI changes. ck_ssl.[ch], 20 Jul 2012.

   Vanity herald for Android: ckuver.h, 20 Jul 2012.

   From Tim Sneddon:
   [217]http://tim.sneddon.id.au/blog/Posts/C-Kermit_for_Android -
   Adaptation of C-Kermit to Android via the Linux path; required very few
   changes, mainly #ifdef'ing a couple Linux APIs not supported in
   Android. ckcdeb.h, ckufio.c, ckutio.c, 20 Jul 2012.

   Changed version to 9.0.304 Dev.01. ckckmai.c, 28 May 2012.

   From Adam Friedlander: OpenSSL version test was preventing C-Kermit
   from starting when the installed OpenSSL version was >= 1.0.0 and there
   was a change in the last letter (e.g. 1.0.0a to 1.0.0b) or to the last
   number (e.g. 1.0.0 to 1.0.1), but these changes do not indicate ABI
   incompatibility. This was forcing rebuild and reinstallation of
   C-Kermit every time a minor update was made to OpenSSL (e.g. on Ubuntu
   Linux that has preinstalled binaries). ck_ssl.[ch], ckcmai.c, 28 May
   2012.

   Fixed a problem with 'make linux "KFLAGS=‑DNOICP -DNOSPL -DNOHELP
   -DNODEBUG"' in which fp_rounding and fp_digits came up undefined.
   ckuus4.c, 28 May 2012.

   Changed version to 9.0.303. ckcmai.c, 23 Aug 2011.

   From Edward Berner: C-Kermit 9.0 on OpenBSD on sparc64 gets a "Bus
   error" and dumps core when receiving a file. Some variables were
   defined long or CK_OFF_T and extern'd as int from other modules. Edward
   found and corrected all instances of this. The variables were filcnt,
   dest, filrej, dialcapas. ckcpro.w, ckuusx.c, 23 Aug 2011.

   Fixed freebsd+ssl and netbsd+ssl, netbsd+krb5, and netbsd+krb5+ssl
   targets to have CC=$(CC) instead of CC=gcc; ditto for CC2, and adjusted
   line breaks in freebsd and freebsd+ssl targets for easier patching.
   makefile, 21 Aug 2011.

    9.0.302

   Changed the version to 9.0.302, ckcmai.c, 20 Aug 2011. Released and
   announced the same day.

   FreeBSD 9 switched from utmp to utmpx, which broke compilation of
   Kermit on that version. Furthermore, the UUCP lockfile conventions
   changed in FreeBSD 8, which did not prevent C-Kermit from compiling,
   but any attempt to lock a terminal or pty device would fail. Thanks to
   Alexey Dokuchaev "danfe" for finding and patching the problems. I undid
   the patches and fixed the code so it didn't need to be patched, except
   for some declarations in the ck_crp.c module, which I felt had better
   not be changed without thoroughly testing the changes on dozens of
   different platforms, which I don't have time to do (in any case, it
   builds OK on FreeBSD 9 without the patch). In particular I made
   completely new makefile targets for FreeBSD 4.0 and later, which
   automatically detect FreeBSD 8 and FreeBSD 9 to enable the appropriate
   feature tests in the code, for a regular build and a build with
   OpenSSL. These changes should affect only FreeBSD. ckutio.c, ckufio.c,
   ck_crp.c, ckuus5.c, makefile, 20 Aug 2011.

   Added and successfully used a new solaris9+krb5+ssl target. makefile, 8
   Aug 2011.

   Added another search term for lk5crypto in the linux+krb5 targets.
   makefile, 20 July 2011.

   In the new copyright notice, copied from the BSD license template, one
   instance of "the <ORGANIZATION>" was not replaced by "Columbia
   University". Fixed in ckcmai.c, 19 July 2011.

   After the initial release I made some small changes that affect only
   HP-UX 5.x: added -DVOID=void and -DCKVOID=void to the hpux0500 makefile
   targets, and put #ifdefs around #include <errno.h>, which (in the
   WinTCP case) didn't protect itself against multiple inclusion (which is
   happening in other header files, not in Kermit). makefile, ckucmd.c,
   ckucon.c, ckutio.c, ckufio.c, ckcnet.c, ckcftp.c, 14 July 2011.

    C-Kermit 9.0.301

   Updated version text and date. ckcmai.c, makefile, 11 July 2011.

    C-Kermit 9.0.301 Beta.01

   Built and tested on Solaris 9, Solaris 10, and RHEL5. 6 July 2011.

   From SMS: To avoid the %CC-W-PTRMISMATCH1 complaints from ck_ssl.c, add
   two (harmless) type casts at lines 2460 and 2773, 6 July 2011.

   On Solaris 10 and 11, DNS lookups don't work. It seems these Solaris
   versions have INADDRX and INADDRX_NONE defined, thus triggering the
   code in ckcnet.c, ckucns.c, and ckcftp.c #ifdef'd on these symbols, but
   that code doesn't work in this case. This happens building with gcc as
   well as with Sun cc. Put #ifdefs in ckcnet.h to undefine these symbols
   (if they are defined after including all the header files) for Solaris.
   I didn't bother trying to differentiate the Solaris versions because
   the symbols are not defined in Solaris 9 or earlier, and they should
   not be used in Solaris 10 or 11. ckcnet.h, 6 July 2011.

    C-Kermit 9.0.300

   Removed solaris9_64 target from makefile. It builds but it doesn't work
   at all. 30 Jun 2011.

   Updated version to 9.0.300 and removed the Beta designation. ckcmai.c,
   makefile, 28 Jun 2011.

   From Martin Vorlaender, a fix for the VMS file-transfer display and
   statistics, a place where a file length wasn't being cast to CK_OFF_T
   in zchki(). ckvfio.c, 28 Jun 2011.

   From Arthur Marsh, a few more directories to test for libresolv in
   Linux. makefile, 26 Jun 2011.

   I had been wanting the S-Expression (ROUND x) to allow a second
   argument n, which, if given, tells where the rounding should occur. If
   n is positive, the number is rounded to n decimal places. If zero, it
   is rounded to the nearest integer If negative, the number is rounded to
   the nearest power of 10; e.g. -2 means "to the nearest hundred". If
   ROUND is used as before, with one argument, it works as before.
   ckclib.c, ckuus3.c, 25 Jun 2011.

   Got access to perhaps the last living 4.3BSD VAX system. It doesn't
   have SEEK_CUR so I had to #ifdef out the \fpicture() function. Aside
   from that, no problems. ckuus4.c, 24 Jun 2011.

   Fixed some typos in COPYING.TXT (noticed by Ian Beckwith). 24 Jun 2011.

   I found a Linux box that had both Kerberos 4 and 5 installed and tried
   'make linux+krb5+krb4', which failed because of missing DES functions.
   Tried 'make linux+krb5+krb4 KFLAGS=-UCK_DES', but that fails too, even
   though it doesn't fail for Kerberos 5 alone, so probably some Krb4 code
   is making unguarded calls to the DES routines. What is really needed is
   a way to completely strip all DES references from any given build, code
   and makefile, a big deal. 21 Jun 2011.

   In Debian 7.0, libk5crypto could not be found without adding another
   clause to 'make linux+krb5'. That done, the SSL build (1.0.0d) was OK,
   as well as the krb5+ssl one. makefile, 21 Jun 2011.

   Got access to Debian 5.0 and 7-to-be ("Wheezy/Sid"). Regular 'make
   linux' is OK in Debian 5, but in 7 can't find crypt, res_search, or
   dn_expand; had to add more library search clauses to 'make linux'.
   makefile, 21 Jun 2011.

   Got reports back on HPUX from Peter Eichhorn, almost all good on HP-UX
   7, 8, 9, 10, and 11. 21-22 Jun 2011.

   Checked current code on RHEL4, found that my GSSAPI-lib finding
   makefile target didn't look in enough places; added some more.
   makefile, 21 Jun 2011.

   Really it would have been nicer if \s(xx[4]) returned a single
   character, the 4th character of xx, but it's too late now. Added
   another "separator" character '.' (period) for that: \s(xx[4.]) is the
   4th character of xx. ckuus4.c, 20 Jun 2010.

   Back to SCO OSR5.0.7... This failed before because 'rdchk' came up
   unknown at link time, unlike all previous OSR5's, that used rdchk() in
   place of the FIONREAD ioctl. Added #ifdefs to make a special case for
   5.0.7. I'm not sure this is the best way, but this is the minimal
   change to get it to work. If anybody cares, maybe the same can be done
   for previous OSR5 releases. ckutio.c, 20 Jun 2010 (search for
   SCO_OSR507).

   SCO OpenServer 5.0.7 i386 32 sco32v507 1895724 No TCP/IP SCO OpenServer
   5.0.7 i386 32 sco32v507net 2246792 With TCP/IP

   When using compact substring notation, \s(xx[4]) returns the whole
   string xx starting at position 4, but \s(xx[4:]) returns an empty
   string. Fixed the latter to be like the former. ckuus5.c, 20 Jun 2010.

   Ditto for Solaris 2.6/i386, except 57.6Kbps, 4K-byte packets, no
   problem. Solaris 8/i386, ditto. 19 Jun 2011.

   SCO OpenServer 5.0.5 i386 32 sco32v505udk 1940964 No TCP/IP SCO
   OpenServer 5.0.5 i386 32 sco32v505udknet 2314668 With TCP/IP Sun
   Solaris 2.6 i386 32 solaris26g 4661368 Sun Solaris 8 i386 32 solaris8g
   4675432

   Transferred the tarball over serial ports to SCO OSR5.0.5 at 38.4Kbps,
   the highest speed supported, 12 minutes, no errors, 3300cps. Unpack,
   make sco32v505udk, OK. Also built the TCP/IP version and it almost made
   an outbound connection, but only once (not a Kermit problem but
   something with the TCP/IP stack). 19 Jun 2011.

   For the pluggable-disk OS's that boot OK but lack a working network, I
   rigged up a serial connection using a DB9-FF null modem cable, and then
   a DB9-MF modem cable to make it reach. I don't see any modem signals on
   either end, but the data goes through OK. COM1 on the desktop PC,
   /dev/ttyS1 or whatever on Lab. Since there are no modem signals, can't
   use RTS/CTS. At 57600bps with Xon/Xoff, 500-byte packets and sliding
   windows, transfers work OK at about 5000cps using 5 window slots; takes
   8 minutes to transfer the gzipped C-Kermit tarball. Kermit to the
   rescue. 19 Jun 2011.

   More important he knew how to force gcc to load the right header files
   for OpenSSL 1.0.0d (by using '-isystem' rather than '-I'). Previously
   it was using the 0.9.8r header files but linking with the 1.0.0d
   libraries. This is not in the sources or makefile; it's done when
   giving the 'make' command:

export PATH=/usr/bin:$PATH
  export SSLINC=-isystem/usr/include
  export "SSLLIB=-L/usr/lib -Wl,-rpath,/usr/lib"
  make linux+ssl

   Folded the previous linux+openssl+zlib+shadow+pam and
   linux+openssl+shadow targets into linux+ssl. Checked the linuxso
   (scripting only) target, builds OK, 600K. Made new subroutinized
   linux+krb5+krb4 target but can't find anyplace to test it. Made new
   subroutinized linux+shadow+pam target, works fine on RHEL4. Revised
   comments and lists again. makefile, 18 Jun 2011.

   Nelson Beebe found two places where I had SSLLIBS in the makefile
   instead of SSLLIB. makefile, 18 Jun 2011.

   From John Dunlap: "Watching the server screen led me to offer a
   cosmetic patch for ckuusx.c. I noticed that the server screen said it
   was "RESENDING" when it really wasn't. The attached patch emits blanks
   to insure that old labels are completely erased." ckuusx.c, 17 Jun
   2011.

   sizeof() can return a long or an int, so neither
   printf("%d",sizeof(blah)); or printf("%ld",sizeof(blah)); can be used
   everywhere. Changed the "sizeofs" section of SHOW FEATURES in the
   dumbest (and therefore most portable) way to squelch the warnings.
   ckuus5.c, 17 Jun 2011.

    C-Kermit 9.0.299 Beta.01

   16 June 2011 builds (Beta.01):

NetBSD 5.1 i386   32/64  netbsd+krb5+ssl   2451757 OpenSSL 0.9.9 MIT Krb5 1.6.3
Solaris 9  sparc  32/64  solaris9+krb5     2543036 MIT Kerberos 5 1.7.1
Solaris 9  sparc  32/64  solaris9+ssl      5021544 OpenSSL 0.9.8q (gcc)
Gentoo...    ppc    32/64  linux             2386597
Gentoo...    ppc    32/64  linux+ssl         2593561 OpenSSL 0.9.8r
Gentoo...    ppc64   64    linux             2749015
Gentoo...    ppc64   64    linux+ssl         3002150 OpenSSL 0.9.8r
RHEL5      x86_64  64    linux+krb5 (*)    2563878 MIT Kerberos 5 1.6.1
RHEL5      x86_64  64    linux+krb5+ssl(*) 2563878 MIT Kerberos 5 1.6.1
Fedora 14  i386   32/64  linux+krb5+ssl    2539891 MIT Krb5 + OpenSSL 0.9.8r

* KFLAGS=-UCK_DES

   Added lots of tests to the Linux Kerberos 5 entries, linux+krb5 and
   linux+krb5+ssl, because some have libk5crypto and some don't; some have
   libcom_err and some don't; and some have libgssapi_krb5 (e.g. RHEL5,
   OpenSuse 11.2) whereas others have libgssapi (Gentoo).

   Updated cu-solaris+krb5 target to test whether the GSSAPI library is
   called libgassapi or libgassapi_krb5. makefile, 16 Jun 2011.

   Updated the solaris9+ssl target to do the DES testing. makefile, 16 Jun
   2011.

   Changed the cu-solaris9-krb5 target to test for the presence of DES
   because DES isn't there, to see if this would allow a Kerberos build to
   proceed. And it worked, amazing. At least the build completed, I have
   no way to test the Kerberos part. makefile, 16 Jun 2011.

   Make a new netbsd+krb5+ssl target based on the combination of the new
   netbsd+ssl and netbsd+krb5 targets. There were lots of warnings in the
   compilation but no errors, but it produced an executable that starts
   and does normal things but I have no idea if the SSL or Kerberos
   functions work. makefile, 16 Jun 2011.

   15 June 2011 builds (Beta.01):


AIX 5.3                 ppc    32/64   aix+ssl        3283846 OpenSSL 0.9.8m
NetBSD 5.1              i386   32/64   netbsd         2159863
NetBSD 5.1              i386   32/64   netbsd+ssl     2350274 OpenSSL 0.9.9-dev
NetBSD 5.1              i386   32/64   netbsd+krb5    2349627 MIT Krb5 1.6.3
FreeBSD 8.2             i386   32/64   freebsd        2298414
FreeBSD 8.2             i386   32/64   freebsd+ssl    2448961 OpenSSL 0.9.8q
OpenBSD 4.7             i386   32/64   openbsd        2266132
OpenBSD 4.7             i386   32/64   openbsd+ssl    2409263 OpenSSL 0.9.8k
MirBSD 10               i386   32/64   mirbsd         2216601
MirBSD 10               i386   32/64   mirbsd+ssl     2358318 OpenSSL 0.9.8r
OpenSuse 11.2           x86_64  64     linux          2348468
OpenSuse 11.2           x86_64  64     linux+ssl (*)  2546540 OpenSSL 0.9.8r
RHEL 5.6                ia64    64     linux          4390687
RHEL 5.6                ia64    64     linux+ssl (*)  4775007 OpenSSL 0.9.8e
Ubuntu 9.10             i386   32/64   linux          2275523
Ubuntu 9.10             i386   32/64   linux+ssl      2466708 OpenSSL 0.9.8r
Gentoo 1.12.13          ppc    32/64   linux          2386597
Gentoo 1.12.13          ppc64   64     linux          2749015
Gentoo 1.12.13          ppc64   64     linux+ssl      3002150 OpenSSL 0.9.8r
Gentoo 1.12.13          sparc  32/64   linux          2478382
Gentoo 1.12.13          sparc  32/64   linux+ssl      2690499 OpenSSL 0.9.8r
Solaris 9               sparc  32/64   solaris9       2849896
Solaris 10              i386   32/64   solaris10      2837620
IRIX 6.5                R10000 32/64   irix65         2869704

* and KFLAGS=-UCK_DES

   Tried building on NetBSD 5.1 with Heimdal Kerberos using:

   make netbsd+krb5 \

 "KFLAGS=-DHEIMDAL" \
 "K5INC=-I/usr/include" \
 "K5LIB=-L/usr/lib"

   It found all its headers OK, but it blew up in ckuath.c. Small wonder,
   ckccfg.html says:

HEIMDAL
    Should be defined if Kerberos V support is provided by HEIMDAL. Support
    for this option is not complete in C-Kermit 8.0. Anyone interested in
    working on this should contact kermit-support.

   KERBEROS VERSION:

   'krb5-config --version' gives the MIT Kerberos 5 version number.

   Fixed the new linux+ssl target to actually use the SSLINC and SSLLIBS
   definitions, oops. makefile, 15 Jun 2011.

   Fixed some printf %ld vs int instances in the sizeofs section of SHOW
   FEATURES. ckuus5.c, 15 Jun 2011.

   SSL builds with OpenSSL < 0.9.7 fail even though there is code to
   support the older SSL.

   Various linux+krb5 builds fail because can't find -lgssapi_krb5

   In OpenSUSE 11.2 with OpenSSL 0.9.8r we bomb on undefined references
   from various DES library routines. Builds OK without DES.

   Made new targets for MirBSD, mirbsd and mirbsd+ssl, makefile 15 Jun
   2011.

   Tried to build with Kerberos 5 on Solaris, fails because the DES
   library no longer exists. This one is beyond me, sorry.

   Same deal for the netbsdnc target, now it simply defined NOCURSES and
   chains to the main netbsd target. makefile, 15 Jun 2011.

   Same deal for Kerberos 5, make a new netbsd+krb5 target and it builds
   ok, at least once one figures out where the Kerberos headers and libs
   are. makefile, 15 Jun 2011.

   Tried to build on SCO Open Server 5.0.7 but it fails at link time
   because it can't find rdchk(). But it's supposed to be there! Come back
   to this later...

Red Hat 6.1             i386   32/64   linux          2332545
Red Hat 7.1             i386   32/64   linux          2368528
Red Hat EL4             i386   32/74   linux          2363067
Red Hat EL5.6           i386    64     linux          2371279
Solaris9                sparc  32/64   solaris9       2849896
Solaris9+ssl            sparc  32/64   solaris9       5021764
Solaris10               sparc  32/64   solaris10      2855776
QNX                     i386    32     qnx32          2012323
NetBSD 1.5.1            i386   32/64   netbsd         2198055
NetBSD 5.1              i386   32/64   netbsd         2159863
OpenBSD 2.5             i386   32/64   openbsd        2236036
Mac OS X 10.6.7         x86_64  64     macosx         2.7M
Mac OS X 10.4.11        ppc    32/64   macosx         2496304
Debian 2.1              i386   32/64   linux          2213221
FreeBSD 4.4             i386   32/64   freebsd        2291333
FreeBSD 3.3             i386   32/64   freebsd        2147370
SINIX 5.42              mips    32     sinix542       3319325 (1995)
SCO Unixware 2.1.3      i386    32     uw213          2242176
SCO OSR6.0.0            i386   32/64   sco_osr600     2368300

   More builds, 14 June 2011:

VMS 6.2                 alpha   32     make mn        2556928 No TCP/IP
VMS 6.2                 alpha   32     make m         3112960 UCX 4.0
Solaris 11              i386   32/64   solaris11      2823860
Solaris 11              i386   32/64   solaris11+ssl  2993660 OpenSSL 0.9.8l
NetBSD 5.1              i386   32/64   netbsd+krb5    2307855 Kerberos 5
Linux Slackware 12.1.0  i386   32/65   linux          2175754
Linux Fedora 14         i386   32/64   linux          2256514
Linux Fedora 14         i386   32/64   linux+ssl      ....... OpenSSL 1.0.0d
Linux Fedora 14         i386   32/64   linux+krb      2449614 (*)

(*) make linux+krb5 "LIBS=$LIBS /lib/libk5crypto.so.3 /lib/libcom_err.so.2"

   Noticed that netbsd+ssl build on NetBSD 5.1 said "NetBSD 1.5" in its
   banner. Fixed by replacing the old hardwired target with the new
   "subroutinized" target a'la linux+ssl and adapting it to NetBSD.
   makefile, 15 Jun 2011.

   On FreeBSD 4.4, it blows up with: ckufio.c: In function vpass':
   ckufio.c:8201: conflicting types for 'initgroups'
   /usr/include/unistd.h:154: previous declaration of 'initgroups'
   ckufio.c:8201: warning: extern declaration of 'initgroups' doesn't
   match global one. Fixed by defining NODCLINITGROUPS for FreeBSD in
   ckufio.c. It might not be the right fix, but I don't have a lot of
   other FreeBSD versions to compare with. Anyway now it builds OK on 4.4,
   and also on FreeBSD 3.3. ckufio.c, 13 Jun 2011.

   SuSE 7.0... boots OK but telnet server doesn't work. Can telnet out but
   it's too flaky, connection drops if I try to transfer a file.

   OpenBSD 2.5 [1999] OK. Red Hat 7.1 OK. Red Hat 7.1 with OpenSSL 0.9.6
   not OK, same error as with 0.9.5a:

   ckuath.c In file included from ck_ssl.h:48,

from ckuath.c:225:

/usr/include/openssl/des.h:77: warning: redefinition of `Block'
ckuat2.h:86: warning: `Block' previously declared here
/usr/include/openssl/des.h:83: redefinition of `struct des_ks_struct'
/usr/include/openssl/des.h:91: warning: redefinition of `Schedule'
ckuat2.h:90: warning: `Schedule' previously declared here

   So it appears that OpenSSL support is broken for pre-0.9.7. Tried
   building it again with -UCK_SSL (since the errors are originating from
   from des.h)... But it still failed exactly the same way. I found
   #includes for des.h in ckuath.c and and ck_ssl.h and #ifdef'd them out,
   but it still fails:

   In file included from /usr/include/openssl/evp.h:89,

from /usr/include/openssl/x509.h:67,
from /usr/include/openssl/ssl.h:69,
from ck_ssl.h:51,
from ckuath.c:227:

/usr/include/openssl/des.h:77: warning: redefinition of `Block'
ckuat2.h:86: warning: `Block' previously declared here
/usr/include/openssl/des.h:83: redefinition of `struct des_ks_struct'
/usr/include/openssl/des.h:91: warning: redefinition of `Schedule'
ckuat2.h:90: warning: `Schedule' previously declared here

   Built OK on Debian 2.1. 13 Jun 2011.

   Tried harder to revive the build-all machine, now it sort of works, but
   not all of the bootable OS's work. Built C-Kermit 9.0 OK on OpenBSD
   3.0. Built OK on QNX 4.25 but had to #ifdef references to IXANY in
   ckutio.c and ckupty. Built OK on NetBSD 1.5.1 (2000). Tried "make
   netbsd+ssl" on this one, it's OpenSSL 0.9.5a 1 Apr 2000, but it bombs
   out in ckuath.c, no big deal. Another problem in NetBSD 1.5.2 is that
   even though off_t is 8, CK_OFF_T is 4. Worth noting but not worth
   fixing unless someone else notices. 13 Jun 2011.

   Built OK on AIX 5.3. Built OK on Solaris 10. 11 Jun 2011.

   Tried to resurrect my old SCO Xenix 2.3.4 machine, also headless.
   Amazingly it still works; it can't use a monitor but I can Telnet to
   it. Had to tweak some #ifdefs but I got a no-net version built
   successfully. According to my notes, it hasn't been possible to build
   with TCP/IP since C-Kermit 8.0, but how many people ever had SCO Xenix
   2.3.4 with TCP/IP anyway? Anyway we still have the binaries for
   C-Kermit 7.0. ckuus4.c, 10 Jun 2011.

   Built OK on NetBSD 5.1. 10 Jun 2011.

   Tried to resurrect my old "build-all" machine, an IBM Netfinity 3500
   from 1997 with 20-some mountable bootable hard disks with lots of 1990s
   OS's on them. No dice. I can see the BIOS but not the hard disks. The
   configuration is still correct because it tries to boot from the
   mountable hard disk, but it fails (I tried six different ones).

   Tried to resurrect my old Siemens Nixdorf RM 200 MIPS machine. Booted
   OK, headless even, but makes a hellish high-pitched whine, like a
   dentist drill. It's pretty slow too. "make sinix542" (for SINIX 5.4.2)
   bombed at link time on no rdchk(). Fixed by #including <sys/filio.h>.
   ckutio.c, 10 Jun 2011.

   Built OK on VMS 8.3 on Alpha with Multinet 5.3. The SSL build failed
   but I'm not going to worry about it. 10 Jun 2011.

   Built OK on VMS 8.3 on Alpha, no net. DEC C caught a couple glitches in
   the new code that gcc didn't catch, which I fixed. ckuus[25].c, 10 Jun
   2011.

   Added \q() as an alternative to the more verbose \fliteral() for
   quoting strings that contain characters (like \) that would otherwise
   be significant to Kermit. It's more efficient because it isn't a
   function call, and 'q' is an intuitive letter to mean 'quote'. It also
   works better than \fliteral() because functions treat commas and braces
   specially. ckuus4.c, 10 Jun 2011.

   Noticed that \frecurse() would dump core if called with no arguments.
   Fixed in ckuus4.c, 9 Jun 2011.

   Back to "make linux+ssl" on RHEL5... I took the coward's way out and
   added code to the makefile target to check whether the build worked
   (somebody let me know if there is a better way to check), and if not to
   give a message suggesting they "make clean ; make linux+ssl
   KFLAGS=-UCK_DES". makefile, 9 Jun 2011.

   Added XMESSAGE, which is to MESSAGE as XECHO is ECHO: prints the text
   without a line terminator, so it can be continued by subsequent
   [X]MESSAGE commands. ckuusr.[ch], 9 Jun 2011.

   Renamed all old Mac OS X makefile targets to have the prefix "old" to
   avoid confusing them with the current targets, and made macosx10 a
   synonym for macosx, so those who used previous makefiles will get a
   current target without having to know the new name. makefile, 9 Jun
   2011.

   Documented the SET COMMAND VARIABLE-EVALUATION command, which I added
   in 2008. ck90.html, 9 Jun 2011.

   Changed SET VARIABLE-EVALUATION to SET COMMAND VARIABLE-EVALUATION, but
   left the former version available. ckuusr.c, 9 Jun 2011.

   7 Jun 2011:

   Corrected various #ifdefs (or lack of them) when building C-Kermit with
   different combinations of feature-selection options such as NOCSETS,
   NOICP, NOLOCAL, NOSPL, NOUNICODE, etc. ckcfns.c ckcmai.c ckcxla.h
   ckuus2.c ckuus4.c ckuus5.c ckuus6.c ckuusr.c, 7 Jun 2011. After running
   the script that does all these builds (84 of them) I ran it again to
   make sure that none of the changes broke builds that succeeded before
   the changes were made.

   Built OK on Solaris9 ("make solaris9") Ditto with Krb5 and OpenSSL
   0.9.8q ("make solaris9g+openssl+shadow+pam+zlib")

   Built OK on Mac OS X 10.4.11 ("make macosx"). Also "make
   macosx+krb5+openssl.

   Built OK on Linux RHEL4 ("make linux"). Built OK on Linux RHEL4 with
   OpenSSL 0.9.7a ("make linux+ssl"). Built OK on Linux RHEL5 ("make
   linux").

   "make linux+ssl" fails on RHEL5 because of DES, even though the target
   tests for the presence or absence of the DES libraries. In this case
   the libraries are there but they lack the functions des_ecb3_encrypt,
   des_random_seed, and des_set_odd_parity. The build succeeds as:

make linux+ssl KFLAGS=-UCK_SSL

   Since DES is now considered harmful, Jeff Altman suggests that all
   OpenSSL builds, even for old versions, should omit it ("If you are
   building with openssl and no kerberos or srp, just disable DES.
   Disabling DES will impact telnet and rlogin but it won't matter if you
   have no ability to negotiate a session key").

   From Ian Beckwith, patches for Debian Linux:
     * Change all '-' to '\(hy' in man page (new pedantry): ckuker.nr.
     * Make IKSD authentication (using PAM) ask for a password when an
       invalid username has been given, to avoid disclosing which account
       names are valid: ckufio.c, ckuus7.c.
     * Fix spelling errors: ckcftp.c, ckuus2.c, ckuker.nr, ckcpro.w,
       ckuusr.h.
     * Patch makefile to support install to a staging area with DESTDIR.
     * Some other patches (mainly for typos) were for plain-text
       documentation files that were generated from Web pages; I updated
       the web pages.

   A big corporate C-Kermit user has an application where a local C-Kermit
   makes a connection to a remote one, uploads some files, and then if the
   server has any new patch files for the local, it sends the patches and
   does a REMOTE HOST command to run the patch program. This stopped
   working in C-Kermit 6.0 or 7.0 when I put a check to prevent it,
   because "it makes no sense to send REMOTE commands to the local end,
   because the results are sent back to the remote to be displayed on its
   screen but it has no screen". That may be true, but if the user needs
   to control the local from the remote, they should be able to. I removed
   the checks. This doesn't solve the problem of where the output goes;
   ideally it would go to the local screen but I don't see any elegant and
   simple way to make that change. However the output redirectors can
   still be used with the REMOTE command so the results can be captured to
   a remote file, which could then be sent. ckuus7.c, 7 Jun 2011.

   There were a couple reports of file corruption that I was saving for
   later. Now that now is later I dug up the messages, files, and logs and
   it turns out that nobody had reported a reproducible case of Kermit
   corrupting a file. There have been non-reproducible cases though,
   almost certainly due to corruption of the S or I packet or its ACK,
   which is why we now have SET BLOCK 5. Even with BLOCK CHECK 5, there is
   no guarantee that the same thing won't happen, it is just far less
   likely. Even if we added a 32-bit CRC or even 64-bit one, there would
   still be a small chance it could happen.

   Replaced the very inadequate help texts for functions \fword() and
   \fsplit() with new ones. ckuus2.c, 6 Jun 2011.

   Autodownload didn't work when the S or I packet had a 3-byte block
   check because kstart() checked it for a 1-byte checksum. Fixed in
   kstart(), ckcfn2.c, 6 Jun 2011. However, older Kermit versions and
   programs that claim to do "autodownload" will never recognize this type
   of packet. No big deal since even if they did, the transfer would fail
   anyway.

   Added 'FORCE 3' to E-Kermit, called it EK 1.7. The option is "-b 5".
   Works OK for sending and receiving, both with and without the new
   option. Also works with "-b 5" if you send an S packet to it with '5'
   in the BCT field. Changes were minimal, I have them all in ek17.diff.

   I could probably also make a new G-Kermit in about 10 minutes, but who
   cares about G-Kermit... We already have two useful Kermit programs that
   interoperate with the new protocol. 6 Jun 2011.

   So the various combinations should work as desired:

     * Sender and receiver both support and are told to SET BLOCK 5
       ("SB5").
     * Sender SB5, but receiver doesn't support it (errors out).
     * Sender SB5, receiver supports it but wasn't told (auto-recognizes
       it).
     * Receiver SB5 but sender no (errors out).

   Note in the last case, the receiver should NOT automatically fall back
   to standard behavior because if the user said SET BLOCK 5 that means
   every packet MUST be protected by CRC to prevent the I/S packets from
   being corrupted.

   Installed new HELP SET BLOCK-CHECK text. ckuus2.c, 5 Jun 2011.

   Now the question is: Can we make the file receiver automatically and
   safely recognize a three-byte block check on an incoming S or I packet?
   It's tricky because the block check field is not self-identified, it's
   just the last "n" characters of string indicated by the length field,
   so correct decoding of the packet depends on stateful knowledge of "n".
   How about this: rpack() already knows what type of packet it is, so if
   it's an S or I packet and the 8th byte of the data field is "5" and
   last 3 bytes, when interpreted as the CRC, match the packet contents,
   then we accept the packet and switch to BLOCK 5 mode.

   On the other hand, if the "5" was put there by corruption, the CRC
   should catch the error. In that case we NAK the packet and presumably
   get a different version back. There would be no reason to try to
   re-read the same packet with a different block check, because the "5"
   could not possibly be there legitimately unless it had a 3-byte CRC. To
   be clear, this is cheating. We read the packet contents before we know
   the packet is correct, then we check that it *is* correct. I made the
   4-line change to rpack() and it works OK in the absence of transmission
   errors. ckcfn2.c, 3 Jun 2011.

   Made the file receiver put "5" in the block-check-type in its ACK to
   the S-Packet. spar(): ckcfns.c, 5 Jun 2011.

   Added code to skip the heuristic that S and I packets always have block
   check type 1. File transfer OK between two C-Kermits with SET BLOCK 5.
   rpack(): ckcfn2.c, 5 Jun 2011.

   Added supporting code for SET BLOCK 5: ckcfn[23].c, ckcpro.w, ckcmai.c,
   ckuus3.c, 3 Jun 2011.

   For EM-APEX ocean floats project, where buoys in stormy waters have to
   transmit data through an earth satellite using non-error-correcting
   modems, John Dunlap ran exhaustive stress tests of Kermit protocol
   transfers through a simulated connection that injected errors and
   delays and identified a weakness in Kermit protocol when it is used
   under extremely bad conditions: If a data byte of the S packet (or its
   Ack) is corrupted and the 1-byte checksum is also corrupted in such a
   way that that the checksum matches the corrupted data, the two Kermit
   programs will disagree as to the negotiated parameters. For example, if
   file Sender's RPT field is changed from '~' to '^', the receiver will
   decode the packet incorrectly. Ditto for most of the other parameters.
   The result is that a corrupted file is received but reported correct.
   John suggested a new mode of operation in which the Type 3 block check
   is used for all packets. Such a mode can not be negotiated because the
   negotiation packet itself is assumed by all Kermit programs to have a
   1-byte checksum. Added SET BLOCK-CHECK 5 to the parser (with invisible
   synonym FORCE-3". ckuus3.c, 3 Jun 2011.

   The SET BLOCK CHECK command did not parse all the items in its keyword
   list. Fixed in ckuus3.c, 3 Jun 2011.

   Most combinations work OK, but not translating Cyrillic text from UTF-8
   to Latin/Cyrillic, and probably the same would be true for any case of
   converting from UTF-8 or UCS-2 to anything else. The problem was in
   xgnbyte(), which converts the input stream from the specified character
   to UCS2; it needed to make a special case for when the input file was
   already Unicode. Believe it or not, this problem occurred at least as
   far back as 8.0.201 (9.5 years ago) and nobody noticed. So if the fix
   isn't perfect probably nobody will notice that either. ckcfns.c, 3 Jun
   2011.

   When I added MIME synonyms for Kermit character-set names, I left a
   bogus entry in the tables ("windows-1251") that was in the wrong place
   alphabetically, thus preventing most references to file character-set
   names from working right. Removed the bogus entry. ckuxla.c, 2 Jun
   2011.

   Began converting C-Kermit to Open Source with the Simplified 3-Clause
   BSD license. Updated the text for the INTRO, LICENSE, NEWS, and SUPPORT
   commands. Fixed things so the copyright year to be displayed is defined
   in one place (ck_cryear in ckcmai.c), rather than hardwired into text
   strings all over the place. COPYING.TXT, ckcmai.c, ckuus[256].c, 2 Jun
   2011.

   cksplit() treats \ as a quoting character. If the source string
   contains backslashes, they are swallowed (or, if doubled, one is kept).
   That's not good for parsing external data, such as lines read from
   files, where there are no quoting rules. This came up when parsing CSV
   files; as a workaround, I made \fsplit() treat backslash as an ordinary
   character for CSV and TSV splitting (a better solution might be yet
   another argument that specifies a quote character). ckclib.c, 30 Dec
   2010.

   \fcontents(\&a[3]) got an error if the array was declared but its
   dimension was less than 3, which is bad when dealing with (say) an
   array created dynamically by \fsplit(), which might or might not have a
   third element. In case it doesn't -- i.e. in case we are referring to an
   out of range element of any array that is declared -- we should just
   return a null string, as we do with other types of variables that are
   not defined. For that matter, ditto even if the array is not declared;
   what useful purpose is served by throwing an error in this case?
   ckuus4.c, 30 Dec 2010.

    Alpha.09

   A couple minor changes to the tru64-51b makefile targets from Steven
   Schweda but there still are some problems with the Tru64 Unix builds.
   makefile, 21 Sep 2010.

   The Solaris target checked the OpenSSL version automatically to set the
   right flag, the Linux target didn't. Put the OpenSSL-version testing
   code in the Linux target too. makefile, 21 Sep 2010.

   Testing this in Solaris 9 I see that the DES library disappeared. Added
   code to the solaris9 targets (also used by Solaris 10 and 11) to check
   for this. makefile, 21 Sep 2010.

   From Gary Mills at the U of Manitoba: convert Solaris version from BSD
   ptys to streams ptys because there are only 48 BSD-style ptys and he
   was running out. No code changes needed, the only change necessary was
   to add the following flags to the makefile target:

-DHAVE_STREAMS -DHAVE_GRANTPT -DHAVE_PTSNAME
  -DPUSH_PTEM -DPUSH_LDTERM -DPUSH_TTCOMPAT

   makefile, ckcmai.c, 21 Sep 2010.

    Alpha.08

   From Joop Boonen 26 Juli 2010: "Added HAVE_LOCKDEV as openSuSE >= 11.3
   uses lockdev but not baudboy. They use ttylock directly. The program
   code has been added so the program works without a problem." makefile,
   ckcdeb.h, ckutio.c, ckuus5.c, 23 Aug 2010.

   The CSV feature of \fsplit() splits a comma-separated list into an
   array. To turn the array back into a comma separated list,
   \fjoin(&a,\44,1) almost works, except for elements contain literal
   doublequotes, such as:

Mohammad "The Greatest" Ali

   This calls for making a symbolic CSV argument for \fjoin() like the one
   that was made for \fsplit(): \fjoin(&a,CSV). Also \fjoin(&a,TSV) for
   Tab-separated list. Thus if Kermit reads a record in CSV format, splits
   it into an array, and then joins the array back into a CSV record, the
   result will be equivalent to the original, according to the CSV
   definition. It might not be identical, because if the result had
   extraneous spaces before or after the separating commas, these are
   discarded, but that does not affect the elements themselves.
   Furthermore it is now possible to convert a comma-separated list into a
   tab-separated list, and vice versa (which is not a simple matter of
   changing commas to tabs or vice versa). ckuus4.c, 12 Aug 2010.

    Alpha.07

   The CSV feature of Alpha.06 had a subtle flaw, namely that if the last
   item in a comma separated list was enclosed within doublequotes with a
   trailing space after the closing doublequote, a spurious empty final
   element would be created in the result array. Fixed in cksplit(),
   ckclib.c, 5 Aug 2010.

   Added \fstrcmp(s1,s2,case,start,length), which has the advantage over
   IF EQU,LGT,LLT that case sensitivity can be specified as a function
   arg, and also substrings can be specified. ckuusr.h, ckuus[24].c, 5 Aug
   2010.

   If only one file is FOPEN'd, FCLOSE given with no arguments would close
   it. Turns out to be a bad idea. Example: program with an input and
   output file, try to close the output file before it is opened by just
   typing FCLOSE; this can mess up the input file. For safety FCLOSE has
   to require a channel number or ALL. ckuus7.c, 4 Aug 2010.

   Peter Eichhorn reported that "RENAME ../x ." didn't work. This is a
   side effect of the changes of 2006 to the RENAME command, there was a
   little confusion in the renameone() routine; fixed in ckuus6.c, 4 Aug
   2010.

   From Lewis McCarthy:

  Based on code inspection, C-Kermit appears to have an SSL-related security
  vulnerability analogous to that identified as CVE-2009-3767 (see e.g.
   [218]http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-3767).

  I'm attaching a patch for this issue relative to the revision of ck_ssl.c
  obtained from a copy of  [219]https://www.columbia.edu/kermit/ftp/test/tar/x.z
ip
  downloaded on 2010/07/30, which I believe is the latest.

  When this flaw was first widely publicized at last year's Black Hat
  conference, it was claimed that some public certificate authorities had
  indeed issued certificates that could be used to exploit this class of
  vulnerability. As far as I know they have not revealed specifically which
  public CA(s) had been found issuing such certificates.
  Some references:  [220]http://www.mseclab.com/?p=180
   [221]http://www.theregister.co.uk/2009/07/30/universal_ssl_certificate/

   Patches added to ck_ssl.c, 4 Aug 2010.

   John Dunlap, running days-long stress tests between E-Kermit and
   C-Kermit, found a bug in the packet-reading and -decoding code: If a
   NAK packet arrives with its length field corrupted to indicate a bigger
   size, and there are enough bytes following in the pipeline, ttinl()
   will return a too-long packet (if there are not enough bytes waiting to
   be read, then ttinl() will properly time out). In the bad case rpack()
   trusts the packet length, uses it as the basis for computation of the
   block-check length, which is then used to access memory that might not
   be there, causing (at least on John's Linux system) a segmentation
   fault. John added the normal clause to check the result of the
   block-check calculation, and I changed ttinl() to always break on the
   eol character (normally carriage return), since this can never appear
   in a packet, even if we "set control unprefix all". Also added a check
   to ttinl() to protect against length fields corrupted into illegal
   values. ckcfn2.c, ckutio.c, 13 Apr 2010.

   Changing VNAML from 4K to 16K broke the build on HP-UX 9. Put it back
   to 4K. 9 Apr 2010.

   VMS changes from SMS. They build OK, Kermit file transfers are still
   OK, but FTP text-mode GETs always hang on the 10th 8K network read.
   Couldn't get a debug log this time. ckcmai.c, ckvfio.c, ckvrms.h,
   ckvker.com. 8 Apr 2010.

    C-Kermit 9.0 Alpha.06

   Implemented a new \fsplit() option for parsing CSV files, which turns
   out to be a little complicated, because the separator is not just a
   comma, but a comma and all its surrounding spaces. Also there are
   special quoting rules for fields with embedded commas and fields with
   embedded quotes. ckclib.c, 7 Apr 2010.

   Increased maximum variable name length from 4K to 16K. Verified that
   too-long names are caught and recovered from correctly. ckuusr.h, 6 Apr
   2010.

    C-Kermit 9.0 Alpha.05

   Did a few builds to make sure there were no booboos. Solaris 9, NetBSD
   5.01, Linux RHEL4, HP-UX 10.20 (non-ANSI compiler and ANSI optimizing
   compiler), Mac OS X 10.4.11, SCO OSR 6.00. 5 Apr 2010.

   Added \fstringtype() function. Given a string argument, it tells
   whether the string is 7bit, 8bit, utf8, binary, etc. ckuusr.h,
   ckuus[4x].c, 2 Apr 2010.

   Changed the IF command to accept a bare macro name its condition. This
   will parse and execute correctly if the macro is defined and if it has
   a numeric value, or if it is not defined, in which case it evaluates to
   0 (FALSE). If it is defined but has a non-numeric value, a parse error
   occurs. ckuus6.c, 2 Apr 2010.

   Added MIME character-set names as invisible synonyms in the file and
   terminal character-set tables, fcstab[] and tcstab[]. Note that not all
   the character sets known to Kermit are registered in MIME. But at least
   now MIME-registered character sets can be referred to by their MIME
   names, e.g. ISO-8859-1, ISO646-ES, IBM437, WINDOWS-1252. These are not
   listed if you type ? in a field that is parsing them, unless you type a
   letter first, e.g. "i?" lists ISO- and IBM set names. Later maybe I'll
   make parallel tables, or keyword attribute bit that says whether a name
   is MIME or not. The real benefit of this change is that now Kermit can
   take its character-set names from external sources like email headers
   or web logs. ckuxla.c, 1 Apr 2010.

   Build on Solaris 11 for the first time. Had to adjust ckuver.h to get
   the version herald right. This was on a box that reported its
   architecture as i86pc. 1 Apr 2010.

   Richard Nolde reports that Kermit can't find -lpam on Fedora 12 because
   it's in /lib rather than /usr/lib. RHEL5 has symlinks, FC12 should too.
   Added a note to the makefile. 1 Apr 2010.

   Added a new function \fdecodehex(string,prefix) that decodes a string
   containing prefixed hex bytes. Default prefix is %%, but any prefix of
   one of two chars (such as % or 0x) can be specified. ckuusr.h,
   ckclib.h, ckclib.c, ckuusr.c, 31 Mar 2010.

   Added a new function \fcvtcsets(string,cset1,cset1) that converts a
   string from one character set to another. The csets are File
   Character-Set names. ckuus4.c, 31 Mar 2010.

   A fix to Trusted HP-UX makefile target from PeterE, to account for the
   equivalence of +openssl and +ssl as target suffixes. 30 Mar 2010.

   Fixed mistaken extern declarations of krb4_errno and krb5_errno as
   strings in nvlook(); they are ints. Built OK on Mac OS X 10.6.3.
   ckuus4.c, 30 Mar 2010.

   The change I made to allow CONNECT to reestablish a previous SSH
   connection prevented a new SSH connection to a different host to be
   made. Fixed in ckuus7.c, 30 Mar 2010.

   Changed VOID and CKVOID definition to be 'void' for all HP-UX (verified
   by PeterE back to HP-UX 6.5, 1989). Still need to check this on HP-UX
   5.21; if that's an exception it can be done in the makefile. ckcdeb.h,
   30 Mar 2010.

   Yesterday's VOID redefinition caused problems for HP-UX in ckuusx.c, in
   the curses section where VOID is undef'd and not used to avoid a
   conflict with curses.h. As a workaround I defined a new macro CKVOID
   with the same definition as VOID and used it in the offending section
   of ckuusx. The real solution is to replace all references to VOID with
   CKVOID (since VOID is increasingly likely to cause conflicts), but a
   mass search and replace is not without risks. ckcdeb.h, ckuusx.c, 30
   Mar 2010.

    C-Kermit 9.0 Alpha.04

11:23:10.722 ftp_hookup[kermit.columbia.edu]=21
11:23:10.722 ftp hookup A[kermit.columbia.edu]
11:23:10.722 ftp hookup C[kermit.columbia.edu]
11:23:10.722 ftp hookup socket=4
11:23:10.722 ftp hookup HADDRLIST
11:23:10.723 ftp hookup connect failed=13
11:23:10.723 ftp hookup bad

   13 = Permission denied:

[EACCESS] Search permission is denied for a component of the path prefix;
  or write access to the named socket is denied.

   On Gentoo Linux, also on Alpha, the errno is 51: Network is
   unreachable. Clearly some data type in the sockets structs is out of
   whack.

   The third connect() argument is "address length". The address is a
   struct sockaddr. About the third argument, RHEL5 "man connect" says:

  The third argument of connect() is in reality an int (and this is what
  4.x BSD and libc4 and libc5 have).  Some POSIX confusion resulted in
  the present socklen_t, also used by glibc.  See also accept(2).

   Building on RHEL5 on x86_64, where size_t is 8 and socklen_t is 4, I
   get a warning:

ckcftp.c: In function 'ftp_hookup':
ckcftp.c:14667: warning:
  comparison is always true due to limited range of data

   Referring to:

if (hisctladdr.sin_addr.s_addr != (unsigned long) -1)

   This seems to be the problem; if I remove the (unsigned long) cast (in
   two places), the problem goes away. Actually what I should be comparing
   it with is INADDR_NONE, which is defined appropriately in some header
   file, e.g. as 0xffffffff. Also I define it explicitly as -1 if it is
   not defined in any header file (as is the case in Solaris 9). Tested OK
   on 64-bit RHEL5, 32-bit RHEL5, Digital Unix 4.0E 64-bit, Solaris 9
   32-bit, Mac OS X 10.4.11 32-bit, Mac OS X 10.6.3 64-bit, AIX 5.3,
   Gentoo Linux 2.6.31 on Alpha 64-bit, NetBSD 5.0.1 32-bit.... ckcftp.c,
   29 Mar 2010.

   connect(s, (struct sockaddr *)&hisctladdr, sizeof (hisctladdr)): In
   FTP, this doesn't work on RHEL5 / Mac OX X 6.1/2 64-bit. But the
   connect() in Telnet works. On Mac OS X 6.2 I tried changing the
   socket() call to be like the one in ckcnet.c for Telnet, but it made no
   difference. On a RHEL5.4 system on i386, FTP works fine, so it's not
   the Red Hat version. On Digital Unix 4.0E 64-bit, same thing:

   There are various warnings in the SSL code in ckutio.c, ckcftp.c, and
   ckcnet.c about pointers not being assignment compatible, but I have
   learned from experience not to try to fix these (see notes from 6 Oct
   2009). 29 Mar 2010.

   "make hpux1000o+ssl" files with: /usr/ccs/bin/ld: Unsatisfied symbols:

__umoddi3 (code)
__udivdi3 (code)
__eprintf (code)

   It appears that OpenSSL (0.9.7c in this case) requires -lgcc. And
   indeed hpux1000gcc+ssl builds fine. 29 Mar 2010.

   Ditto in tls_load_certs(). ck_ssl.c, 29 Mar 2010.

   Fixed a typo in a debug() statement in cksplit() that was causing some
   warnings. ckclib.c, 29 Mar 2010.

   In HP-UX with the bundled-non ANSI compiler, we get warnings about
   functions such as endusershell(), which are declared void in the header
   files. But in non-ANSI builds we defind VOID to be int rather than
   void, so our prototypes are wrong. I checked that HP-UX 9, 10, and 11
   all have void datatype and changed the definition of VOID to void in
   those cases. ckcdeb.h, 29 Mar 2010.

    C-Kermit 9.0 Alpha.03

   Changed hexdump() to ckhexdump() in ck_crp.c, which I missed before. 19
   Mar 2010.

   Built OK on VMS 6.2 and 8.3 with and without networking. Large file
   support included automatically in VMS 8.3 FTP client included
   automatically in both network builds. 19 Mar 2010.

   From SMS: updated dependencies in CKVKER.COM, fix the "don't reinclude
   me" clause in CKVRTL.H. 19 Mar 2010.

   Changed VMS build procedure to include the FTP client in any network
   build by default. Changed the sense of the I option to exclude the FTP
   client, in case anybody would want to do that. ckvker.com, 18 Mar 2010.

   Changed the VMS build procedure to enable large file support
   automatically for non-VAX and VMS 7.3 or greater. No reason not to
   include this feature. Changed the sense of the F option to DISABLE
   large file support in the unlikely case that C-Kermit is being built on
   a suitable platform but the C library is older than VMS73_ACRTL-V0200,
   in which case fseeko() and ftello() will come up missing at link time.
   ckvker.com, 18 Mar 2010.

   From SMS: #include <types.h> earlier for VMS in ckcdeb.h to pick up
   off_t before it is referenced. This allows C-Kermit to compile on
   VMS/Alpha 6.2 but linking fails on fseeko() and ftello() (and yet, a
   functional executable is created, and FSEEK works right). Builds the
   same way with no problems at all on VMS 8.3 / Alpha. In this case we
   get the full 64-bit arithmetic... Well, 62 bits:

ATLAS::C-Kermit>( ^ 2 63)
   9223372036854775000.0
ATLAS::C-Kermit>( ^ 2 62)
   4611686018427387904

   whereas on VMS 6.2 we get integers only up to (^ 2 30). 17 Mar 2010.

   From SMS: Corrections to my merging of SMS's changes, ckcftp.c,
   ckvrtl.h. Builds OK on VMS 6.2 now. Also did an SSL build on VMS 8.3
   with OpenSSL m0.9.7e and "OPENSSL_DISABLE_OLD_DES_SUPPORT" was included
   in P3 automatically by Martin V's addition to ckvker.com. 17 Mar 2010.

   To go with MESSAGE and SET DEBUG MESSAGE, I added IF DEBUG, which is
   true if SET DEBUG MESSAGE is not OFF and false otherwise. ckuusr.h,
   ckuus6.c, 16 Mar 2010.

   Tried again to build Digital Unix Tru64 4.0E using "make tru64-40e",
   but something prevents it from picking up the termios symbols and it
   blows up in ckutio.c, whereas this used to work in earlier C-Kermit
   versions. This is the only Tru64 system I still have access to, so I
   can't tell if it's a local peculiarity or what. Note that POSIX is not
   defined for this build. But if I define it, I get into trouble with
   "struct timeval". Tried again with "KFLAGS=-DPOSIX -DNOTIMEVAL" but
   that doesn't help. Tried "make dec-osf" and that worked OK but oddly
   enough it makes a Kermit with less features than "make osf". 16 Mar
   2010.

   Built OK on Digital Unix Tru-64 4.0E using "make osf", 16 Mar 2010.

   FreeBSD 8.0 <libutil.h> has a hexdump() prototype that conflicts with
   the hexdump macro defined in ckcdeb.h. Since the same thing is likely
   to happen elsewhere, I changed the Kermit macro to ckhexdump as well
   all references to it: ckcdeb.h, ckcftp.c, ckcnet.c, ckctel.c, ckuath.c,
   ckutio.c, 16 Mar 2010.

   More from SMS for VMS, 16 Mar 2010:
     * Set MAXPATH correctly for VMS, ckcdeb.h.
     * NAM -> NAML, QIO replaces system( "SET PROTECTION"), bugfixes in
       cvtdir() and nzltor(), ... (See comments): ckvfio.c, new ckvrms.h.
       (The RMS code in ckvfio.c was almost totally rewritten)
     * Moved "NAMX$*" (and related) macros to ckvrms.h, and renamed to
       "NAMX_*" (and similar "$" -> "_"), moved "FIB_*" macros from
       ckvrtl.c.

   These changes are mainly to accommodate the ODS5 file system, which has
   longer and mixed-case filenames, and also to execute certain commands
   (e.g. for setting file protection, deleting directories) directly
   instead of using a system() command.

   Built OK on VMS 8.3 (with and without network support). 16 Mar 2010.

   Failed to build on VMS 6.2. 16 Mar 2010.

   Not so good on VMS, turns out I made a typo in one of the VMS updates
   (#ifndef OLDIP instead of #ifdef...). ckcnet.c, 16 Mar 2010.

   Built OK on Solaris9, Mac OS X 10.4.11, RHEL4 (32-bit), RHEL5 (64-bit),
   AIX 5.3, SCO OpenServr 6.0.0... 15 Mar 2010.

   Exposed inesc[] and oldesc[] for VMS, so new INPUT command
   escape-sequence stripping can work (really, chkaes() and related global
   variables should be moved out of ck[uvd]con.c/ckucns.c and into a
   common module; do that later). ckuusr.h, ckvcon.c, 15 Mar 2010.

   From SMS for VMS: 'Added/documented P3 options INTSELECT, OLDFIB,
   OLDIP. Disabled (commented out) automatic definition of NOSETTIME for
   VMS before V7.2 (vms_ver .lts. "VMS_V72").' ckcdeb.h, ckcftp.c,
   ckcnet.c, ckuus[2567].c, ckvfio.c, ckvker.com, ckvrtl.[ch], 15 Mar
   2010.

   Also for debugging and error messages, I added \v(lastcommmand) so that
   the command that failed can be included in an IF FAIL or DEBUG error
   message. This works even for commands that have syntax errors.
   ckuusr.h, ckuus5.c, ckucmd.c, 12 Mar 2010.

   There has never been a clean way to put debugging messages (ECHO
   commands) in a script which are executed only if debugging is desired
   and ignored otherwise. You'd have to set a random variable and test it,
   or define a macro or whatever. To make this more straightforward, I
   added SET DEBUG MESSAGE ON/OFF/STDERR, and added a new MESSAGE (syn:
   MSG) command for printing debugging messages to stdout if SET DEBUG
   MESSAGE is ON or to stderr if SET DEBUG MESSAGE is STDERR. ckcmai.c,
   ckuus[r23].c, 12 Mar 2010.

   Peter Eichhorn complained that if you make an ssh connection with
   Kermit, then log out from the ssh host, and then use a "connect"
   command to make a new connection to the same host (which you can do
   with Telnet), Kermit says (e.g.):

 DNS Lookup... Can't get address for ssh -e none somehostname
 Sorry, can't open ssh -e none somehostname: Error 0

   I added code to detect and handle this case and it seems to work OK,
   even though it's kind of a hack. ckuusr.[ch], ckuus7.c, 1 Mar 2010.

   Added code to INPUT command to strip ANSI escape sequences. It's
   activated by SET SESSION-LOG TEXT. ckuusr.h: added prototype for
   chkaes(); ckucon.c, ckucns.c: made inesc[] and oldesc[] global instead
   of static; ckuus4.c: doinput() code for skipping escape sequences. 1
   Mar 2010.

   From Martin Vorlaender: new code in VMS C-Kermit build procedure to
   detect OpenSSL version automatically. ckvker.com, 22 Feb 2010.

   Moved the #include "ckvrtl.h" in the FTP module to below the include
   for utime.h, because building the VMS version with the 'i' option
   (meaning "include internal ftp client") results in "struct utimbuf tp"
   erroring out because struct utimbuf is not defined yet (at least in
   some version of VMS with some version of C). From Rob Brown, ckcftp.c,
   20 Feb 2010.

   Added note to CKVKER.COM to the effect the 'f' option has no effect on
   VAX architecture. 15 Feb 2010.

   Tried to build on a real VAX-11/785 but the machine seems to be
   seriously wedged. 12-15 Feb 2010.

   Built on VMS E8.4. 12 Feb 2010.

   In ckupty.h, make the #include <sys/ioctl.h> be #ifndef SUNOS41. From
   Christian Corti. 10 Feb 2010.

   Added an aixg target to build on AIX with gcc when gcc is not installed
